/* FlickrPublishingAuthenticator.c generated by valac 0.56.3, the Vala compiler
 * generated from FlickrPublishingAuthenticator.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "shotwell-plugin-common.h"
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include <libsoup/soup.h>
#include <gio/gio.h>
#include "shotwell-plugin-dev-1.0.h"
#include "shotwell-authenticator.h"

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ENDPOINT_URL "https://api.flickr.com/services/rest"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_EXPIRED_SESSION_ERROR_CODE "98"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_KEY "60dd96d4a2ad04888b09c9e18d82c26f"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_SECRET "d0960565e03547c1"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_WELCOME_MESSAGE _ ("You are not currently logged into Flickr.\n" \
"\n" \
"Click Log in to log into Flickr in your Web browser. You will have to " \
"authorize Shotwell Connect to link to your Flickr account.")
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_DISCLAIMER "<b>This product uses the Flickr API but is not endorsed or certified b" \
"y SmugMug, Inc.</b>"
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_LOGIN_URI "https://www.flickr.com/services/oauth/authorize?oauth_token=%s&perms=w" \
"rite"

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION (publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_AUTHENTICATION_REQUEST_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_AUTHENTICATION_REQUEST_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_AUTHENTICATION_REQUEST_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass))

typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction;
typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass;
typedef struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate;

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION (publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_ACCESS_TOKEN_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_ACCESS_TOKEN_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_ACCESS_TOKEN_FETCH_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass))

typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction;
typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass;
typedef struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE (publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass))

typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPane PublishingAuthenticatorShotwellFlickrWebAuthenticationPane;
typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass;
typedef struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate;
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_0_PROPERTY,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_PROPERTIES
};
static GParamSpec* publishing_authenticator_shotwell_flickr_web_authentication_pane_properties[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_SIGNALS
};
static guint publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_NUM_SIGNALS] = {0};

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR (publishing_authenticator_shotwell_oauth1_authenticator_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1AuthenticatorClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_IS_AUTHENTICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_IS_AUTHENTICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_AUTHENTICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1AuthenticatorClass))

typedef struct _PublishingAuthenticatorShotwellOAuth1Authenticator PublishingAuthenticatorShotwellOAuth1Authenticator;
typedef struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorClass PublishingAuthenticatorShotwellOAuth1AuthenticatorClass;
typedef struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate;

#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR (publishing_authenticator_shotwell_flickr_flickr_get_type ())
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickrClass))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR))
#define PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickrClass))

typedef struct _PublishingAuthenticatorShotwellFlickrFlickr PublishingAuthenticatorShotwellFlickrFlickr;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrClass PublishingAuthenticatorShotwellFlickrFlickrClass;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrPrivate PublishingAuthenticatorShotwellFlickrFlickrPrivate;
enum  {
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_0_PROPERTY,
	PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_NUM_PROPERTIES
};
static GParamSpec* publishing_authenticator_shotwell_flickr_flickr_properties[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_FLICKR_NUM_PROPERTIES];
#define _publishing_rest_support_transaction_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_transaction_unref (var), NULL)))
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData;
typedef struct _PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData;

struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction {
	PublishingRESTSupportOAuth1Transaction parent_instance;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass {
	PublishingRESTSupportOAuth1TransactionClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction {
	PublishingRESTSupportOAuth1Transaction parent_instance;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass {
	PublishingRESTSupportOAuth1TransactionClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPane {
	ShotwellPluginsCommonWebAuthenticationPane parent_instance;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass {
	ShotwellPluginsCommonWebAuthenticationPaneClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate {
	gchar* auth_code;
};

struct _PublishingAuthenticatorShotwellOAuth1Authenticator {
	GObject parent_instance;
	PublishingAuthenticatorShotwellOAuth1AuthenticatorPrivate * priv;
	GHashTable* params;
	PublishingRESTSupportOAuth1Session* session;
	SpitPublishingPluginHost* host;
};

struct _PublishingAuthenticatorShotwellOAuth1AuthenticatorClass {
	GObjectClass parent_class;
	void (*authenticate) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	gboolean (*can_logout) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*logout) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*refresh) (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
	void (*set_accountname) (PublishingAuthenticatorShotwellOAuth1Authenticator* self, const gchar* name);
};

struct _PublishingAuthenticatorShotwellFlickrFlickr {
	PublishingAuthenticatorShotwellOAuth1Authenticator parent_instance;
	PublishingAuthenticatorShotwellFlickrFlickrPrivate * priv;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrClass {
	PublishingAuthenticatorShotwellOAuth1AuthenticatorClass parent_class;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrPrivate {
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* pane;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingAuthenticatorShotwellFlickrFlickr* self;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* txn;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* err;
	SpitPublishingPluginHost* _tmp8_;
	GError* _tmp9_;
	GError* _inner_error0_;
};

struct _PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingAuthenticatorShotwellFlickrFlickr* self;
	gchar* pin;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* txn;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* err;
	SpitPublishingPluginHost* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

static gpointer publishing_authenticator_shotwell_flickr_authentication_request_transaction_parent_class = NULL;
static gpointer publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_parent_class = NULL;
static gint PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset;
static gpointer publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class = NULL;
static gint PublishingAuthenticatorShotwellFlickrFlickr_private_offset;
static gpointer publishing_authenticator_shotwell_flickr_flickr_parent_class = NULL;

VALA_EXTERN GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (PublishingRESTSupportOAuth1Session* session);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (GType object_type,
                                                                                                                                                              PublishingRESTSupportOAuth1Session* session);
static GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                                                                                                               const gchar* user_verifier);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (GType object_type,
                                                                                                                                                     PublishingRESTSupportOAuth1Session* session,
                                                                                                                                                     const gchar* user_verifier);
static GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* publishing_authenticator_shotwell_flickr_web_authentication_pane_new (const gchar* token);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (GType object_type,
                                                                                                                                        const gchar* token);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed (GObject* base);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self,
                                                                                                   WebKitURISchemeRequest* request);
static void _publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback (WebKitURISchemeRequest* request,
                                                                                                                                        gpointer self);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load (ShotwellPluginsCommonWebAuthenticationPane* base);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
static void publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize (GObject * obj);
static GType publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once (void);
VALA_EXTERN GType publishing_authenticator_shotwell_oauth1_authenticator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType publishing_authenticator_shotwell_flickr_flickr_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gboolean publishing_authenticator_shotwell_oauth1_authenticator_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrFlickr* publishing_authenticator_shotwell_flickr_flickr_new (SpitPublishingPluginHost* host);
VALA_EXTERN PublishingAuthenticatorShotwellFlickrFlickr* publishing_authenticator_shotwell_flickr_flickr_construct (GType object_type,
                                                                                                        SpitPublishingPluginHost* host);
VALA_EXTERN PublishingAuthenticatorShotwellOAuth1Authenticator* publishing_authenticator_shotwell_oauth1_authenticator_construct (GType object_type,
                                                                                                                      const gchar* service,
                                                                                                                      const gchar* api_key,
                                                                                                                      const gchar* api_secret,
                                                                                                                      SpitPublishingPluginHost* host);
static void publishing_authenticator_shotwell_flickr_flickr_real_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
VALA_EXTERN gboolean publishing_authenticator_shotwell_oauth1_authenticator_is_persistent_session_valid (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token_secret (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
VALA_EXTERN gchar* publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_username (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
static void publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (PublishingAuthenticatorShotwellFlickrFlickr* self);
static gboolean publishing_authenticator_shotwell_flickr_flickr_real_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
static void publishing_authenticator_shotwell_flickr_flickr_real_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
VALA_EXTERN void publishing_authenticator_shotwell_oauth1_authenticator_invalidate_persistent_session (PublishingAuthenticatorShotwellOAuth1Authenticator* self);
static void publishing_authenticator_shotwell_flickr_flickr_real_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* base);
static void publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked (PublishingAuthenticatorShotwellFlickrFlickr* self);
static void _publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback (gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                GAsyncReadyCallback _callback_,
                                                                                                gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                       GAsyncResult* _res_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free (gpointer _data);
static gboolean publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready (GObject* source_object,
                                                                                                      GAsyncResult* _res_,
                                                                                                      gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                            const gchar* response);
static void publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                        const gchar* token,
                                                                                        const gchar* token_secret);
static void publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                            const gchar* token);
static void __lambda4_ (PublishingAuthenticatorShotwellFlickrFlickr* self,
                 const gchar* pin);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                    const gchar* pin,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                           GAsyncResult* _res_);
static void ___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                              const gchar* auth_code,
                                                                                              gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_on_web_login_error (PublishingAuthenticatorShotwellFlickrFlickr* self);
static void _publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                                                                                 gpointer self);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free (gpointer _data);
static gboolean publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready (GObject* source_object,
                                                                          GAsyncResult* _res_,
                                                                          gpointer _user_data_);
static void publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                        const gchar* response);
static void publishing_authenticator_shotwell_flickr_flickr_finalize (GObject * obj);
static GType publishing_authenticator_shotwell_flickr_flickr_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*
publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (GType object_type,
                                                                                       PublishingRESTSupportOAuth1Session* session)
{
	PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction* self = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
	self = (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*) publishing_rest_support_oauth1_transaction_construct_with_uri (object_type, session, "https://www.flickr.com/services/oauth/request_token", PUBLISHING_REST_SUPPORT_HTTP_METHOD_GET);
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_callback", "shotwell-auth://local-callback");
	return self;
}

PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction*
publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (PublishingRESTSupportOAuth1Session* session)
{
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_AUTHENTICATION_REQUEST_TRANSACTION, session);
}

static void
publishing_authenticator_shotwell_flickr_authentication_request_transaction_class_init (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass * klass,
                                                                                        gpointer klass_data)
{
	publishing_authenticator_shotwell_flickr_authentication_request_transaction_parent_class = g_type_class_peek_parent (klass);
}

static void
publishing_authenticator_shotwell_flickr_authentication_request_transaction_instance_init (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction * self,
                                                                                           gpointer klass)
{
}

static GType
publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_authentication_request_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_authentication_request_transaction_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
	publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, "PublishingAuthenticatorShotwellFlickrAuthenticationRequestTransaction", &g_define_type_info, 0);
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
}

GType
publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id;
		publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id = publishing_authenticator_shotwell_flickr_authentication_request_transaction_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once, publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id);
	}
	return publishing_authenticator_shotwell_flickr_authentication_request_transaction_type_id__once;
}

PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (GType object_type,
                                                                                   PublishingRESTSupportOAuth1Session* session,
                                                                                   const gchar* user_verifier)
{
	PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
	g_return_val_if_fail (user_verifier != NULL, NULL);
	self = (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*) publishing_rest_support_oauth1_transaction_construct_with_uri (object_type, session, "https://www.flickr.com/services/oauth/access_token", PUBLISHING_REST_SUPPORT_HTTP_METHOD_GET);
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_verifier", user_verifier);
	_tmp0_ = publishing_rest_support_oauth1_session_get_request_phase_token (session);
	_tmp1_ = _tmp0_;
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_token", _tmp1_);
	_g_free0 (_tmp1_);
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "oauth_callback", "shotwell-auth://local-callback");
	return self;
}

PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction*
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                                             const gchar* user_verifier)
{
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_ACCESS_TOKEN_FETCH_TRANSACTION, session, user_verifier);
}

static void
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_class_init (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass * klass,
                                                                                    gpointer klass_data)
{
	publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_parent_class = g_type_class_peek_parent (klass);
}

static void
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_instance_init (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction * self,
                                                                                       gpointer klass)
{
}

static GType
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
	publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, "PublishingAuthenticatorShotwellFlickrAccessTokenFetchTransaction", &g_define_type_info, 0);
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
}

GType
publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id;
		publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id = publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once, publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id);
	}
	return publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_type_id__once;
}

static inline gpointer
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_instance_private (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset);
}

PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*
publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (GType object_type,
                                                                            const gchar* token)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (token != NULL, NULL);
	_tmp0_ = g_strdup_printf (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_LOGIN_URI, token);
	_tmp1_ = _tmp0_;
	self = (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*) g_object_new (object_type, "login-uri", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	return self;
}

PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*
publishing_authenticator_shotwell_flickr_web_authentication_pane_new (const gchar* token)
{
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, token);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback (WebKitURISchemeRequest* request,
                                                                                                                                   gpointer self)
{
	publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb ((PublishingAuthenticatorShotwellFlickrWebAuthenticationPane*) self, request);
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed (GObject* base)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
	WebKitWebContext* ctx = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* _tmp1_;
	WebKitSecurityManager* mgr = NULL;
	WebKitSecurityManager* _tmp2_;
	WebKitSecurityManager* _tmp3_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane), G_TYPE_OBJECT, GObject));
	_tmp0_ = webkit_web_context_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	webkit_web_context_register_uri_scheme (ctx, "shotwell-auth", _publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb_web_kit_uri_scheme_request_callback, g_object_ref (self), g_object_unref);
	_tmp2_ = webkit_web_context_get_security_manager (ctx);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	mgr = _tmp3_;
	webkit_security_manager_register_uri_scheme_as_secure (mgr, "shotwell-auth");
	webkit_security_manager_register_uri_scheme_as_cors_enabled (mgr, "shotwell-auth");
	_g_object_unref0 (mgr);
	_g_object_unref0 (ctx);
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load (ShotwellPluginsCommonWebAuthenticationPane* base)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
	GError* _tmp0_;
	GError* _tmp1_;
	const gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
	_tmp0_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL], 0);
		return;
	}
	{
		GUri* uri = NULL;
		WebKitWebView* _tmp2_;
		WebKitWebView* _tmp3_;
		const gchar* _tmp4_;
		GUri* _tmp5_;
		GUri* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GUri* _tmp8_;
		const gchar* _tmp9_;
		_tmp2_ = shotwell_plugins_common_web_authentication_pane_get_view (G_TYPE_CHECK_INSTANCE_CAST (self, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
		_tmp3_ = _tmp2_;
		_tmp4_ = webkit_web_view_get_uri (_tmp3_);
		_tmp5_ = g_uri_parse (_tmp4_, G_URI_FLAGS_NONE, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp3_);
		uri = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp8_ = uri;
		_tmp9_ = g_uri_get_scheme (_tmp8_);
		if (g_strcmp0 (_tmp9_, "shotwell-auth") == 0) {
			const gchar* _tmp10_;
			_tmp10_ = self->priv->auth_code;
			_tmp7_ = _tmp10_ == NULL;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			GHashTable* form_data = NULL;
			GUri* _tmp11_;
			const gchar* _tmp12_;
			GHashTable* _tmp13_;
			GHashTable* _tmp14_;
			gconstpointer _tmp15_;
			gchar* _tmp16_;
			_tmp11_ = uri;
			_tmp12_ = g_uri_get_query (_tmp11_);
			_tmp13_ = soup_form_decode (_tmp12_);
			form_data = _tmp13_;
			_tmp14_ = form_data;
			_tmp15_ = g_hash_table_lookup (_tmp14_, "oauth_verifier");
			_tmp16_ = g_strdup ((const gchar*) _tmp15_);
			_g_free0 (self->priv->auth_code);
			self->priv->auth_code = _tmp16_;
			_g_hash_table_unref0 (form_data);
		}
		_g_uri_unref0 (uri);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL], 0);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp17_ = self->priv->auth_code;
	if (_tmp17_ != NULL) {
		const gchar* _tmp18_;
		_tmp18_ = self->priv->auth_code;
		g_signal_emit (self, publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL], 0, _tmp18_);
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (guint8));
	}
	return NULL;
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_on_shotwell_auth_request_cb (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* self,
                                                                                              WebKitURISchemeRequest* request)
{
	gchar* response = NULL;
	gchar* _tmp10_;
	GMemoryInputStream* mins = NULL;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp12_ = 0;
	guint8* _tmp13_;
	gint _tmp13__length1;
	guint8* _tmp14_;
	gint _tmp14__length1;
	GMemoryInputStream* _tmp15_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_WEB_AUTHENTICATION_PANE (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (request, webkit_uri_scheme_request_get_type ()));
	{
		GUri* uri = NULL;
		const gchar* _tmp0_;
		GUri* _tmp1_;
		GHashTable* form_data = NULL;
		const gchar* _tmp2_;
		GHashTable* _tmp3_;
		GHashTable* _tmp4_;
		gconstpointer _tmp5_;
		gchar* _tmp6_;
		_tmp0_ = webkit_uri_scheme_request_get_uri (request);
		_tmp1_ = g_uri_parse (_tmp0_, G_URI_FLAGS_NONE, &_inner_error0_);
		uri = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = g_uri_get_query (uri);
		_tmp3_ = soup_form_decode (_tmp2_);
		form_data = _tmp3_;
		_tmp4_ = form_data;
		_tmp5_ = g_hash_table_lookup (_tmp4_, "oauth_verifier");
		_tmp6_ = g_strdup ((const gchar*) _tmp5_);
		_g_free0 (self->priv->auth_code);
		self->priv->auth_code = _tmp6_;
		_g_hash_table_unref0 (form_data);
		_g_uri_unref0 (uri);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = webkit_uri_scheme_request_get_uri (request);
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_debug ("FlickrPublishingAuthenticator.vala:90: Failed to parse URI %s: %s", _tmp7_, _tmp9_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp10_ = g_strdup ("");
	response = _tmp10_;
	_tmp11_ = string_get_data (response, &_tmp12_);
	_tmp11__length1 = _tmp12_;
	_tmp13_ = _tmp11_;
	_tmp13__length1 = _tmp11__length1;
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup1 (_tmp13_, _tmp13__length1) : _tmp13_;
	_tmp14__length1 = _tmp13__length1;
	_tmp15_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp14_, _tmp14__length1, NULL);
	mins = _tmp15_;
	webkit_uri_scheme_request_finish (request, G_TYPE_CHECK_INSTANCE_CAST (mins, g_input_stream_get_type (), GInputStream), (gint64) -1, "text/plain");
	_g_object_unref0 (mins);
	_g_free0 (response);
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_class_init (PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass * klass,
                                                                             gpointer klass_data)
{
	publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) publishing_authenticator_shotwell_flickr_web_authentication_pane_real_constructed;
	((ShotwellPluginsCommonWebAuthenticationPaneClass *) klass)->on_page_load = (void (*) (ShotwellPluginsCommonWebAuthenticationPane*)) publishing_authenticator_shotwell_flickr_web_authentication_pane_real_on_page_load;
	G_OBJECT_CLASS (klass)->finalize = publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize;
	publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_AUTHORIZED_SIGNAL] = g_signal_new ("authorized", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	publishing_authenticator_shotwell_flickr_web_authentication_pane_signals[PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_WEB_AUTHENTICATION_PANE_ERROR_SIGNAL] = g_signal_new ("error", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_instance_init (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self,
                                                                                gpointer klass)
{
	self->priv = publishing_authenticator_shotwell_flickr_web_authentication_pane_get_instance_private (self);
	self->priv->auth_code = NULL;
}

static void
publishing_authenticator_shotwell_flickr_web_authentication_pane_finalize (GObject * obj)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_WEB_AUTHENTICATION_PANE, PublishingAuthenticatorShotwellFlickrWebAuthenticationPane);
	_g_free0 (self->priv->auth_code);
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_web_authentication_pane_parent_class)->finalize (obj);
}

static GType
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_web_authentication_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_web_authentication_pane_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
	publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id = g_type_register_static (SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, "PublishingAuthenticatorShotwellFlickrWebAuthenticationPane", &g_define_type_info, 0);
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane_private_offset = g_type_add_instance_private (publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id, sizeof (PublishingAuthenticatorShotwellFlickrWebAuthenticationPanePrivate));
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
}

GType
publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id;
		publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id = publishing_authenticator_shotwell_flickr_web_authentication_pane_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once, publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id);
	}
	return publishing_authenticator_shotwell_flickr_web_authentication_pane_type_id__once;
}

static inline gpointer
publishing_authenticator_shotwell_flickr_flickr_get_instance_private (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingAuthenticatorShotwellFlickrFlickr_private_offset);
}

PublishingAuthenticatorShotwellFlickrFlickr*
publishing_authenticator_shotwell_flickr_flickr_construct (GType object_type,
                                                           SpitPublishingPluginHost* host)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (host, SPIT_PUBLISHING_TYPE_PLUGIN_HOST), NULL);
	self = (PublishingAuthenticatorShotwellFlickrFlickr*) publishing_authenticator_shotwell_oauth1_authenticator_construct (object_type, "Flickr", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_KEY, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_API_SECRET, host);
	return self;
}

PublishingAuthenticatorShotwellFlickrFlickr*
publishing_authenticator_shotwell_flickr_flickr_new (SpitPublishingPluginHost* host)
{
	return publishing_authenticator_shotwell_flickr_flickr_construct (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, host);
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_authenticate (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
	if (publishing_authenticator_shotwell_oauth1_authenticator_is_persistent_session_valid (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator))) {
		PublishingRESTSupportOAuth1Session* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		g_debug ("FlickrPublishingAuthenticator.vala:108: attempt start: a persistent se" \
"ssion is available; using it");
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
		_tmp1_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
		_tmp2_ = _tmp1_;
		_tmp3_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_token_secret (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
		_tmp4_ = _tmp3_;
		_tmp5_ = publishing_authenticator_shotwell_oauth1_authenticator_get_persistent_access_phase_username (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
		_tmp6_ = _tmp5_;
		publishing_rest_support_oauth1_session_authenticate_from_persistent_credentials (_tmp0_, _tmp2_, _tmp4_, _tmp6_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
	} else {
		g_debug ("FlickrPublishingAuthenticator.vala:113: attempt start: no persistent s" \
"ession available; showing login welcome pane");
		publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (self);
	}
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_real_can_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	gboolean result;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
	result = TRUE;
	return result;
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_logout (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	PublishingRESTSupportOAuth1Session* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
	publishing_rest_support_oauth1_session_deauthenticate (_tmp0_);
	publishing_authenticator_shotwell_oauth1_authenticator_invalidate_persistent_session (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator));
}

static void
publishing_authenticator_shotwell_flickr_flickr_real_refresh (PublishingAuthenticatorShotwellOAuth1Authenticator* base)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
}

static void
_publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback (gpointer self)
{
	publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked ((PublishingAuthenticatorShotwellFlickrFlickr*) self);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_show_login_welcome_pane (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_debug ("FlickrPublishingAuthenticator.vala:132: ACTION: installing login welco" \
"me pane");
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	spit_publishing_plugin_host_set_service_locked (_tmp0_, FALSE);
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	_tmp2_ = g_strdup_printf ("%s\n\n%s", PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_WELCOME_MESSAGE, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_SERVICE_DISCLAIMER);
	_tmp3_ = _tmp2_;
	spit_publishing_plugin_host_install_welcome_pane (_tmp1_, _tmp3_, _publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked_spit_publishing_login_callback, self);
	_g_free0 (_tmp3_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_welcome_pane_login_clicked (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_debug ("FlickrPublishingAuthenticator.vala:139: EVENT: user clicked 'Login' bu" \
"tton in the welcome pane");
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (self, NULL, NULL);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free (gpointer _data)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData, _data_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                           GAsyncReadyCallback _callback_,
                                                                                           gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	PublishingAuthenticatorShotwellFlickrFlickr* _tmp0_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	_data_ = g_slice_new0 (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (_data_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                  GAsyncResult* _res_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready (GObject* source_object,
                                                                                                 GAsyncResult* _res_,
                                                                                                 gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (_data_);
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_co (PublishingAuthenticatorShotwellFlickrFlickrDoRunAuthenticationRequestTransactionData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_debug ("FlickrPublishingAuthenticator.vala:145: ACTION: running authentication" \
" request transaction");
	_data_->_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
	_data_->_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	spit_publishing_plugin_host_install_static_message_pane (_data_->_tmp1_, _ ("Preparing for login…"), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
	_data_->_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
	_data_->_tmp3_ = publishing_authenticator_shotwell_flickr_authentication_request_transaction_new (_data_->_tmp2_);
	_data_->txn = _data_->_tmp3_;
	{
		_data_->_state_ = 1;
		publishing_rest_support_transaction_execute_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_authenticator_shotwell_flickr_flickr_do_run_authentication_request_transaction_ready, _data_);
		return FALSE;
		_state_1:
		publishing_rest_support_transaction_execute_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
		_data_->_tmp5_ = _data_->_tmp4_;
		g_debug ("FlickrPublishingAuthenticator.vala:153: EVENT: OAuth authentication re" \
"quest transaction completed; response = '%s'", _data_->_tmp5_);
		_g_free0 (_data_->_tmp5_);
		_data_->_tmp6_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
		_data_->_tmp7_ = _data_->_tmp6_;
		publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (_data_->self, _data_->_tmp7_);
		_g_free0 (_data_->_tmp7_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->err = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		g_debug ("FlickrPublishingAuthenticator.vala:157: EVENT: OAuth authentication re" \
"quest transaction caused a network error");
		_data_->_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
		_data_->_tmp9_ = _data_->err;
		spit_publishing_plugin_host_post_error (_data_->_tmp8_, _data_->_tmp9_);
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
		_g_error_free0 (_data_->err);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_publishing_rest_support_transaction_unref0 (_data_->txn);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_publishing_rest_support_transaction_unref0 (_data_->txn);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_parse_token_info_from_auth_request (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                       const gchar* response)
{
	gchar* oauth_token = NULL;
	gchar* oauth_token_secret = NULL;
	GHashTable* data = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_ = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_return_if_fail (response != NULL);
	g_debug ("FlickrPublishingAuthenticator.vala:165: ACTION: parsing authorization " \
"request response '%s' into token and secret", response);
	oauth_token = NULL;
	oauth_token_secret = NULL;
	_tmp0_ = soup_form_decode (response);
	data = _tmp0_;
	_tmp1_ = data;
	g_hash_table_lookup_extended (_tmp1_, "oauth_token", NULL, &_tmp2_);
	_g_free0 (oauth_token);
	_tmp3_ = g_strdup (_tmp2_);
	oauth_token = _tmp3_;
	_tmp4_ = data;
	g_hash_table_lookup_extended (_tmp4_, "oauth_token_secret", NULL, &_tmp5_);
	_g_free0 (oauth_token_secret);
	_tmp6_ = g_strdup (_tmp5_);
	oauth_token_secret = _tmp6_;
	_tmp8_ = oauth_token;
	if (_tmp8_ == NULL) {
		_tmp7_ = TRUE;
	} else {
		const gchar* _tmp9_;
		_tmp9_ = oauth_token_secret;
		_tmp7_ = _tmp9_ == NULL;
	}
	if (_tmp7_) {
		SpitPublishingPluginHost* _tmp10_;
		GError* _tmp11_;
		GError* _tmp12_;
		_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
		_tmp11_ = g_error_new (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_MALFORMED_RESPONSE, "'%s' isn't a valid response to an OAuth authentication request", response);
		_tmp12_ = _tmp11_;
		spit_publishing_plugin_host_post_error (_tmp10_, _tmp12_);
		_g_error_free0 (_tmp12_);
	}
	_tmp13_ = oauth_token;
	_tmp14_ = oauth_token_secret;
	publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (self, _tmp13_, _tmp14_);
	_g_hash_table_unref0 (data);
	_g_free0 (oauth_token_secret);
	_g_free0 (oauth_token);
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_authentication_token_available (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                   const gchar* token,
                                                                                   const gchar* token_secret)
{
	PublishingRESTSupportOAuth1Session* _tmp0_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_return_if_fail (token != NULL);
	g_return_if_fail (token_secret != NULL);
	g_debug ("FlickrPublishingAuthenticator.vala:183: EVENT: OAuth authentication to" \
"ken (%s) and token secret (%s) available", token, token_secret);
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
	publishing_rest_support_oauth1_session_set_request_phase_credentials (_tmp0_, token, token_secret);
	publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (self, token);
}

static void
__lambda4_ (PublishingAuthenticatorShotwellFlickrFlickr* self,
            const gchar* pin)
{
	g_return_if_fail (pin != NULL);
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (self, pin, NULL, NULL);
}

static void
___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                         const gchar* auth_code,
                                                                                         gpointer self)
{
	__lambda4_ ((PublishingAuthenticatorShotwellFlickrFlickr*) self, auth_code);
}

static void
_publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error (PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _sender,
                                                                                                                                            gpointer self)
{
	publishing_authenticator_shotwell_flickr_flickr_on_web_login_error ((PublishingAuthenticatorShotwellFlickrFlickr*) self);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_web_authentication (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                       const gchar* token)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp2_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp3_;
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp4_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_return_if_fail (token != NULL);
	_tmp0_ = publishing_authenticator_shotwell_flickr_web_authentication_pane_new (token);
	_g_object_unref0 (self->priv->pane);
	self->priv->pane = _tmp0_;
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	_tmp2_ = self->priv->pane;
	spit_publishing_plugin_host_install_dialog_pane (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SPIT_PUBLISHING_TYPE_DIALOG_PANE, SpitPublishingDialogPane), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
	_tmp3_ = self->priv->pane;
	g_signal_connect_object (_tmp3_, "authorized", (GCallback) ___lambda4__publishing_authenticator_shotwell_flickr_web_authentication_pane_authorized, self, 0);
	_tmp4_ = self->priv->pane;
	g_signal_connect_object (_tmp4_, "error", (GCallback) _publishing_authenticator_shotwell_flickr_flickr_on_web_login_error_publishing_authenticator_shotwell_flickr_web_authentication_pane_error, self, 0);
}

static void
publishing_authenticator_shotwell_flickr_flickr_on_web_login_error (PublishingAuthenticatorShotwellFlickrFlickr* self)
{
	PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp0_;
	GError* _tmp1_;
	GError* _tmp2_;
	SpitPublishingPluginHost* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	_tmp0_ = self->priv->pane;
	_tmp1_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		SpitPublishingPluginHost* _tmp3_;
		PublishingAuthenticatorShotwellFlickrWebAuthenticationPane* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
		_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
		_tmp4_ = self->priv->pane;
		_tmp5_ = shotwell_plugins_common_web_authentication_pane_get_load_error (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SHOTWELL_PLUGINS_COMMON_TYPE_WEB_AUTHENTICATION_PANE, ShotwellPluginsCommonWebAuthenticationPane));
		_tmp6_ = _tmp5_;
		spit_publishing_plugin_host_post_error (_tmp3_, _tmp6_);
		return;
	}
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	_tmp8_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_PROTOCOL_ERROR, _ ("Flickr authorization failed"));
	_tmp9_ = _tmp8_;
	spit_publishing_plugin_host_post_error (_tmp7_, _tmp9_);
	_g_error_free0 (_tmp9_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free (gpointer _data)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	_data_ = _data;
	_g_free0 (_data_->pin);
	_g_object_unref0 (_data_->self);
	g_slice_free (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData, _data_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                               const gchar* pin,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	PublishingAuthenticatorShotwellFlickrFlickr* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_return_if_fail (pin != NULL);
	_data_ = g_slice_new0 (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (pin);
	_g_free0 (_data_->pin);
	_data_->pin = _tmp1_;
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (_data_);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_finish (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                      GAsyncResult* _res_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_)
{
	PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (_data_);
}

static gboolean
publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_co (PublishingAuthenticatorShotwellFlickrFlickrDoVerifyPinData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_debug ("FlickrPublishingAuthenticator.vala:207: ACTION: validating authorizati" \
"on PIN %s", _data_->pin);
	_data_->_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
	_data_->_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
	spit_publishing_plugin_host_install_static_message_pane (_data_->_tmp1_, _ ("Verifying authorization…"), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
	_data_->_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
	_data_->_tmp3_ = publishing_authenticator_shotwell_flickr_access_token_fetch_transaction_new (_data_->_tmp2_, _data_->pin);
	_data_->txn = _data_->_tmp3_;
	{
		_data_->_state_ = 1;
		publishing_rest_support_transaction_execute_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_authenticator_shotwell_flickr_flickr_do_verify_pin_ready, _data_);
		return FALSE;
		_state_1:
		publishing_rest_support_transaction_execute_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		g_debug ("FlickrPublishingAuthenticator.vala:216: EVENT: fetching OAuth access t" \
"oken over the network succeeded");
		_data_->_tmp4_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
		_data_->_tmp5_ = _data_->_tmp4_;
		publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (_data_->self, _data_->_tmp5_);
		_g_free0 (_data_->_tmp5_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->err = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		g_debug ("FlickrPublishingAuthenticator.vala:220: EVENT: fetching OAuth access t" \
"oken over the network caused an error.");
		_data_->_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
		_data_->_tmp7_ = _data_->err;
		spit_publishing_plugin_host_post_error (_data_->_tmp6_, _data_->_tmp7_);
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
		_g_error_free0 (_data_->err);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_publishing_rest_support_transaction_unref0 (_data_->txn);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_publishing_rest_support_transaction_unref0 (_data_->txn);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
publishing_authenticator_shotwell_flickr_flickr_do_extract_access_phase_credentials_from_response (PublishingAuthenticatorShotwellFlickrFlickr* self,
                                                                                                   const gchar* response)
{
	gchar* token = NULL;
	gchar* token_secret = NULL;
	gchar* username = NULL;
	GHashTable* data = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_ = NULL;
	gchar* _tmp6_;
	GHashTable* _tmp7_;
	gconstpointer _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	g_return_if_fail (PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_IS_FLICKR (self));
	g_return_if_fail (response != NULL);
	g_debug ("FlickrPublishingAuthenticator.vala:228: ACTION: extracting access phas" \
"e credentials from '%s'", response);
	token = NULL;
	token_secret = NULL;
	username = NULL;
	_tmp0_ = soup_form_decode (response);
	data = _tmp0_;
	_tmp1_ = data;
	g_hash_table_lookup_extended (_tmp1_, "oauth_token", NULL, &_tmp2_);
	_g_free0 (token);
	_tmp3_ = g_strdup (_tmp2_);
	token = _tmp3_;
	_tmp4_ = data;
	g_hash_table_lookup_extended (_tmp4_, "oauth_token_secret", NULL, &_tmp5_);
	_g_free0 (token_secret);
	_tmp6_ = g_strdup (_tmp5_);
	token_secret = _tmp6_;
	_tmp7_ = data;
	g_hash_table_lookup_extended (_tmp7_, "username", NULL, &_tmp8_);
	_g_free0 (username);
	_tmp9_ = g_strdup (_tmp8_);
	username = _tmp9_;
	_tmp10_ = token;
	_tmp11_ = token_secret;
	_tmp12_ = username;
	g_debug ("FlickrPublishingAuthenticator.vala:239: access phase credentials: { to" \
"ken = '%s'; token_secret = '%s'; username = '%s' }", _tmp10_, _tmp11_, _tmp12_);
	_tmp15_ = token;
	if (_tmp15_ == NULL) {
		_tmp14_ = TRUE;
	} else {
		const gchar* _tmp16_;
		_tmp16_ = token_secret;
		_tmp14_ = _tmp16_ == NULL;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		const gchar* _tmp17_;
		_tmp17_ = username;
		_tmp13_ = _tmp17_ == NULL;
	}
	if (_tmp13_) {
		SpitPublishingPluginHost* _tmp18_;
		GError* _tmp19_;
		GError* _tmp20_;
		_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->host;
		_tmp19_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_MALFORMED_RESPONSE, "expected " "access phase credentials to contain token, token secret, and username " \
"but at " "least one of these is absent");
		_tmp20_ = _tmp19_;
		spit_publishing_plugin_host_post_error (_tmp18_, _tmp20_);
		_g_error_free0 (_tmp20_);
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_AUTHENTICATOR, SpitPublishingAuthenticator), "authentication-failed");
	} else {
		PublishingRESTSupportOAuth1Session* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		_tmp21_ = G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, PublishingAuthenticatorShotwellOAuth1Authenticator)->session;
		_tmp22_ = token;
		_tmp23_ = token_secret;
		_tmp24_ = username;
		publishing_rest_support_oauth1_session_set_access_phase_credentials (_tmp21_, _tmp22_, _tmp23_, _tmp24_);
	}
	_g_hash_table_unref0 (data);
	_g_free0 (username);
	_g_free0 (token_secret);
	_g_free0 (token);
}

static void
publishing_authenticator_shotwell_flickr_flickr_class_init (PublishingAuthenticatorShotwellFlickrFlickrClass * klass,
                                                            gpointer klass_data)
{
	publishing_authenticator_shotwell_flickr_flickr_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PublishingAuthenticatorShotwellFlickrFlickr_private_offset);
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->authenticate = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_authenticate;
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->can_logout = (gboolean (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_can_logout;
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->logout = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_logout;
	((PublishingAuthenticatorShotwellOAuth1AuthenticatorClass *) klass)->refresh = (void (*) (PublishingAuthenticatorShotwellOAuth1Authenticator*)) publishing_authenticator_shotwell_flickr_flickr_real_refresh;
	G_OBJECT_CLASS (klass)->finalize = publishing_authenticator_shotwell_flickr_flickr_finalize;
}

static void
publishing_authenticator_shotwell_flickr_flickr_instance_init (PublishingAuthenticatorShotwellFlickrFlickr * self,
                                                               gpointer klass)
{
	self->priv = publishing_authenticator_shotwell_flickr_flickr_get_instance_private (self);
}

static void
publishing_authenticator_shotwell_flickr_flickr_finalize (GObject * obj)
{
	PublishingAuthenticatorShotwellFlickrFlickr * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_AUTHENTICATOR_SHOTWELL_FLICKR_TYPE_FLICKR, PublishingAuthenticatorShotwellFlickrFlickr);
	_g_object_unref0 (self->priv->pane);
	G_OBJECT_CLASS (publishing_authenticator_shotwell_flickr_flickr_parent_class)->finalize (obj);
}

static GType
publishing_authenticator_shotwell_flickr_flickr_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingAuthenticatorShotwellFlickrFlickrClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_authenticator_shotwell_flickr_flickr_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingAuthenticatorShotwellFlickrFlickr), 0, (GInstanceInitFunc) publishing_authenticator_shotwell_flickr_flickr_instance_init, NULL };
	GType publishing_authenticator_shotwell_flickr_flickr_type_id;
	publishing_authenticator_shotwell_flickr_flickr_type_id = g_type_register_static (PUBLISHING_AUTHENTICATOR_SHOTWELL_OAUTH1_TYPE_AUTHENTICATOR, "PublishingAuthenticatorShotwellFlickrFlickr", &g_define_type_info, 0);
	PublishingAuthenticatorShotwellFlickrFlickr_private_offset = g_type_add_instance_private (publishing_authenticator_shotwell_flickr_flickr_type_id, sizeof (PublishingAuthenticatorShotwellFlickrFlickrPrivate));
	return publishing_authenticator_shotwell_flickr_flickr_type_id;
}

GType
publishing_authenticator_shotwell_flickr_flickr_get_type (void)
{
	static volatile gsize publishing_authenticator_shotwell_flickr_flickr_type_id__once = 0;
	if (g_once_init_enter (&publishing_authenticator_shotwell_flickr_flickr_type_id__once)) {
		GType publishing_authenticator_shotwell_flickr_flickr_type_id;
		publishing_authenticator_shotwell_flickr_flickr_type_id = publishing_authenticator_shotwell_flickr_flickr_get_type_once ();
		g_once_init_leave (&publishing_authenticator_shotwell_flickr_flickr_type_id__once, publishing_authenticator_shotwell_flickr_flickr_type_id);
	}
	return publishing_authenticator_shotwell_flickr_flickr_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

