/* SpitInterfaces.c generated by valac 0.56.3, the Vala compiler
 * generated from SpitInterfaces.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "shotwell-plugin-dev-1.0.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SPIT_PLUGGABLE_INFO_0_PROPERTY,
	SPIT_PLUGGABLE_INFO_VERSION_PROPERTY,
	SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY,
	SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY,
	SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY,
	SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY,
	SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY,
	SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY,
	SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY,
	SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY,
	SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY,
	SPIT_PLUGGABLE_INFO_NUM_PROPERTIES
};
static GParamSpec* spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SpitPluggableInfoPrivate {
	gchar* _version;
	gchar* _brief_description;
	gchar* _authors;
	gchar* _copyright;
	gchar* _license_blurp;
	gchar* _license_url;
	gchar* _website_url;
	gchar* _website_name;
	gchar* _translators;
	gchar* _icon_name;
};

static gint SpitPluggableInfo_private_offset;
static gpointer spit_pluggable_info_parent_class = NULL;

static void spit_module_real_reserved0 (SpitModule* self);
static void spit_module_real_reserved1 (SpitModule* self);
static void spit_module_real_reserved2 (SpitModule* self);
static void spit_module_real_reserved3 (SpitModule* self);
static void spit_module_real_reserved4 (SpitModule* self);
static void spit_module_real_reserved5 (SpitModule* self);
static void spit_module_real_reserved6 (SpitModule* self);
static void spit_module_real_reserved7 (SpitModule* self);
static GType spit_module_get_type_once (void);
static void spit_pluggable_info_finalize (GObject * obj);
static GType spit_pluggable_info_get_type_once (void);
static void _vala_spit_pluggable_info_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_spit_pluggable_info_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void spit_pluggable_real_reserved0 (SpitPluggable* self);
static void spit_pluggable_real_reserved1 (SpitPluggable* self);
static void spit_pluggable_real_reserved2 (SpitPluggable* self);
static void spit_pluggable_real_reserved3 (SpitPluggable* self);
static void spit_pluggable_real_reserved4 (SpitPluggable* self);
static void spit_pluggable_real_reserved5 (SpitPluggable* self);
static void spit_pluggable_real_reserved6 (SpitPluggable* self);
static void spit_pluggable_real_reserved7 (SpitPluggable* self);
static GType spit_pluggable_get_type_once (void);
static void spit_host_interface_real_reserved0 (SpitHostInterface* self);
static void spit_host_interface_real_reserved1 (SpitHostInterface* self);
static void spit_host_interface_real_reserved2 (SpitHostInterface* self);
static void spit_host_interface_real_reserved3 (SpitHostInterface* self);
static void spit_host_interface_real_reserved4 (SpitHostInterface* self);
static void spit_host_interface_real_reserved5 (SpitHostInterface* self);
static void spit_host_interface_real_reserved6 (SpitHostInterface* self);
static void spit_host_interface_real_reserved7 (SpitHostInterface* self);
static GType spit_host_interface_get_type_once (void);

/**
 * A utility function for checking host interfaces against one's own and returning the right value.
 *
 * Note that this only works if the caller operates on only one interface version (and cannot mutate
 * between multiple ones).
 *
 * @param min_host_interface The minimum supported host interface version.
 * @param max_host_interface The maximum supported host interface version.
 * @param plugin_interface The interface version supported by the Pluggable.
 * 
 * @return The plugin's interface version if supported, {@link UNSUPPORTED_INTERFACE} otherwise.
 */
gint
spit_negotiate_interfaces (gint min_host_interface,
                           gint max_host_interface,
                           gint plugin_interface)
{
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gint result;
	if (min_host_interface > plugin_interface) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = max_host_interface < plugin_interface;
	}
	if (_tmp1_) {
		_tmp0_ = SPIT_UNSUPPORTED_INTERFACE;
	} else {
		_tmp0_ = plugin_interface;
	}
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
spit_entry_point_params_copy (const SpitEntryPointParams* self,
                              SpitEntryPointParams* dest)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	(*dest).host_min_spit_interface = (*self).host_min_spit_interface;
	(*dest).host_max_spit_interface = (*self).host_max_spit_interface;
	(*dest).module_spit_interface = (*self).module_spit_interface;
	_tmp0_ = (*self).module_file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 ((*dest).module_file);
	(*dest).module_file = _tmp1_;
}

void
spit_entry_point_params_destroy (SpitEntryPointParams* self)
{
	_g_object_unref0 ((*self).module_file);
}

SpitEntryPointParams*
spit_entry_point_params_dup (const SpitEntryPointParams* self)
{
	SpitEntryPointParams* dup;
	dup = g_new0 (SpitEntryPointParams, 1);
	spit_entry_point_params_copy (self, dup);
	return dup;
}

void
spit_entry_point_params_free (SpitEntryPointParams* self)
{
	spit_entry_point_params_destroy (self);
	g_free (self);
}

static GType
spit_entry_point_params_get_type_once (void)
{
	GType spit_entry_point_params_type_id;
	spit_entry_point_params_type_id = g_boxed_type_register_static ("SpitEntryPointParams", (GBoxedCopyFunc) spit_entry_point_params_dup, (GBoxedFreeFunc) spit_entry_point_params_free);
	return spit_entry_point_params_type_id;
}

GType
spit_entry_point_params_get_type (void)
{
	static volatile gsize spit_entry_point_params_type_id__once = 0;
	if (g_once_init_enter (&spit_entry_point_params_type_id__once)) {
		GType spit_entry_point_params_type_id;
		spit_entry_point_params_type_id = spit_entry_point_params_get_type_once ();
		g_once_init_leave (&spit_entry_point_params_type_id__once, spit_entry_point_params_type_id);
	}
	return spit_entry_point_params_type_id__once;
}

/**
     * Returns a user-visible string describing the module.
     */
const gchar*
spit_module_get_module_name (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_val_if_fail (SPIT_IS_MODULE (self), NULL);
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->get_module_name) {
		return _iface_->get_module_name (self);
	}
	return NULL;
}

/**
     * Returns a user-visible string describing the module version.
     * 
     * Note that this may be programmatically interpreted at some point, so use a widespread 
     * versioning scheme.
     */
const gchar*
spit_module_get_version (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_val_if_fail (SPIT_IS_MODULE (self), NULL);
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->get_version) {
		return _iface_->get_version (self);
	}
	return NULL;
}

/**
     * Returns a unique identifier for this module.
     * 
     * This is used to differentiate between multiple
     * installed versions and to determine which one should be used (i.e. if a module is available
     * in a system directory and a user directory). This name is case-sensitive.
     * 
     * Best practice: use a reverse-DNS-order scheme, a la Java's packages
     * (i.e. "org.yorba.shotwell.frotz").
     */
const gchar*
spit_module_get_id (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_val_if_fail (SPIT_IS_MODULE (self), NULL);
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->get_id) {
		return _iface_->get_id (self);
	}
	return NULL;
}

/**
     * Returns an array of {@link Pluggable} that represent each plugin available in the module.
     *
     * May return NULL or an empty array.
     */
SpitPluggable**
spit_module_get_pluggables (SpitModule* self,
                            gint* result_length1)
{
	SpitModuleIface* _iface_;
	g_return_val_if_fail (SPIT_IS_MODULE (self), NULL);
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->get_pluggables) {
		return _iface_->get_pluggables (self, result_length1);
	}
	return NULL;
}

static void
spit_module_real_reserved0 (SpitModule* self)
{
}

void
spit_module_reserved0 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved0) {
		_iface_->reserved0 (self);
	}
}

static void
spit_module_real_reserved1 (SpitModule* self)
{
}

void
spit_module_reserved1 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved1) {
		_iface_->reserved1 (self);
	}
}

static void
spit_module_real_reserved2 (SpitModule* self)
{
}

void
spit_module_reserved2 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved2) {
		_iface_->reserved2 (self);
	}
}

static void
spit_module_real_reserved3 (SpitModule* self)
{
}

void
spit_module_reserved3 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved3) {
		_iface_->reserved3 (self);
	}
}

static void
spit_module_real_reserved4 (SpitModule* self)
{
}

void
spit_module_reserved4 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved4) {
		_iface_->reserved4 (self);
	}
}

static void
spit_module_real_reserved5 (SpitModule* self)
{
}

void
spit_module_reserved5 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved5) {
		_iface_->reserved5 (self);
	}
}

static void
spit_module_real_reserved6 (SpitModule* self)
{
}

void
spit_module_reserved6 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved6) {
		_iface_->reserved6 (self);
	}
}

static void
spit_module_real_reserved7 (SpitModule* self)
{
}

void
spit_module_reserved7 (SpitModule* self)
{
	SpitModuleIface* _iface_;
	g_return_if_fail (SPIT_IS_MODULE (self));
	_iface_ = SPIT_MODULE_GET_INTERFACE (self);
	if (_iface_->reserved7) {
		_iface_->reserved7 (self);
	}
}

static void
spit_module_default_init (SpitModuleIface * iface,
                          gpointer iface_data)
{
	iface->reserved0 = spit_module_real_reserved0;
	iface->reserved1 = spit_module_real_reserved1;
	iface->reserved2 = spit_module_real_reserved2;
	iface->reserved3 = spit_module_real_reserved3;
	iface->reserved4 = spit_module_real_reserved4;
	iface->reserved5 = spit_module_real_reserved5;
	iface->reserved6 = spit_module_real_reserved6;
	iface->reserved7 = spit_module_real_reserved7;
}

/**
 * A Module represents the resources of an entire dynamically-linked module (i.e. a .so/.la).
 *
 * A module holds zero or more Shotwell plugins ({@link Pluggable}). Once the module has been
 * loaded into process space this object is retrieved by Shotwell. All calls to the module and
 * its plugins are resolved through this interface.
 *
 * Note: The module is responsible for holding the reference to the Module object, of which there
 * should be only one in the library file. The module should implement a g_module_unload method
 * and drop the reference there.
 */
static GType
spit_module_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpitModuleIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spit_module_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType spit_module_type_id;
	spit_module_type_id = g_type_register_static (G_TYPE_INTERFACE, "SpitModule", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (spit_module_type_id, G_TYPE_OBJECT);
	return spit_module_type_id;
}

GType
spit_module_get_type (void)
{
	static volatile gsize spit_module_type_id__once = 0;
	if (g_once_init_enter (&spit_module_type_id__once)) {
		GType spit_module_type_id;
		spit_module_type_id = spit_module_get_type_once ();
		g_once_init_leave (&spit_module_type_id__once, spit_module_type_id);
	}
	return spit_module_type_id__once;
}

static inline gpointer
spit_pluggable_info_get_instance_private (SpitPluggableInfo* self)
{
	return G_STRUCT_MEMBER_P (self, SpitPluggableInfo_private_offset);
}

SpitPluggableInfo*
spit_pluggable_info_construct (GType object_type)
{
	SpitPluggableInfo * self = NULL;
	self = (SpitPluggableInfo*) g_object_new (object_type, NULL);
	return self;
}

SpitPluggableInfo*
spit_pluggable_info_new (void)
{
	return spit_pluggable_info_construct (SPIT_TYPE_PLUGGABLE_INFO);
}

const gchar*
spit_pluggable_info_get_version (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_version;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_version (SpitPluggableInfo* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_version (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_version);
		self->priv->_version = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_VERSION_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_brief_description (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_brief_description;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_brief_description (SpitPluggableInfo* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_brief_description (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_brief_description);
		self->priv->_brief_description = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_authors (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_authors;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_authors (SpitPluggableInfo* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_authors (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_authors);
		self->priv->_authors = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_copyright (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_copyright;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_copyright (SpitPluggableInfo* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_copyright (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_copyright);
		self->priv->_copyright = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_license_blurp (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_license_blurp;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_license_blurp (SpitPluggableInfo* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_license_blurp (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_license_blurp);
		self->priv->_license_blurp = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_license_url (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_license_url;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_license_url (SpitPluggableInfo* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_license_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_license_url);
		self->priv->_license_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_website_url (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_website_url;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_website_url (SpitPluggableInfo* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_website_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_website_url);
		self->priv->_website_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_website_name (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_website_name;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_website_name (SpitPluggableInfo* self,
                                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_website_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_website_name);
		self->priv->_website_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_translators (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_translators;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_translators (SpitPluggableInfo* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_translators (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_translators);
		self->priv->_translators = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY]);
	}
}

const gchar*
spit_pluggable_info_get_icon_name (SpitPluggableInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE_INFO (self), NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
spit_pluggable_info_set_icon_name (SpitPluggableInfo* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (SPIT_IS_PLUGGABLE_INFO (self));
	old_value = spit_pluggable_info_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY]);
	}
}

static void
spit_pluggable_info_class_init (SpitPluggableInfoClass * klass,
                                gpointer klass_data)
{
	spit_pluggable_info_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SpitPluggableInfo_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_spit_pluggable_info_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_spit_pluggable_info_set_property;
	G_OBJECT_CLASS (klass)->finalize = spit_pluggable_info_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_VERSION_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY] = g_param_spec_string ("brief-description", "brief-description", "brief-description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * A comma-delimited list of the authors of this {@link Pluggable}.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY] = g_param_spec_string ("authors", "authors", "authors", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY] = g_param_spec_string ("copyright", "copyright", "copyright", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY] = g_param_spec_string ("license-blurp", "license-blurp", "license-blurp", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY] = g_param_spec_string ("license-url", "license-url", "license-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY] = g_param_spec_string ("website-url", "website-url", "website-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY] = g_param_spec_string ("website-name", "website-name", "website-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY] = g_param_spec_string ("translators", "translators", "translators", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY, spit_pluggable_info_properties[SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
spit_pluggable_info_instance_init (SpitPluggableInfo * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	self->priv = spit_pluggable_info_get_instance_private (self);
	_tmp0_ = g_strdup (_VERSION);
	self->priv->_version = _tmp0_;
	_tmp1_ = g_strdup (_ ("LGPL v2.1 or later"));
	self->priv->_license_blurp = _tmp1_;
	_tmp2_ = g_strdup ("https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html");
	self->priv->_license_url = _tmp2_;
	_tmp3_ = g_strdup ("https://wiki.gnome.org/Apps/Shotwell");
	self->priv->_website_url = _tmp3_;
	_tmp4_ = g_strdup (_ ("Visit the Shotwell home page"));
	self->priv->_website_name = _tmp4_;
	_tmp5_ = g_strdup (_ ("translator-credits"));
	self->priv->_translators = _tmp5_;
	_tmp6_ = g_strdup ("application-x-addon-symbolic");
	self->priv->_icon_name = _tmp6_;
}

static void
spit_pluggable_info_finalize (GObject * obj)
{
	SpitPluggableInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SPIT_TYPE_PLUGGABLE_INFO, SpitPluggableInfo);
	_g_free0 (self->priv->_version);
	_g_free0 (self->priv->_brief_description);
	_g_free0 (self->priv->_authors);
	_g_free0 (self->priv->_copyright);
	_g_free0 (self->priv->_license_blurp);
	_g_free0 (self->priv->_license_url);
	_g_free0 (self->priv->_website_url);
	_g_free0 (self->priv->_website_name);
	_g_free0 (self->priv->_translators);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (spit_pluggable_info_parent_class)->finalize (obj);
}

/**
 * A structure holding an assortment of information about a {@link Pluggable}.
 */
static GType
spit_pluggable_info_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpitPluggableInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spit_pluggable_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SpitPluggableInfo), 0, (GInstanceInitFunc) spit_pluggable_info_instance_init, NULL };
	GType spit_pluggable_info_type_id;
	spit_pluggable_info_type_id = g_type_register_static (G_TYPE_OBJECT, "SpitPluggableInfo", &g_define_type_info, 0);
	SpitPluggableInfo_private_offset = g_type_add_instance_private (spit_pluggable_info_type_id, sizeof (SpitPluggableInfoPrivate));
	return spit_pluggable_info_type_id;
}

GType
spit_pluggable_info_get_type (void)
{
	static volatile gsize spit_pluggable_info_type_id__once = 0;
	if (g_once_init_enter (&spit_pluggable_info_type_id__once)) {
		GType spit_pluggable_info_type_id;
		spit_pluggable_info_type_id = spit_pluggable_info_get_type_once ();
		g_once_init_leave (&spit_pluggable_info_type_id__once, spit_pluggable_info_type_id);
	}
	return spit_pluggable_info_type_id__once;
}

static void
_vala_spit_pluggable_info_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SpitPluggableInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPIT_TYPE_PLUGGABLE_INFO, SpitPluggableInfo);
	switch (property_id) {
		case SPIT_PLUGGABLE_INFO_VERSION_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_version (self));
		break;
		case SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_brief_description (self));
		break;
		case SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_authors (self));
		break;
		case SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_copyright (self));
		break;
		case SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_license_blurp (self));
		break;
		case SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_license_url (self));
		break;
		case SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_website_url (self));
		break;
		case SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_website_name (self));
		break;
		case SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_translators (self));
		break;
		case SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY:
		g_value_set_string (value, spit_pluggable_info_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_spit_pluggable_info_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SpitPluggableInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SPIT_TYPE_PLUGGABLE_INFO, SpitPluggableInfo);
	switch (property_id) {
		case SPIT_PLUGGABLE_INFO_VERSION_PROPERTY:
		spit_pluggable_info_set_version (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_BRIEF_DESCRIPTION_PROPERTY:
		spit_pluggable_info_set_brief_description (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_AUTHORS_PROPERTY:
		spit_pluggable_info_set_authors (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_COPYRIGHT_PROPERTY:
		spit_pluggable_info_set_copyright (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_LICENSE_BLURP_PROPERTY:
		spit_pluggable_info_set_license_blurp (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_LICENSE_URL_PROPERTY:
		spit_pluggable_info_set_license_url (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_WEBSITE_URL_PROPERTY:
		spit_pluggable_info_set_website_url (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_WEBSITE_NAME_PROPERTY:
		spit_pluggable_info_set_website_name (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_TRANSLATORS_PROPERTY:
		spit_pluggable_info_set_translators (self, g_value_get_string (value));
		break;
		case SPIT_PLUGGABLE_INFO_ICON_NAME_PROPERTY:
		spit_pluggable_info_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

/**
     * Pluggable interface version negotiation.
     *
     * Like the {@link EntryPoint}, this mechanism allows for the host to negotiate with the Pluggable
     * for its interface version. If the pluggable does not support an interface between the
     * two ranges (inclusive), it should return {@link UNSUPPORTED_INTERFACE}.
     *
     * Note that this is ''not'' a negotiation of the SPIT interface versions (which is the
     * responsibility of {@link EntryPoint}. Rather, each extension point is expected to version
     * its own cluster of interfaces. It is that interface version that is being negotiated here.
     *
     * {@link negotiate_interfaces} can be used to implement this method.
     *
     * @param min_host_interface The host's minimum supported interface version number
     *        //for this Pluggable's intended extension point//.
     * @param max_host_interface The host's maximum supported interface version number
     *        //for this Pluggable's intended extension point//.
     *
     * @return The version number supported by the host and the Pluggable or
     *         {@link UNSUPPORTED_INTERFACE}.
     */
gint
spit_pluggable_get_pluggable_interface (SpitPluggable* self,
                                        gint min_host_interface,
                                        gint max_host_interface)
{
	SpitPluggableIface* _iface_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE (self), 0);
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->get_pluggable_interface) {
		return _iface_->get_pluggable_interface (self, min_host_interface, max_host_interface);
	}
	return -1;
}

/**
     * Returns a unique identifier for this Pluggable.
     *
     * Like {@link Module.get_id}, best practice is to use a reverse-DNS-order scheme to avoid 
     * conflicts.
     */
const gchar*
spit_pluggable_get_id (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE (self), NULL);
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->get_id) {
		return _iface_->get_id (self);
	}
	return NULL;
}

/**
     * Returns a user-visible name for the Pluggable.
     */
const gchar*
spit_pluggable_get_pluggable_name (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE (self), NULL);
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->get_pluggable_name) {
		return _iface_->get_pluggable_name (self);
	}
	return NULL;
}

/**
     * Returns extra information about the Pluggable that is used to identify it to the user.
     */
SpitPluggableInfo*
spit_pluggable_get_info (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_val_if_fail (SPIT_IS_PLUGGABLE (self), NULL);
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->get_info) {
		return _iface_->get_info (self);
	}
	return NULL;
}

/**
     * Called when the Pluggable is enabled (activated) or disabled (deactivated).
     *
     * activation will be called at the start of the program if the user previously 
     * enabled/disabled it as well as during program execution if the user changes its state. Note 
     * that disabling a Pluggable does not require destroying existing resources or objects 
     * the Pluggable has previously handed off to the host.
     *
     * This is purely informational. The Pluggable should acquire any long-term resources
     * it may be holding onto here, or wait until an extension-specific call is made to it.
     *
     * @param enabled ``true`` if the Pluggable has been enabled, ``false`` otherwise.
     */
void
spit_pluggable_activation (SpitPluggable* self,
                           gboolean enabled)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->activation) {
		_iface_->activation (self, enabled);
	}
}

static void
spit_pluggable_real_reserved0 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved0 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved0) {
		_iface_->reserved0 (self);
	}
}

static void
spit_pluggable_real_reserved1 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved1 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved1) {
		_iface_->reserved1 (self);
	}
}

static void
spit_pluggable_real_reserved2 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved2 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved2) {
		_iface_->reserved2 (self);
	}
}

static void
spit_pluggable_real_reserved3 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved3 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved3) {
		_iface_->reserved3 (self);
	}
}

static void
spit_pluggable_real_reserved4 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved4 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved4) {
		_iface_->reserved4 (self);
	}
}

static void
spit_pluggable_real_reserved5 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved5 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved5) {
		_iface_->reserved5 (self);
	}
}

static void
spit_pluggable_real_reserved6 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved6 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved6) {
		_iface_->reserved6 (self);
	}
}

static void
spit_pluggable_real_reserved7 (SpitPluggable* self)
{
}

void
spit_pluggable_reserved7 (SpitPluggable* self)
{
	SpitPluggableIface* _iface_;
	g_return_if_fail (SPIT_IS_PLUGGABLE (self));
	_iface_ = SPIT_PLUGGABLE_GET_INTERFACE (self);
	if (_iface_->reserved7) {
		_iface_->reserved7 (self);
	}
}

static void
spit_pluggable_default_init (SpitPluggableIface * iface,
                             gpointer iface_data)
{
	iface->reserved0 = spit_pluggable_real_reserved0;
	iface->reserved1 = spit_pluggable_real_reserved1;
	iface->reserved2 = spit_pluggable_real_reserved2;
	iface->reserved3 = spit_pluggable_real_reserved3;
	iface->reserved4 = spit_pluggable_real_reserved4;
	iface->reserved5 = spit_pluggable_real_reserved5;
	iface->reserved6 = spit_pluggable_real_reserved6;
	iface->reserved7 = spit_pluggable_real_reserved7;
}

/**
 * A generic interface to all Shotwell plugins.
 *
 * Each plugin in a module needs to implement this interface at a minimum. Extension
 * points may have (and probably will have) specific interface requirements as well.
 */
static GType
spit_pluggable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpitPluggableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spit_pluggable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType spit_pluggable_type_id;
	spit_pluggable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SpitPluggable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (spit_pluggable_type_id, G_TYPE_OBJECT);
	return spit_pluggable_type_id;
}

GType
spit_pluggable_get_type (void)
{
	static volatile gsize spit_pluggable_type_id__once = 0;
	if (g_once_init_enter (&spit_pluggable_type_id__once)) {
		GType spit_pluggable_type_id;
		spit_pluggable_type_id = spit_pluggable_get_type_once ();
		g_once_init_leave (&spit_pluggable_type_id__once, spit_pluggable_type_id);
	}
	return spit_pluggable_type_id__once;
}

/**
     * Returns a File object representing the library file (.so/la.) that the plugin was loaded
     * from.
     */
GFile*
spit_host_interface_get_module_file (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_val_if_fail (SPIT_IS_HOST_INTERFACE (self), NULL);
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_module_file) {
		return _iface_->get_module_file (self);
	}
	return NULL;
}

/**
     * Get a boolean from a persistent configuration store.
     *
     * @param key The name of the value to be retrieved.
     * @param def The default value (returned if the key has not been previously set).
     *
     * @return The value associated with key, def if not set.
     */
gboolean
spit_host_interface_get_config_bool (SpitHostInterface* self,
                                     const gchar* key,
                                     gboolean def)
{
	SpitHostInterfaceIface* _iface_;
	g_return_val_if_fail (SPIT_IS_HOST_INTERFACE (self), FALSE);
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_config_bool) {
		return _iface_->get_config_bool (self, key, def);
	}
	return FALSE;
}

/**
     * Store a boolean in a persistent configuration store.
     *
     * @param key The name of the value to be stored.
     * @param val The value to be stored.
     */
void
spit_host_interface_set_config_bool (SpitHostInterface* self,
                                     const gchar* key,
                                     gboolean val)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_config_bool) {
		_iface_->set_config_bool (self, key, val);
	}
}

/**
     * Get an integer from a persistent configuration store.
     *
     * @param key The name of the value to be retrieved.
     * @param def The default value (returned if the key has not been previously set).
     *
     * @return The value associated with key, def if not set.
     */
gint
spit_host_interface_get_config_int (SpitHostInterface* self,
                                    const gchar* key,
                                    gint def)
{
	SpitHostInterfaceIface* _iface_;
	g_return_val_if_fail (SPIT_IS_HOST_INTERFACE (self), 0);
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_config_int) {
		return _iface_->get_config_int (self, key, def);
	}
	return -1;
}

/**
     * Store an integer in a persistent configuration store.
     *
     * @param key The name of the value to be stored.
     * @param val The value to be stored.
     */
void
spit_host_interface_set_config_int (SpitHostInterface* self,
                                    const gchar* key,
                                    gint val)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_config_int) {
		_iface_->set_config_int (self, key, val);
	}
}

/**
     * Get a string from a persistent configuration store.
     *
     * @param key The name of the value to be retrieved.
     * @param def The default value (returned if the key has not been previously set).
     *
     * @return The value associated with key, def if not set.
     */
gchar*
spit_host_interface_get_config_string (SpitHostInterface* self,
                                       const gchar* key,
                                       const gchar* def)
{
	SpitHostInterfaceIface* _iface_;
	g_return_val_if_fail (SPIT_IS_HOST_INTERFACE (self), NULL);
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_config_string) {
		return _iface_->get_config_string (self, key, def);
	}
	return NULL;
}

/**
     * Store a string in a persistent configuration store.
     *
     * @param key The name of the value to be stored.
     * @param val The value to be stored.
     */
void
spit_host_interface_set_config_string (SpitHostInterface* self,
                                       const gchar* key,
                                       const gchar* val)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_config_string) {
		_iface_->set_config_string (self, key, val);
	}
}

/**
     * Get a double from a persistent configuration store.
     *
     * @param key The name of the value to be retrieved.
     * @param def The default value (returned if the key has not been previously set).
     *
     * @return The value associated with key, def if not set.
     */
gdouble
spit_host_interface_get_config_double (SpitHostInterface* self,
                                       const gchar* key,
                                       gdouble def)
{
	SpitHostInterfaceIface* _iface_;
	g_return_val_if_fail (SPIT_IS_HOST_INTERFACE (self), 0.0);
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_config_double) {
		return _iface_->get_config_double (self, key, def);
	}
	return -1.0;
}

/**
     * Store a double in a persistent configuration store.
     *
     * @param key The name of the value to be stored.
     * @param val The value to be stored.
     */
void
spit_host_interface_set_config_double (SpitHostInterface* self,
                                       const gchar* key,
                                       gdouble val)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_config_double) {
		_iface_->set_config_double (self, key, val);
	}
}

/**
     * Delete the value from the persistent configuration store.
     */
void
spit_host_interface_unset_config_key (SpitHostInterface* self,
                                      const gchar* key)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->unset_config_key) {
		_iface_->unset_config_key (self, key);
	}
}

static void
spit_host_interface_real_reserved0 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved0 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved0) {
		_iface_->reserved0 (self);
	}
}

static void
spit_host_interface_real_reserved1 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved1 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved1) {
		_iface_->reserved1 (self);
	}
}

static void
spit_host_interface_real_reserved2 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved2 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved2) {
		_iface_->reserved2 (self);
	}
}

static void
spit_host_interface_real_reserved3 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved3 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved3) {
		_iface_->reserved3 (self);
	}
}

static void
spit_host_interface_real_reserved4 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved4 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved4) {
		_iface_->reserved4 (self);
	}
}

static void
spit_host_interface_real_reserved5 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved5 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved5) {
		_iface_->reserved5 (self);
	}
}

static void
spit_host_interface_real_reserved6 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved6 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved6) {
		_iface_->reserved6 (self);
	}
}

static void
spit_host_interface_real_reserved7 (SpitHostInterface* self)
{
}

void
spit_host_interface_reserved7 (SpitHostInterface* self)
{
	SpitHostInterfaceIface* _iface_;
	g_return_if_fail (SPIT_IS_HOST_INTERFACE (self));
	_iface_ = SPIT_HOST_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reserved7) {
		_iface_->reserved7 (self);
	}
}

static void
spit_host_interface_default_init (SpitHostInterfaceIface * iface,
                                  gpointer iface_data)
{
	iface->reserved0 = spit_host_interface_real_reserved0;
	iface->reserved1 = spit_host_interface_real_reserved1;
	iface->reserved2 = spit_host_interface_real_reserved2;
	iface->reserved3 = spit_host_interface_real_reserved3;
	iface->reserved4 = spit_host_interface_real_reserved4;
	iface->reserved5 = spit_host_interface_real_reserved5;
	iface->reserved6 = spit_host_interface_real_reserved6;
	iface->reserved7 = spit_host_interface_real_reserved7;
}

/**
 * An interface to common services supplied by the host (Shotwell).
 *
 * Each {@link Pluggable} is offered a HostInterface for needs common to most plugins.
 * 
 * Note that
 * a HostInterface is not explicitly handed to the Pluggable through the SPIT interface, but is expected 
 * to be offered to the Pluggable through an interface applicable to the extension point. This 
 * also allows the extension point to extend HostInterface to offer other services applicable to the
 * type of plugin.
 */
static GType
spit_host_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SpitHostInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spit_host_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType spit_host_interface_type_id;
	spit_host_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SpitHostInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (spit_host_interface_type_id, G_TYPE_OBJECT);
	return spit_host_interface_type_id;
}

GType
spit_host_interface_get_type (void)
{
	static volatile gsize spit_host_interface_type_id__once = 0;
	if (g_once_init_enter (&spit_host_interface_type_id__once)) {
		GType spit_host_interface_type_id;
		spit_host_interface_type_id = spit_host_interface_get_type_once ();
		g_once_init_leave (&spit_host_interface_type_id__once, spit_host_interface_type_id);
	}
	return spit_host_interface_type_id__once;
}

