/* SearchFilter.c generated by valac 0.56.3, the Vala compiler
 * generated from SearchFilter.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Bitfield values used to specify which search bar features we want.*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define SEARCH_FILTER_TOOLBAR_FILTER_BUTTON_MARGIN 12
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE 0.65f
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_SCALE 0.75f
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH 30
#define SEARCH_FILTER_TOOLBAR_FILTER_ICON_PLUS_WIDTH 20
#define RESOURCES_ICON_FILTER_REJECTED_OR_BETTER_FIXED_SIZE 32
#define RESOURCES_ICON_FILTER_UNRATED_OR_BETTER_FIXED_SIZE 16
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SEARCH_FILTER_CRITERIA_NONE = 0,
	SEARCH_FILTER_CRITERIA_RECURSIVE = 1 << 0,
	SEARCH_FILTER_CRITERIA_TEXT = 1 << 1,
	SEARCH_FILTER_CRITERIA_FLAG = 1 << 2,
	SEARCH_FILTER_CRITERIA_MEDIA = 1 << 3,
	SEARCH_FILTER_CRITERIA_RATING = 1 << 4,
	SEARCH_FILTER_CRITERIA_SAVEDSEARCH = 1 << 5,
	SEARCH_FILTER_CRITERIA_ALL = 0xFFFFFFFFLL
} SearchFilterCriteria;

#define TYPE_SEARCH_FILTER_CRITERIA (search_filter_criteria_get_type ())
typedef enum  {
	RATING_FILTER_NO_FILTER = 0,
	RATING_FILTER_REJECTED_OR_HIGHER = 1,
	RATING_FILTER_UNRATED_OR_HIGHER = 2,
	RATING_FILTER_ONE_OR_HIGHER = 3,
	RATING_FILTER_TWO_OR_HIGHER = 4,
	RATING_FILTER_THREE_OR_HIGHER = 5,
	RATING_FILTER_FOUR_OR_HIGHER = 6,
	RATING_FILTER_FIVE_OR_HIGHER = 7,
	RATING_FILTER_REJECTED_ONLY = 8,
	RATING_FILTER_UNRATED_ONLY = 9,
	RATING_FILTER_ONE_ONLY = 10,
	RATING_FILTER_TWO_ONLY = 11,
	RATING_FILTER_THREE_ONLY = 12,
	RATING_FILTER_FOUR_ONLY = 13,
	RATING_FILTER_FIVE_ONLY = 14
} RatingFilter;

#define TYPE_RATING_FILTER (rating_filter_get_type ())

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;
typedef struct _ViewFilterPrivate ViewFilterPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_SEARCH_VIEW_FILTER (search_view_filter_get_type ())
#define SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))
#define SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_VIEW_FILTER, SearchViewFilterClass))
#define IS_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_VIEW_FILTER))
#define IS_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_VIEW_FILTER))
#define SEARCH_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_VIEW_FILTER, SearchViewFilterClass))

typedef struct _SearchViewFilter SearchViewFilter;
typedef struct _SearchViewFilterClass SearchViewFilterClass;
typedef struct _SearchViewFilterPrivate SearchViewFilterPrivate;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SAVED_SEARCH (saved_search_get_type ())
#define SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH, SavedSearch))
#define SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH, SavedSearchClass))
#define IS_SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH))
#define IS_SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH))
#define SAVED_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH, SavedSearchClass))

typedef struct _SavedSearch SavedSearch;
typedef struct _SavedSearchClass SavedSearchClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DEFAULT_SEARCH_VIEW_FILTER (default_search_view_filter_get_type ())
#define DEFAULT_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilter))
#define DEFAULT_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilterClass))
#define IS_DEFAULT_SEARCH_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER))
#define IS_DEFAULT_SEARCH_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEFAULT_SEARCH_VIEW_FILTER))
#define DEFAULT_SEARCH_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilterClass))

typedef struct _DefaultSearchViewFilter DefaultSearchViewFilter;
typedef struct _DefaultSearchViewFilterClass DefaultSearchViewFilterClass;
typedef struct _DefaultSearchViewFilterPrivate DefaultSearchViewFilterPrivate;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_CHECKERBOARD_ITEM (checkerboard_item_get_type ())
#define CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItem))
#define CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))
#define IS_CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_ITEM))
#define IS_CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_ITEM))
#define CHECKERBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))

typedef struct _CheckerboardItem CheckerboardItem;
typedef struct _CheckerboardItemClass CheckerboardItemClass;

#define TYPE_MEDIA_SOURCE_ITEM (media_source_item_get_type ())
#define MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItem))
#define MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))
#define IS_MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_ITEM))
#define IS_MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_ITEM))
#define MEDIA_SOURCE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))

typedef struct _MediaSourceItem MediaSourceItem;
typedef struct _MediaSourceItemClass MediaSourceItemClass;

#define TYPE_THUMBNAIL (thumbnail_get_type ())
#define THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL, Thumbnail))
#define THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL, ThumbnailClass))
#define IS_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL))
#define IS_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL))
#define THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL, ThumbnailClass))

typedef struct _Thumbnail Thumbnail;
typedef struct _ThumbnailClass ThumbnailClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_HEIF,
	PHOTO_FILE_FORMAT_JPEGXL,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_FACE (face_get_type ())
#define FACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE, Face))
#define FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE, FaceClass))
#define IS_FACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE))
#define IS_FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE))
#define FACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE, FaceClass))

typedef struct _Face Face;
typedef struct _FaceClass FaceClass;

#define TYPE_FACE_SOURCE_COLLECTION (face_source_collection_get_type ())
#define FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollection))
#define FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))
#define IS_FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_SOURCE_COLLECTION))
#define IS_FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_SOURCE_COLLECTION))
#define FACE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))

typedef struct _FaceSourceCollection FaceSourceCollection;
typedef struct _FaceSourceCollectionClass FaceSourceCollectionClass;

#define TYPE_DISABLED_VIEW_FILTER (disabled_view_filter_get_type ())
#define DISABLED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter))
#define DISABLED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilterClass))
#define IS_DISABLED_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DISABLED_VIEW_FILTER))
#define IS_DISABLED_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DISABLED_VIEW_FILTER))
#define DISABLED_VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DISABLED_VIEW_FILTER, DisabledViewFilterClass))

typedef struct _DisabledViewFilter DisabledViewFilter;
typedef struct _DisabledViewFilterClass DisabledViewFilterClass;
typedef struct _DisabledViewFilterPrivate DisabledViewFilterPrivate;

#define TYPE_TEXT_ACTION (text_action_get_type ())
#define TEXT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_ACTION, TextAction))
#define TEXT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_ACTION, TextActionClass))
#define IS_TEXT_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_ACTION))
#define IS_TEXT_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_ACTION))
#define TEXT_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_ACTION, TextActionClass))

typedef struct _TextAction TextAction;
typedef struct _TextActionClass TextActionClass;
typedef struct _TextActionPrivate TextActionPrivate;
typedef struct _ParamSpecTextAction ParamSpecTextAction;
enum  {
	TEXT_ACTION_TEXT_CHANGED_SIGNAL,
	TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL,
	TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL,
	TEXT_ACTION_NUM_SIGNALS
};
static guint text_action_signals[TEXT_ACTION_NUM_SIGNALS] = {0};

#define TYPE_SEARCH_FILTER_ACTIONS (search_filter_actions_get_type ())
#define SEARCH_FILTER_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActions))
#define SEARCH_FILTER_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActionsClass))
#define IS_SEARCH_FILTER_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_FILTER_ACTIONS))
#define IS_SEARCH_FILTER_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_FILTER_ACTIONS))
#define SEARCH_FILTER_ACTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActionsClass))

typedef struct _SearchFilterActions SearchFilterActions;
typedef struct _SearchFilterActionsClass SearchFilterActionsClass;
typedef struct _SearchFilterActionsPrivate SearchFilterActionsPrivate;
#define _text_action_unref0(var) ((var == NULL) ? NULL : (var = (text_action_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;

#define TYPE_LIBRARY_WINDOW (library_window_get_type ())
#define LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_WINDOW, LibraryWindow))
#define LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_WINDOW, LibraryWindowClass))
#define IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_WINDOW))
#define IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_WINDOW))
#define LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_WINDOW, LibraryWindowClass))

typedef struct _LibraryWindow LibraryWindow;
typedef struct _LibraryWindowClass LibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_CHECKERBOARD_PAGE (checkerboard_page_get_type ())
#define CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPage))
#define CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))
#define IS_CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_PAGE))
#define IS_CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_PAGE))
#define CHECKERBOARD_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))

typedef struct _CheckerboardPage CheckerboardPage;
typedef struct _CheckerboardPageClass CheckerboardPageClass;

#define CORE_TYPE_TRACKER (core_tracker_get_type ())
#define CORE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_TRACKER, CoreTracker))
#define CORE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CORE_TYPE_TRACKER, CoreTrackerClass))
#define CORE_IS_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_TRACKER))
#define CORE_IS_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CORE_TYPE_TRACKER))
#define CORE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CORE_TYPE_TRACKER, CoreTrackerClass))

typedef struct _CoreTracker CoreTracker;
typedef struct _CoreTrackerClass CoreTrackerClass;

#define CORE_TYPE_VIEW_TRACKER (core_view_tracker_get_type ())
#define CORE_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_VIEW_TRACKER, CoreViewTracker))
#define CORE_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CORE_TYPE_VIEW_TRACKER, CoreViewTrackerClass))
#define CORE_IS_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_VIEW_TRACKER))
#define CORE_IS_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CORE_TYPE_VIEW_TRACKER))
#define CORE_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CORE_TYPE_VIEW_TRACKER, CoreViewTrackerClass))

typedef struct _CoreViewTracker CoreViewTracker;
typedef struct _CoreViewTrackerClass CoreViewTrackerClass;

#define TYPE_MEDIA_VIEW_TRACKER (media_view_tracker_get_type ())
#define MEDIA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_VIEW_TRACKER, MediaViewTracker))
#define MEDIA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_VIEW_TRACKER, MediaViewTrackerClass))
#define IS_MEDIA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_VIEW_TRACKER))
#define IS_MEDIA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_VIEW_TRACKER))
#define MEDIA_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_VIEW_TRACKER, MediaViewTrackerClass))

typedef struct _MediaViewTracker MediaViewTracker;
typedef struct _MediaViewTrackerClass MediaViewTrackerClass;

#define TYPE_CAMERA_VIEW_TRACKER (camera_view_tracker_get_type ())
#define CAMERA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAMERA_VIEW_TRACKER, CameraViewTracker))
#define CAMERA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAMERA_VIEW_TRACKER, CameraViewTrackerClass))
#define IS_CAMERA_VIEW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAMERA_VIEW_TRACKER))
#define IS_CAMERA_VIEW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAMERA_VIEW_TRACKER))
#define CAMERA_VIEW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAMERA_VIEW_TRACKER, CameraViewTrackerClass))

typedef struct _CameraViewTracker CameraViewTracker;
typedef struct _CameraViewTrackerClass CameraViewTrackerClass;
#define _core_tracker_unref0(var) ((var == NULL) ? NULL : (var = (core_tracker_unref (var), NULL)))
typedef struct _CoreTrackerPrivate CoreTrackerPrivate;
typedef struct _CoreViewTrackerPrivate CoreViewTrackerPrivate;
typedef struct _MediaViewTrackerPrivate MediaViewTrackerPrivate;

#define TYPE_MEDIA_ACCUMULATOR (media_accumulator_get_type ())
#define MEDIA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_ACCUMULATOR, MediaAccumulator))
#define MEDIA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_ACCUMULATOR, MediaAccumulatorClass))
#define IS_MEDIA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_ACCUMULATOR))
#define IS_MEDIA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_ACCUMULATOR))
#define MEDIA_ACCUMULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_ACCUMULATOR, MediaAccumulatorClass))

typedef struct _MediaAccumulator MediaAccumulator;
typedef struct _MediaAccumulatorClass MediaAccumulatorClass;

#define CORE_TYPE_TRACKER_ACCUMULATOR (core_tracker_accumulator_get_type ())
#define CORE_TRACKER_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CORE_TYPE_TRACKER_ACCUMULATOR, CoreTrackerAccumulator))
#define CORE_IS_TRACKER_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CORE_TYPE_TRACKER_ACCUMULATOR))
#define CORE_TRACKER_ACCUMULATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), CORE_TYPE_TRACKER_ACCUMULATOR, CoreTrackerAccumulatorIface))

typedef struct _CoreTrackerAccumulator CoreTrackerAccumulator;
typedef struct _CoreTrackerAccumulatorIface CoreTrackerAccumulatorIface;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _MediaAccumulatorPrivate MediaAccumulatorPrivate;
typedef struct _CameraViewTrackerPrivate CameraViewTrackerPrivate;

#define TYPE_CAMERA_ACCUMULATOR (camera_accumulator_get_type ())
#define CAMERA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAMERA_ACCUMULATOR, CameraAccumulator))
#define CAMERA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAMERA_ACCUMULATOR, CameraAccumulatorClass))
#define IS_CAMERA_ACCUMULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAMERA_ACCUMULATOR))
#define IS_CAMERA_ACCUMULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAMERA_ACCUMULATOR))
#define CAMERA_ACCUMULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAMERA_ACCUMULATOR, CameraAccumulatorClass))

typedef struct _CameraAccumulator CameraAccumulator;
typedef struct _CameraAccumulatorClass CameraAccumulatorClass;
typedef struct _ParamSpecSearchFilterActions ParamSpecSearchFilterActions;
enum  {
	SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL,
	SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL,
	SEARCH_FILTER_ACTIONS_NUM_SIGNALS
};
static guint search_filter_actions_signals[SEARCH_FILTER_ACTIONS_NUM_SIGNALS] = {0};

#define TYPE_SEARCH_FILTER_TOOLBAR (search_filter_toolbar_get_type ())
#define SEARCH_FILTER_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbar))
#define SEARCH_FILTER_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbarClass))
#define IS_SEARCH_FILTER_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_FILTER_TOOLBAR))
#define IS_SEARCH_FILTER_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_FILTER_TOOLBAR))
#define SEARCH_FILTER_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbarClass))

typedef struct _SearchFilterToolbar SearchFilterToolbar;
typedef struct _SearchFilterToolbarClass SearchFilterToolbarClass;
typedef struct _SearchFilterToolbarPrivate SearchFilterToolbarPrivate;

#define SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX (search_filter_toolbar_search_box_get_type ())
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBox))
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBoxClass))
#define SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX))
#define SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX))
#define SEARCH_FILTER_TOOLBAR_SEARCH_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBoxClass))

typedef struct _SearchFilterToolbarSearchBox SearchFilterToolbarSearchBox;
typedef struct _SearchFilterToolbarSearchBoxClass SearchFilterToolbarSearchBoxClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON (search_filter_toolbar_rating_filter_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButton))
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButtonClass))

typedef struct _SearchFilterToolbarRatingFilterButton SearchFilterToolbarRatingFilterButton;
typedef struct _SearchFilterToolbarRatingFilterButtonClass SearchFilterToolbarRatingFilterButtonClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON (search_filter_toolbar_saved_search_filter_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButton))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButtonClass))

typedef struct _SearchFilterToolbarSavedSearchFilterButton SearchFilterToolbarSavedSearchFilterButton;
typedef struct _SearchFilterToolbarSavedSearchFilterButtonClass SearchFilterToolbarSavedSearchFilterButtonClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM (search_filter_toolbar_label_tool_item_get_type ())
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItem))
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItemClass))
#define SEARCH_FILTER_TOOLBAR_IS_LABEL_TOOL_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM))
#define SEARCH_FILTER_TOOLBAR_IS_LABEL_TOOL_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM))
#define SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItemClass))

typedef struct _SearchFilterToolbarLabelToolItem SearchFilterToolbarLabelToolItem;
typedef struct _SearchFilterToolbarLabelToolItemClass SearchFilterToolbarLabelToolItemClass;

#define SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON (search_filter_toolbar_toggle_action_tool_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButton))
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButtonClass))
#define SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON))
#define SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON))
#define SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButtonClass))

typedef struct _SearchFilterToolbarToggleActionToolButton SearchFilterToolbarToggleActionToolButton;
typedef struct _SearchFilterToolbarToggleActionToolButtonClass SearchFilterToolbarToggleActionToolButtonClass;
enum  {
	SEARCH_FILTER_TOOLBAR_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_properties[SEARCH_FILTER_TOOLBAR_NUM_PROPERTIES];
#define _search_filter_actions_unref0(var) ((var == NULL) ? NULL : (var = (search_filter_actions_unref (var), NULL)))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SearchFilterToolbarSavedSearchFilterButtonPrivate SearchFilterToolbarSavedSearchFilterButtonPrivate;

#define SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER (search_filter_toolbar_saved_search_popover_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopover))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopoverClass))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER))
#define SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopoverClass))

typedef struct _SearchFilterToolbarSavedSearchPopover SearchFilterToolbarSavedSearchPopover;
typedef struct _SearchFilterToolbarSavedSearchPopoverClass SearchFilterToolbarSavedSearchPopoverClass;

#define TYPE_SAVED_SEARCH_DIALOG (saved_search_dialog_get_type ())
#define SAVED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialog))
#define SAVED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialogClass))
#define IS_SAVED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH_DIALOG))
#define IS_SAVED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH_DIALOG))
#define SAVED_SEARCH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH_DIALOG, SavedSearchDialogClass))

typedef struct _SavedSearchDialog SavedSearchDialog;
typedef struct _SavedSearchDialogClass SavedSearchDialogClass;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;

#define TYPE_PAGE_COMMAND (page_command_get_type ())
#define PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_COMMAND, PageCommand))
#define PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_COMMAND, PageCommandClass))
#define IS_PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_COMMAND))
#define IS_PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_COMMAND))
#define PAGE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_COMMAND, PageCommandClass))

typedef struct _PageCommand PageCommand;
typedef struct _PageCommandClass PageCommandClass;

#define TYPE_SINGLE_DATA_SOURCE_COMMAND (single_data_source_command_get_type ())
#define SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand))
#define SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))
#define IS_SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define IS_SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define SINGLE_DATA_SOURCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))

typedef struct _SingleDataSourceCommand SingleDataSourceCommand;
typedef struct _SingleDataSourceCommandClass SingleDataSourceCommandClass;

#define TYPE_DELETE_SAVED_SEARCH_COMMAND (delete_saved_search_command_get_type ())
#define DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand))
#define DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))
#define IS_DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define IS_DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define DELETE_SAVED_SEARCH_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))

typedef struct _DeleteSavedSearchCommand DeleteSavedSearchCommand;
typedef struct _DeleteSavedSearchCommandClass DeleteSavedSearchCommandClass;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _search_filter_toolbar_saved_search_popover_unref0(var) ((var == NULL) ? NULL : (var = (search_filter_toolbar_saved_search_popover_unref (var), NULL)))
typedef struct _SearchFilterToolbarLabelToolItemPrivate SearchFilterToolbarLabelToolItemPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_label_tool_item_properties[SEARCH_FILTER_TOOLBAR_LABEL_TOOL_ITEM_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarToggleActionToolButtonPrivate SearchFilterToolbarToggleActionToolButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_toggle_action_tool_button_properties[SEARCH_FILTER_TOOLBAR_TOGGLE_ACTION_TOOL_BUTTON_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarSearchBoxPrivate SearchFilterToolbarSearchBoxPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_SEARCH_BOX_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SEARCH_BOX_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_search_box_properties[SEARCH_FILTER_TOOLBAR_SEARCH_BOX_NUM_PROPERTIES];
typedef struct _SearchFilterToolbarRatingFilterButtonPrivate SearchFilterToolbarRatingFilterButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_rating_filter_button_properties[SEARCH_FILTER_TOOLBAR_RATING_FILTER_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_saved_search_filter_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_NUM_SIGNALS] = {0};
typedef struct _SearchFilterToolbarSavedSearchPopoverPrivate SearchFilterToolbarSavedSearchPopoverPrivate;

#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON (search_filter_toolbar_saved_search_popover_data_button_get_type ())
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButtonClass))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON))
#define SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButtonClass))

typedef struct _SearchFilterToolbarSavedSearchPopoverDataButton SearchFilterToolbarSavedSearchPopoverDataButton;
typedef struct _SearchFilterToolbarSavedSearchPopoverDataButtonClass SearchFilterToolbarSavedSearchPopoverDataButtonClass;

#define TYPE_SAVED_SEARCH_TABLE (saved_search_table_get_type ())
#define SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTable))
#define SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))
#define IS_SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH_TABLE))
#define IS_SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH_TABLE))
#define SAVED_SEARCH_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))

typedef struct _SavedSearchTable SavedSearchTable;
typedef struct _SavedSearchTableClass SavedSearchTableClass;
#define _saved_search_table_unref0(var) ((var == NULL) ? NULL : (var = (saved_search_table_unref (var), NULL)))
typedef struct _SearchFilterToolbarSavedSearchPopoverDataButtonPrivate SearchFilterToolbarSavedSearchPopoverDataButtonPrivate;
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_0_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_PROPERTIES
};
static GParamSpec* search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_PROPERTIES];
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_NUM_SIGNALS] = {0};
typedef struct _SearchFilterToolbarParamSpecSavedSearchPopover SearchFilterToolbarParamSpecSavedSearchPopover;
enum  {
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL,
	SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_NUM_SIGNALS
};
static guint search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _SearchViewFilter {
	ViewFilter parent_instance;
	SearchViewFilterPrivate * priv;
};

struct _SearchViewFilterClass {
	ViewFilterClass parent_class;
	guint (*get_criteria) (SearchViewFilter* self);
};

struct _SearchViewFilterPrivate {
	gboolean rating_allow_higher;
	Rating rating;
	RatingFilter rating_filter;
	gboolean _flagged;
	gboolean _show_media_video;
	gboolean _show_media_photos;
	gboolean _show_media_raw;
	gchar* search_filter;
	gchar** search_filter_words;
	gint search_filter_words_length1;
	gint _search_filter_words_size_;
	SavedSearch* _saved_search;
};

struct _DefaultSearchViewFilter {
	SearchViewFilter parent_instance;
	DefaultSearchViewFilterPrivate * priv;
};

struct _DefaultSearchViewFilterClass {
	SearchViewFilterClass parent_class;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _DisabledViewFilter {
	SearchViewFilter parent_instance;
	DisabledViewFilterPrivate * priv;
};

struct _DisabledViewFilterClass {
	SearchViewFilterClass parent_class;
};

struct _TextAction {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TextActionPrivate * priv;
};

struct _TextActionClass {
	GTypeClass parent_class;
	void (*finalize) (TextAction *self);
};

struct _TextActionPrivate {
	gchar* text;
	gboolean sensitive;
	gboolean visible;
};

struct _ParamSpecTextAction {
	GParamSpec parent_instance;
};

struct _SearchFilterActions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SearchFilterActionsPrivate * priv;
};

struct _SearchFilterActionsClass {
	GTypeClass parent_class;
	void (*finalize) (SearchFilterActions *self);
};

struct _SearchFilterActionsPrivate {
	SearchFilterCriteria criteria;
	TextAction* _text;
	gboolean has_flagged;
	gboolean has_photos;
	gboolean has_videos;
	gboolean has_raw;
	gboolean can_filter_by_stars;
};

struct _CoreTracker {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CoreTrackerPrivate * priv;
};

struct _CoreTrackerClass {
	GTypeClass parent_class;
	void (*finalize) (CoreTracker *self);
	void (*updated) (CoreTracker* self);
};

struct _CoreViewTracker {
	CoreTracker parent_instance;
	CoreViewTrackerPrivate * priv;
};

struct _CoreViewTrackerClass {
	CoreTrackerClass parent_class;
};

struct _MediaViewTracker {
	CoreViewTracker parent_instance;
	MediaViewTrackerPrivate * priv;
	MediaAccumulator* all;
	MediaAccumulator* visible;
	MediaAccumulator* selected;
};

struct _MediaViewTrackerClass {
	CoreViewTrackerClass parent_class;
};

struct _CoreTrackerAccumulatorIface {
	GTypeInterface parent_iface;
	gboolean (*include) (CoreTrackerAccumulator* self, DataObject* object);
	gboolean (*uninclude) (CoreTrackerAccumulator* self, DataObject* object);
	gboolean (*altered) (CoreTrackerAccumulator* self, DataObject* object, Alteration* alteration);
};

struct _MediaAccumulator {
	GObject parent_instance;
	MediaAccumulatorPrivate * priv;
	gint total;
	gint photos;
	gint videos;
	gint raw;
	gint flagged;
};

struct _MediaAccumulatorClass {
	GObjectClass parent_class;
};

struct _CameraViewTracker {
	CoreViewTracker parent_instance;
	CameraViewTrackerPrivate * priv;
	CameraAccumulator* all;
	CameraAccumulator* visible;
	CameraAccumulator* selected;
};

struct _CameraViewTrackerClass {
	CoreViewTrackerClass parent_class;
};

struct _ParamSpecSearchFilterActions {
	GParamSpec parent_instance;
};

struct _SearchFilterToolbar {
	GtkRevealer parent_instance;
	SearchFilterToolbarPrivate * priv;
	GtkBuilder* builder;
};

struct _SearchFilterToolbarClass {
	GtkRevealerClass parent_class;
};

struct _SearchFilterToolbarPrivate {
	GtkToolbar* toolbar;
	GtkMenu* close_menu;
	GtkMenuItem* close_item;
	SearchFilterActions* actions;
	SavedSearch* saved_search;
	SearchFilterToolbarSearchBox* search_box;
	SearchFilterToolbarRatingFilterButton* rating_button;
	SearchFilterToolbarSavedSearchFilterButton* saved_search_button;
	gboolean elide_showing_again;
	SearchViewFilter* search_filter;
	SearchFilterToolbarLabelToolItem* label_type;
	SearchFilterToolbarToggleActionToolButton* toolbtn_photos;
	SearchFilterToolbarToggleActionToolButton* toolbtn_videos;
	SearchFilterToolbarToggleActionToolButton* toolbtn_raw;
	SearchFilterToolbarToggleActionToolButton* toolbtn_flag;
	GtkSeparatorToolItem* sepr_mediatype_flagged;
	GtkSeparatorToolItem* sepr_flagged_rating;
	GtkSeparatorToolItem* sepr_rating_saved;
};

struct _SearchFilterToolbarSavedSearchFilterButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarSavedSearchFilterButtonPrivate * priv;
	SearchFilterToolbarSavedSearchPopover* filter_popup;
	GtkToggleButton* button;
};

struct _SearchFilterToolbarSavedSearchFilterButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarLabelToolItem {
	GtkToolItem parent_instance;
	SearchFilterToolbarLabelToolItemPrivate * priv;
};

struct _SearchFilterToolbarLabelToolItemClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarLabelToolItemPrivate {
	GtkLabel* label;
};

struct _SearchFilterToolbarToggleActionToolButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarToggleActionToolButtonPrivate * priv;
};

struct _SearchFilterToolbarToggleActionToolButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarToggleActionToolButtonPrivate {
	GtkToggleButton* button;
};

struct _SearchFilterToolbarSearchBox {
	GtkToolItem parent_instance;
	SearchFilterToolbarSearchBoxPrivate * priv;
};

struct _SearchFilterToolbarSearchBoxClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarSearchBoxPrivate {
	GtkSearchEntry* search_entry;
	TextAction* action;
};

struct _SearchFilterToolbarRatingFilterButton {
	GtkToolItem parent_instance;
	SearchFilterToolbarRatingFilterButtonPrivate * priv;
	GtkMenuButton* button;
};

struct _SearchFilterToolbarRatingFilterButtonClass {
	GtkToolItemClass parent_class;
};

struct _SearchFilterToolbarSavedSearchPopover {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SearchFilterToolbarSavedSearchPopoverPrivate * priv;
};

struct _SearchFilterToolbarSavedSearchPopoverClass {
	GTypeClass parent_class;
	void (*finalize) (SearchFilterToolbarSavedSearchPopover *self);
};

struct _SearchFilterToolbarSavedSearchPopoverPrivate {
	GtkPopover* popover;
	GtkListBox* list_box;
	SearchFilterToolbarSavedSearchPopoverDataButton** edit_buttons;
	gint edit_buttons_length1;
	gint _edit_buttons_size_;
	SearchFilterToolbarSavedSearchPopoverDataButton** delete_buttons;
	gint delete_buttons_length1;
	gint _delete_buttons_size_;
	GtkButton* add;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButton {
	GtkBin parent_instance;
	SearchFilterToolbarSavedSearchPopoverDataButtonPrivate * priv;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButtonClass {
	GtkBinClass parent_class;
};

struct _SearchFilterToolbarSavedSearchPopoverDataButtonPrivate {
	GtkButton* button;
	SavedSearch* _search;
};

struct _SearchFilterToolbarParamSpecSavedSearchPopover {
	GParamSpec parent_instance;
};

static gint SearchViewFilter_private_offset;
static gpointer search_view_filter_parent_class = NULL;
static gpointer default_search_view_filter_parent_class = NULL;
VALA_EXTERN TagSourceCollection* tag_global;
VALA_EXTERN FaceSourceCollection* face_global;
static gpointer disabled_view_filter_parent_class = NULL;
static gint TextAction_private_offset;
static gpointer text_action_parent_class = NULL;
static gint SearchFilterActions_private_offset;
static gpointer search_filter_actions_parent_class = NULL;
static gint SearchFilterToolbar_private_offset;
static gpointer search_filter_toolbar_parent_class = NULL;
static gint SearchFilterToolbarLabelToolItem_private_offset;
static gpointer search_filter_toolbar_label_tool_item_parent_class = NULL;
static gint SearchFilterToolbarToggleActionToolButton_private_offset;
static gpointer search_filter_toolbar_toggle_action_tool_button_parent_class = NULL;
static gint SearchFilterToolbarSearchBox_private_offset;
static gpointer search_filter_toolbar_search_box_parent_class = NULL;
static gpointer search_filter_toolbar_rating_filter_button_parent_class = NULL;
static gpointer search_filter_toolbar_saved_search_filter_button_parent_class = NULL;
static gint SearchFilterToolbarSavedSearchPopover_private_offset;
static gpointer search_filter_toolbar_saved_search_popover_parent_class = NULL;
static gint SearchFilterToolbarSavedSearchPopoverDataButton_private_offset;
static gpointer search_filter_toolbar_saved_search_popover_data_button_parent_class = NULL;

VALA_EXTERN GType search_filter_criteria_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rating_filter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer view_filter_ref (gpointer instance);
VALA_EXTERN void view_filter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_view_filter (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_view_filter (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_view_filter (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_view_filter (const GValue* value);
VALA_EXTERN GType view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewFilter, view_filter_unref)
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN GType data_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataView, g_object_unref)
VALA_EXTERN GType search_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchViewFilter, view_filter_unref)
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN GType saved_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearch, g_object_unref)
VALA_EXTERN guint search_view_filter_get_criteria (SearchViewFilter* self);
static guint search_view_filter_real_get_criteria (SearchViewFilter* self);
VALA_EXTERN void search_view_filter_set_rating_filter (SearchViewFilter* self,
                                           RatingFilter rf);
VALA_EXTERN gboolean search_view_filter_has_search_filter (SearchViewFilter* self);
VALA_EXTERN gboolean is_string_empty (const gchar* s);
VALA_EXTERN const gchar* search_view_filter_get_search_filter (SearchViewFilter* self);
VALA_EXTERN gchar** search_view_filter_get_search_filter_words (SearchViewFilter* self,
                                                    gint* result_length1);
VALA_EXTERN void search_view_filter_set_search_filter (SearchViewFilter* self,
                                           const gchar* text);
VALA_EXTERN gchar* string_remove_diacritics (const gchar* istring);
static gchar** _vala_array_dup36 (gchar** self,
                           gssize length);
VALA_EXTERN void search_view_filter_clear_search_filter (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_has_saved_search (SearchViewFilter* self);
VALA_EXTERN SavedSearch* search_view_filter_get_saved_search (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_get_rating_allow_higher (SearchViewFilter* self);
VALA_EXTERN Rating search_view_filter_get_rating (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_filter_by_media_type (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_get_show_media_video (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_get_show_media_photos (SearchViewFilter* self);
VALA_EXTERN gboolean search_view_filter_get_show_media_raw (SearchViewFilter* self);
VALA_EXTERN SearchViewFilter* search_view_filter_construct (GType object_type);
VALA_EXTERN ViewFilter* view_filter_construct (GType object_type);
VALA_EXTERN gboolean search_view_filter_get_flagged (SearchViewFilter* self);
VALA_EXTERN void search_view_filter_set_flagged (SearchViewFilter* self,
                                     gboolean value);
VALA_EXTERN void search_view_filter_set_show_media_video (SearchViewFilter* self,
                                              gboolean value);
VALA_EXTERN void search_view_filter_set_show_media_photos (SearchViewFilter* self,
                                               gboolean value);
VALA_EXTERN void search_view_filter_set_show_media_raw (SearchViewFilter* self,
                                            gboolean value);
VALA_EXTERN void search_view_filter_set_saved_search (SearchViewFilter* self,
                                          SavedSearch* value);
static void search_view_filter_finalize (ViewFilter * obj);
static GType search_view_filter_get_type_once (void);
VALA_EXTERN GType default_search_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DefaultSearchViewFilter, view_filter_unref)
VALA_EXTERN gboolean view_filter_predicate (ViewFilter* self,
                                DataView* view);
static gboolean default_search_view_filter_real_predicate (ViewFilter* base,
                                                    DataView* view);
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GType thumbnail_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailView, g_object_unref)
VALA_EXTERN GType checkerboard_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardItem, g_object_unref)
VALA_EXTERN GType media_source_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceItem, g_object_unref)
VALA_EXTERN GType thumbnail_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnail, g_object_unref)
VALA_EXTERN MediaSource* thumbnail_get_media_source (Thumbnail* self);
VALA_EXTERN Rating media_source_get_rating (MediaSource* self);
VALA_EXTERN GType flaggable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Flaggable, g_object_unref)
VALA_EXTERN gboolean flaggable_is_flagged (Flaggable* self);
VALA_EXTERN GType video_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSource, g_object_unref)
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoFileFormat photo_get_master_file_format (Photo* self);
VALA_EXTERN GType indexable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Indexable, g_object_unref)
VALA_EXTERN const gchar* indexable_get_indexable_keywords (Indexable* self);
VALA_EXTERN GType event_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSource, g_object_unref)
VALA_EXTERN GType event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Event, g_object_unref)
VALA_EXTERN Event* media_source_get_event (MediaSource* self);
VALA_EXTERN GType tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tag, g_object_unref)
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
VALA_EXTERN GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
VALA_EXTERN GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
VALA_EXTERN GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
VALA_EXTERN GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
VALA_EXTERN GType face_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Face, g_object_unref)
VALA_EXTERN GType face_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceSourceCollection, data_collection_unref)
VALA_EXTERN GeeList* face_source_collection_fetch_for_source (FaceSourceCollection* self,
                                                  MediaSource* source);
VALA_EXTERN gboolean saved_search_predicate (SavedSearch* self,
                                 MediaSource* source);
VALA_EXTERN DefaultSearchViewFilter* default_search_view_filter_construct (GType object_type);
static GType default_search_view_filter_get_type_once (void);
VALA_EXTERN GType disabled_view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisabledViewFilter, view_filter_unref)
static gboolean disabled_view_filter_real_predicate (ViewFilter* base,
                                              DataView* view);
static guint disabled_view_filter_real_get_criteria (SearchViewFilter* base);
VALA_EXTERN DisabledViewFilter* disabled_view_filter_new (void);
VALA_EXTERN DisabledViewFilter* disabled_view_filter_construct (GType object_type);
static GType disabled_view_filter_get_type_once (void);
VALA_EXTERN gpointer text_action_ref (gpointer instance);
VALA_EXTERN void text_action_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_text_action (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_text_action (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_text_action (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_text_action (const GValue* value);
VALA_EXTERN GType text_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TextAction, text_action_unref)
VALA_EXTERN TextAction* text_action_new (const gchar* init);
VALA_EXTERN TextAction* text_action_construct (GType object_type,
                                   const gchar* init);
VALA_EXTERN void text_action_set_text (TextAction* self,
                           const gchar* text);
VALA_EXTERN void text_action_clear (TextAction* self);
VALA_EXTERN gboolean text_action_is_sensitive (TextAction* self);
VALA_EXTERN void text_action_set_sensitive (TextAction* self,
                                gboolean sensitive);
VALA_EXTERN gboolean text_action_is_visible (TextAction* self);
VALA_EXTERN void text_action_set_visible (TextAction* self,
                              gboolean visible);
VALA_EXTERN const gchar* text_action_get_value (TextAction* self);
static void text_action_finalize (TextAction * obj);
static GType text_action_get_type_once (void);
VALA_EXTERN gpointer search_filter_actions_ref (gpointer instance);
VALA_EXTERN void search_filter_actions_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_search_filter_actions (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void value_set_search_filter_actions (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void value_take_search_filter_actions (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer value_get_search_filter_actions (const GValue* value);
VALA_EXTERN GType search_filter_actions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterActions, search_filter_actions_unref)
static void search_filter_actions_on_action_radio (SearchFilterActions* self,
                                            GSimpleAction* action,
                                            GVariant* parameter);
static void _search_filter_actions_on_action_radio_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void search_filter_actions_on_rating_changed (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_rating_changed_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_action_toggle (SearchFilterActions* self,
                                             GSimpleAction* action,
                                             GVariant* parameter);
static void _search_filter_actions_on_action_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void search_filter_actions_on_flagged_toggled (SearchFilterActions* self,
                                               GSimpleAction* action,
                                               GVariant* value);
static void _search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                     GVariant* value,
                                                                                     gpointer self);
static void search_filter_actions_on_photos_toggled (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_videos_toggled (SearchFilterActions* self,
                                              GSimpleAction* action,
                                              GVariant* value);
static void _search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                    GVariant* value,
                                                                                    gpointer self);
static void search_filter_actions_on_raw_toggled (SearchFilterActions* self,
                                           GSimpleAction* action,
                                           GVariant* value);
static void _search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                 GVariant* value,
                                                                                 gpointer self);
VALA_EXTERN SearchFilterActions* search_filter_actions_new (void);
VALA_EXTERN SearchFilterActions* search_filter_actions_construct (GType object_type);
static void search_filter_actions_register (SearchFilterActions* self);
VALA_EXTERN TextAction* search_filter_actions_get_text (SearchFilterActions* self);
static void search_filter_actions_on_text_changed (SearchFilterActions* self,
                                            TextAction* action,
                                            const gchar* text);
static void _search_filter_actions_on_text_changed_text_action_text_changed (TextAction* _sender,
                                                                      const gchar* text,
                                                                      gpointer self);
VALA_EXTERN SearchFilterCriteria search_filter_actions_get_criteria (SearchFilterActions* self);
VALA_EXTERN GActionEntry* search_filter_actions_get_actions (SearchFilterActions* self,
                                                 gint* result_length1);
VALA_EXTERN GSimpleAction* search_filter_actions_get_action (SearchFilterActions* self,
                                                 const gchar* name);
VALA_EXTERN GType page_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageWindow, g_object_unref)
VALA_EXTERN GType app_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWindow, g_object_unref)
VALA_EXTERN GType library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryWindow, g_object_unref)
VALA_EXTERN AppWindow* app_window_get_instance (void);
VALA_EXTERN void search_filter_actions_set_action_sensitive (SearchFilterActions* self,
                                                 const gchar* name,
                                                 gboolean sensitive);
VALA_EXTERN void search_filter_actions_reset (SearchFilterActions* self);
VALA_EXTERN GSimpleAction* search_filter_actions_get_flagged (SearchFilterActions* self);
static GVariant* _variant_new29 (gboolean value);
VALA_EXTERN GSimpleAction* search_filter_actions_get_photos (SearchFilterActions* self);
static GVariant* _variant_new30 (gboolean value);
VALA_EXTERN GSimpleAction* search_filter_actions_get_raw (SearchFilterActions* self);
static GVariant* _variant_new31 (gboolean value);
VALA_EXTERN GSimpleAction* search_filter_actions_get_videos (SearchFilterActions* self);
static GVariant* _variant_new32 (gboolean value);
static GVariant* _variant_new33 (gchar* value);
VALA_EXTERN GSimpleAction* search_filter_actions_get_rating (SearchFilterActions* self);
VALA_EXTERN void search_filter_actions_set_sensitive_for_search_criteria (SearchFilterActions* self,
                                                              SearchFilterCriteria criteria);
static void search_filter_actions_update_sensitivities (SearchFilterActions* self);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN void search_filter_actions_monitor_page_contents (SearchFilterActions* self,
                                                  Page* old_page,
                                                  Page* new_page);
VALA_EXTERN GType checkerboard_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardPage, g_object_unref)
VALA_EXTERN gpointer core_tracker_ref (gpointer instance);
VALA_EXTERN void core_tracker_unref (gpointer instance);
VALA_EXTERN GParamSpec* core_param_spec_tracker (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void core_value_set_tracker (GValue* value,
                             gpointer v_object);
VALA_EXTERN void core_value_take_tracker (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer core_value_get_tracker (const GValue* value);
VALA_EXTERN GType core_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CoreTracker, core_tracker_unref)
VALA_EXTERN GType core_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CoreViewTracker, core_tracker_unref)
VALA_EXTERN CoreViewTracker* checkerboard_page_get_view_tracker (CheckerboardPage* self);
VALA_EXTERN GType media_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaViewTracker, core_tracker_unref)
static void search_filter_actions_on_media_tracker_updated (SearchFilterActions* self,
                                                     CoreTracker* t);
static void _search_filter_actions_on_media_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                           gpointer self);
VALA_EXTERN GType camera_view_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraViewTracker, core_tracker_unref)
static void search_filter_actions_on_camera_tracker_updated (SearchFilterActions* self,
                                                      CoreTracker* t);
static void _search_filter_actions_on_camera_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                            gpointer self);
VALA_EXTERN GType media_accumulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaAccumulator, g_object_unref)
VALA_EXTERN gpointer alteration_ref (gpointer instance);
VALA_EXTERN void alteration_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_alteration (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_alteration (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_alteration (const GValue* value);
VALA_EXTERN GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
VALA_EXTERN GType core_tracker_accumulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CoreTrackerAccumulator, g_object_unref)
VALA_EXTERN GType camera_accumulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraAccumulator, g_object_unref)
VALA_EXTERN gint camera_accumulator_get_photos (CameraAccumulator* self);
VALA_EXTERN gint camera_accumulator_get_videos (CameraAccumulator* self);
VALA_EXTERN gint camera_accumulator_get_raw (CameraAccumulator* self);
static gboolean _variant_get3 (GVariant* value);
static GVariant* _variant_new34 (gboolean value);
VALA_EXTERN gboolean search_filter_actions_get_has_photos (SearchFilterActions* self);
VALA_EXTERN gboolean search_filter_actions_get_has_videos (SearchFilterActions* self);
VALA_EXTERN gboolean search_filter_actions_get_has_raw (SearchFilterActions* self);
VALA_EXTERN gboolean search_filter_actions_get_has_flagged (SearchFilterActions* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN (GClosure * closure,
                                                                    GValue * return_value,
                                                                    guint n_param_values,
                                                                    const GValue * param_values,
                                                                    gpointer invocation_hint,
                                                                    gpointer marshal_data);
static void search_filter_actions_finalize (SearchFilterActions * obj);
static GType search_filter_actions_get_type_once (void);
VALA_EXTERN GType search_filter_toolbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbar, g_object_unref)
VALA_EXTERN GType search_filter_toolbar_search_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSearchBox, g_object_unref)
VALA_EXTERN GType search_filter_toolbar_rating_filter_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarRatingFilterButton, g_object_unref)
VALA_EXTERN GType search_filter_toolbar_saved_search_filter_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchFilterButton, g_object_unref)
static GType search_filter_toolbar_label_tool_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarLabelToolItem, g_object_unref)
static GType search_filter_toolbar_toggle_action_tool_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarToggleActionToolButton, g_object_unref)
static void search_filter_toolbar_on_media_context_changed (SearchFilterToolbar* self,
                                                     gboolean has_photos,
                                                     gboolean has_videos,
                                                     gboolean has_raw,
                                                     gboolean has_flagged);
static void _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed (SearchFilterActions* _sender,
                                                                                                  gboolean has_photos,
                                                                                                  gboolean has_videos,
                                                                                                  gboolean has_raw,
                                                                                                  gboolean has_flagged,
                                                                                                  gpointer self);
static void search_filter_toolbar_on_flagged_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled (SearchFilterActions* _sender,
                                                                                      gboolean on,
                                                                                      gpointer self);
static void search_filter_toolbar_on_photos_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled (SearchFilterActions* _sender,
                                                                                    gboolean on,
                                                                                    gpointer self);
static void search_filter_toolbar_on_videos_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled (SearchFilterActions* _sender,
                                                                                    gboolean on,
                                                                                    gpointer self);
static void search_filter_toolbar_on_raw_toggled (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled (SearchFilterActions* _sender,
                                                                              gboolean on,
                                                                              gpointer self);
static void search_filter_toolbar_on_rating_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed (SearchFilterActions* _sender,
                                                                                    RatingFilter filter,
                                                                                    gpointer self);
static void search_filter_toolbar_on_search_text_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed (SearchFilterActions* _sender,
                                                                                       const gchar* text,
                                                                                       gpointer self);
static void search_filter_toolbar_on_criteria_changed (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed (SearchFilterActions* _sender,
                                                                                        gpointer self);
static gboolean search_filter_toolbar_on_context_menu_requested (SearchFilterToolbar* self,
                                                          gint x,
                                                          gint y,
                                                          gint button);
static gboolean _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu (GtkToolbar* _sender,
                                                                                          gint x,
                                                                                          gint y,
                                                                                          gint button_number,
                                                                                          gpointer self);
VALA_EXTERN SearchFilterToolbarSavedSearchFilterButton* search_filter_toolbar_saved_search_filter_button_new (void);
VALA_EXTERN SearchFilterToolbarSavedSearchFilterButton* search_filter_toolbar_saved_search_filter_button_construct (GType object_type);
VALA_EXTERN SearchFilterToolbar* search_filter_toolbar_new (SearchFilterActions* actions);
VALA_EXTERN SearchFilterToolbar* search_filter_toolbar_construct (GType object_type,
                                                      SearchFilterActions* actions);
VALA_EXTERN SearchFilterToolbarSearchBox* search_filter_toolbar_search_box_new (TextAction* action);
VALA_EXTERN SearchFilterToolbarSearchBox* search_filter_toolbar_search_box_construct (GType object_type,
                                                                          TextAction* action);
VALA_EXTERN gchar* resources_get_ui (const gchar* filename);
VALA_EXTERN void app_window_panic (const gchar* msg);
static void search_filter_toolbar_on_context_menu_close_chosen (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                                 gpointer self);
static SearchFilterToolbarLabelToolItem* search_filter_toolbar_label_tool_item_new (const gchar* s,
                                                                             gint left_padding,
                                                                             gint right_padding);
static SearchFilterToolbarLabelToolItem* search_filter_toolbar_label_tool_item_construct (GType object_type,
                                                                                   const gchar* s,
                                                                                   gint left_padding,
                                                                                   gint right_padding);
static SearchFilterToolbarToggleActionToolButton* search_filter_toolbar_toggle_action_tool_button_new (const gchar* action);
static SearchFilterToolbarToggleActionToolButton* search_filter_toolbar_toggle_action_tool_button_construct (GType object_type,
                                                                                                      const gchar* action);
static void search_filter_toolbar_toggle_action_tool_button_set_label (SearchFilterToolbarToggleActionToolButton* self,
                                                                const gchar* label);
VALA_EXTERN SearchFilterToolbarRatingFilterButton* search_filter_toolbar_rating_filter_button_new (GMenuModel* model);
VALA_EXTERN SearchFilterToolbarRatingFilterButton* search_filter_toolbar_rating_filter_button_construct (GType object_type,
                                                                                             GMenuModel* model);
VALA_EXTERN void search_filter_toolbar_rating_filter_button_set_label (SearchFilterToolbarRatingFilterButton* self,
                                                           const gchar* label);
VALA_EXTERN void search_filter_toolbar_saved_search_filter_button_set_label (SearchFilterToolbarSavedSearchFilterButton* self,
                                                                 const gchar* label);
static void search_filter_toolbar_on_saved_search_button_clicked (SearchFilterToolbar* self);
static void _search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked (SearchFilterToolbarSavedSearchFilterButton* _sender,
                                                                                                                     gpointer self);
static void search_filter_toolbar_toggle_action_tool_button_set_icon_name (SearchFilterToolbarToggleActionToolButton* self,
                                                                    const gchar* icon_name);
VALA_EXTERN LibraryWindow* library_window_get_app (void);
static GVariant* _variant_new35 (gboolean value);
VALA_EXTERN void search_filter_toolbar_update (SearchFilterToolbar* self);
static GVariant* _variant_new36 (gboolean value);
VALA_EXTERN void search_filter_toolbar_set_view_filter (SearchFilterToolbar* self,
                                            SearchViewFilter* search_filter);
VALA_EXTERN void search_filter_toolbar_unset_view_filter (SearchFilterToolbar* self);
VALA_EXTERN void library_window_show_search_bar (LibraryWindow* self,
                                     gboolean display);
VALA_EXTERN void search_filter_toolbar_rating_filter_button_set_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                                 RatingFilter filter);
static void search_filter_toolbar_on_savedsearch_selected (SearchFilterToolbar* self,
                                                    SavedSearch* saved_search);
static void search_filter_toolbar_disable_savedsearch (SearchFilterToolbar* self);
static void search_filter_toolbar_edit_dialog (SearchFilterToolbar* self,
                                        SavedSearch* search);
VALA_EXTERN gpointer search_filter_toolbar_saved_search_popover_ref (gpointer instance);
VALA_EXTERN void search_filter_toolbar_saved_search_popover_unref (gpointer instance);
VALA_EXTERN GParamSpec* search_filter_toolbar_param_spec_saved_search_popover (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags);
VALA_EXTERN void search_filter_toolbar_value_set_saved_search_popover (GValue* value,
                                                           gpointer v_object);
VALA_EXTERN void search_filter_toolbar_value_take_saved_search_popover (GValue* value,
                                                            gpointer v_object);
VALA_EXTERN gpointer search_filter_toolbar_value_get_saved_search_popover (const GValue* value);
VALA_EXTERN GType search_filter_toolbar_saved_search_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchPopover, search_filter_toolbar_saved_search_popover_unref)
VALA_EXTERN void search_filter_toolbar_saved_search_popover_hide (SearchFilterToolbarSavedSearchPopover* self);
VALA_EXTERN GType saved_search_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearchDialog, g_object_unref)
VALA_EXTERN SavedSearchDialog* saved_search_dialog_new_edit_existing (SavedSearch* saved_search);
VALA_EXTERN SavedSearchDialog* saved_search_dialog_construct_edit_existing (GType object_type,
                                                                SavedSearch* saved_search);
VALA_EXTERN void saved_search_dialog_show (SavedSearchDialog* self);
static void search_filter_toolbar_delete_dialog (SearchFilterToolbar* self,
                                          SavedSearch* search);
VALA_EXTERN gboolean dialogs_confirm_delete_saved_search (SavedSearch* search);
VALA_EXTERN gpointer command_manager_ref (gpointer instance);
VALA_EXTERN void command_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_command_manager (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_command_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_command_manager (const GValue* value);
VALA_EXTERN GType command_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandManager, command_manager_unref)
VALA_EXTERN CommandManager* app_window_get_command_manager (void);
VALA_EXTERN GType command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
VALA_EXTERN void command_manager_execute (CommandManager* self,
                              Command* command);
VALA_EXTERN DeleteSavedSearchCommand* delete_saved_search_command_new (SavedSearch* search);
VALA_EXTERN DeleteSavedSearchCommand* delete_saved_search_command_construct (GType object_type,
                                                                 SavedSearch* search);
VALA_EXTERN GType page_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageCommand, g_object_unref)
VALA_EXTERN GType single_data_source_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SingleDataSourceCommand, g_object_unref)
VALA_EXTERN GType delete_saved_search_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteSavedSearchCommand, g_object_unref)
static void search_filter_toolbar_add_dialog (SearchFilterToolbar* self);
VALA_EXTERN SavedSearchDialog* saved_search_dialog_new (void);
VALA_EXTERN SavedSearchDialog* saved_search_dialog_construct (GType object_type);
static void search_filter_toolbar_on_popover_closed (SearchFilterToolbar* self);
VALA_EXTERN void search_filter_toolbar_saved_search_filter_button_set_active (SearchFilterToolbarSavedSearchFilterButton* self,
                                                                  gboolean active);
static void _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                 SavedSearch* search,
                                                                                                 gpointer self);
static void _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                                 SavedSearch* search,
                                                                                                                 gpointer self);
static void _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                     SavedSearch* search,
                                                                                                     gpointer self);
static void _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                               gpointer self);
static void _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                 gpointer self);
VALA_EXTERN SearchFilterToolbarSavedSearchPopover* search_filter_toolbar_saved_search_popover_new (GtkWidget* relative_to);
VALA_EXTERN SearchFilterToolbarSavedSearchPopover* search_filter_toolbar_saved_search_popover_construct (GType object_type,
                                                                                             GtkWidget* relative_to);
VALA_EXTERN void search_filter_toolbar_saved_search_popover_show_all (SearchFilterToolbarSavedSearchPopover* self);
VALA_EXTERN void search_filter_toolbar_take_focus (SearchFilterToolbar* self);
VALA_EXTERN void search_filter_toolbar_search_box_get_focus (SearchFilterToolbarSearchBox* self);
static void search_filter_toolbar_label_tool_item_finalize (GObject * obj);
static GType search_filter_toolbar_label_tool_item_get_type_once (void);
static void search_filter_toolbar_toggle_action_tool_button_finalize (GObject * obj);
static GType search_filter_toolbar_toggle_action_tool_button_get_type_once (void);
static void search_filter_toolbar_search_box_on_action_text_changed (SearchFilterToolbarSearchBox* self,
                                                              const gchar* text);
static void _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed (TextAction* _sender,
                                                                                        const gchar* text,
                                                                                        gpointer self);
static void search_filter_toolbar_search_box_on_sensitivity_changed (SearchFilterToolbarSearchBox* self,
                                                              gboolean sensitive);
static void _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed (TextAction* _sender,
                                                                                               gboolean sensitive,
                                                                                               gpointer self);
static void search_filter_toolbar_search_box_on_visibility_changed (SearchFilterToolbarSearchBox* self,
                                                             gboolean visible);
static void _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed (TextAction* _sender,
                                                                                             gboolean visible,
                                                                                             gpointer self);
static void search_filter_toolbar_search_box_on_entry_changed (SearchFilterToolbarSearchBox* self);
static void _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                                       guint position,
                                                                                       guint n_chars,
                                                                                       gpointer self);
static void _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                                        guint position,
                                                                                        const gchar* chars,
                                                                                        guint n_chars,
                                                                                        gpointer self);
static gboolean search_filter_toolbar_search_box_on_escape_key (SearchFilterToolbarSearchBox* self,
                                                         GdkEventKey* e);
static gboolean _search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                     GdkEventKey* event,
                                                                                     gpointer self);
static void search_filter_toolbar_search_box_set_nullable_text (SearchFilterToolbarSearchBox* self,
                                                         const gchar* text);
static void search_filter_toolbar_search_box_finalize (GObject * obj);
static GType search_filter_toolbar_search_box_get_type_once (void);
static GtkWidget* search_filter_toolbar_rating_filter_button_get_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                                       RatingFilter filter);
static gint search_filter_toolbar_rating_filter_button_get_filter_icon_size (SearchFilterToolbarRatingFilterButton* self,
                                                                      RatingFilter filter);
static gint search_filter_toolbar_rating_filter_button_get_filter_button_size (SearchFilterToolbarRatingFilterButton* self,
                                                                        RatingFilter filter);
VALA_EXTERN gchar* resources_get_rating_filter_tooltip (RatingFilter filter);
static void search_filter_toolbar_rating_filter_button_finalize (GObject * obj);
static GType search_filter_toolbar_rating_filter_button_get_type_once (void);
static void search_filter_toolbar_saved_search_filter_button_on_clicked (SearchFilterToolbarSavedSearchFilterButton* self);
static void _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                      gpointer self);
VALA_EXTERN void search_filter_toolbar_saved_search_filter_button_restyle (SearchFilterToolbarSavedSearchFilterButton* self);
static void search_filter_toolbar_saved_search_filter_button_finalize (GObject * obj);
static GType search_filter_toolbar_saved_search_filter_button_get_type_once (void);
static GType search_filter_toolbar_saved_search_popover_data_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchFilterToolbarSavedSearchPopoverDataButton, g_object_unref)
static void search_filter_toolbar_saved_search_popover_on_edit_click (SearchFilterToolbarSavedSearchPopover* self,
                                                               SavedSearch* search);
static void _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                               SavedSearch* search,
                                                                                                                               gpointer self);
static void search_filter_toolbar_saved_search_popover_on_delete_click (SearchFilterToolbarSavedSearchPopover* self,
                                                                 SavedSearch* search);
static void _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                                 SavedSearch* search,
                                                                                                                                 gpointer self);
static void search_filter_toolbar_saved_search_popover_on_add_click (SearchFilterToolbarSavedSearchPopover* self);
static void _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static void search_filter_toolbar_saved_search_popover_on_activate_row (SearchFilterToolbarSavedSearchPopover* self,
                                                                 GtkListBoxRow* row);
static void _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                             GtkListBoxRow* row,
                                                                                             gpointer self);
static void search_filter_toolbar_saved_search_popover_on_popover_closed (SearchFilterToolbarSavedSearchPopover* self);
static void _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed (GtkPopover* _sender,
                                                                                       gpointer self);
VALA_EXTERN gpointer saved_search_table_ref (gpointer instance);
VALA_EXTERN void saved_search_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_saved_search_table (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_saved_search_table (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_saved_search_table (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_saved_search_table (const GValue* value);
VALA_EXTERN GType saved_search_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearchTable, saved_search_table_unref)
VALA_EXTERN SavedSearchTable* saved_search_table_get_instance (void);
VALA_EXTERN GeeCollection* saved_search_table_get_all (SavedSearchTable* self);
VALA_EXTERN gchar* data_object_get_name (DataObject* self);
static SearchFilterToolbarSavedSearchPopoverDataButton* search_filter_toolbar_saved_search_popover_data_button_new (SavedSearch* search,
                                                                                                             const gchar* name);
static SearchFilterToolbarSavedSearchPopoverDataButton* search_filter_toolbar_saved_search_popover_data_button_construct (GType object_type,
                                                                                                                   SavedSearch* search,
                                                                                                                   const gchar* name);
static void _vala_array_add129 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                         gint* length,
                         gint* size,
                         SearchFilterToolbarSavedSearchPopoverDataButton* value);
static void _vala_array_add130 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                         gint* length,
                         gint* size,
                         SearchFilterToolbarSavedSearchPopoverDataButton* value);
VALA_EXTERN void search_filter_toolbar_saved_search_popover_restyle (SearchFilterToolbarSavedSearchPopover* self);
static void search_filter_toolbar_saved_search_popover_data_button_restyle (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static gboolean search_filter_toolbar_saved_search_popover_is_search_row (SearchFilterToolbarSavedSearchPopover* self,
                                                                   GtkListBoxRow* row);
static SavedSearch* search_filter_toolbar_saved_search_popover_get_search (SearchFilterToolbarSavedSearchPopover* self,
                                                                    GtkListBoxRow* row);
static SavedSearch* search_filter_toolbar_saved_search_popover_data_button_get_search (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static void search_filter_toolbar_saved_search_popover_data_button_on_click (SearchFilterToolbarSavedSearchPopoverDataButton* self);
static void _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked (GtkButton* _sender,
                                                                                          gpointer self);
static void search_filter_toolbar_saved_search_popover_data_button_set_search (SearchFilterToolbarSavedSearchPopoverDataButton* self,
                                                                        SavedSearch* value);
static void search_filter_toolbar_saved_search_popover_data_button_finalize (GObject * obj);
static GType search_filter_toolbar_saved_search_popover_data_button_get_type_once (void);
static void _vala_search_filter_toolbar_saved_search_popover_data_button_get_property (GObject * object,
                                                                                guint property_id,
                                                                                GValue * value,
                                                                                GParamSpec * pspec);
static void _vala_search_filter_toolbar_saved_search_popover_data_button_set_property (GObject * object,
                                                                                guint property_id,
                                                                                const GValue * value,
                                                                                GParamSpec * pspec);
static void search_filter_toolbar_saved_search_popover_finalize (SearchFilterToolbarSavedSearchPopover * obj);
static GType search_filter_toolbar_saved_search_popover_get_type_once (void);
static void search_filter_toolbar_finalize (GObject * obj);
static GType search_filter_toolbar_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry SEARCH_FILTER_ACTIONS_entries[5] = {{"display.rating", _search_filter_actions_on_action_radio_gsimple_action_activate_callback, "s", "'2'", _search_filter_actions_on_rating_changed_gsimple_action_change_state_callback}, {"display.flagged", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback}, {"display.photos", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback}, {"display.videos", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback}, {"display.raw", _search_filter_actions_on_action_toggle_gsimple_action_activate_callback, NULL, "false", _search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback}};

static GType
search_filter_criteria_get_type_once (void)
{
	static const GFlagsValue values[] = {{SEARCH_FILTER_CRITERIA_NONE, "SEARCH_FILTER_CRITERIA_NONE", "none"}, {SEARCH_FILTER_CRITERIA_RECURSIVE, "SEARCH_FILTER_CRITERIA_RECURSIVE", "recursive"}, {SEARCH_FILTER_CRITERIA_TEXT, "SEARCH_FILTER_CRITERIA_TEXT", "text"}, {SEARCH_FILTER_CRITERIA_FLAG, "SEARCH_FILTER_CRITERIA_FLAG", "flag"}, {SEARCH_FILTER_CRITERIA_MEDIA, "SEARCH_FILTER_CRITERIA_MEDIA", "media"}, {SEARCH_FILTER_CRITERIA_RATING, "SEARCH_FILTER_CRITERIA_RATING", "rating"}, {SEARCH_FILTER_CRITERIA_SAVEDSEARCH, "SEARCH_FILTER_CRITERIA_SAVEDSEARCH", "savedsearch"}, {SEARCH_FILTER_CRITERIA_ALL, "SEARCH_FILTER_CRITERIA_ALL", "all"}, {0, NULL, NULL}};
	GType search_filter_criteria_type_id;
	search_filter_criteria_type_id = g_flags_register_static ("SearchFilterCriteria", values);
	return search_filter_criteria_type_id;
}

GType
search_filter_criteria_get_type (void)
{
	static volatile gsize search_filter_criteria_type_id__once = 0;
	if (g_once_init_enter (&search_filter_criteria_type_id__once)) {
		GType search_filter_criteria_type_id;
		search_filter_criteria_type_id = search_filter_criteria_get_type_once ();
		g_once_init_leave (&search_filter_criteria_type_id__once, search_filter_criteria_type_id);
	}
	return search_filter_criteria_type_id__once;
}

static GType
rating_filter_get_type_once (void)
{
	static const GEnumValue values[] = {{RATING_FILTER_NO_FILTER, "RATING_FILTER_NO_FILTER", "no-filter"}, {RATING_FILTER_REJECTED_OR_HIGHER, "RATING_FILTER_REJECTED_OR_HIGHER", "rejected-or-higher"}, {RATING_FILTER_UNRATED_OR_HIGHER, "RATING_FILTER_UNRATED_OR_HIGHER", "unrated-or-higher"}, {RATING_FILTER_ONE_OR_HIGHER, "RATING_FILTER_ONE_OR_HIGHER", "one-or-higher"}, {RATING_FILTER_TWO_OR_HIGHER, "RATING_FILTER_TWO_OR_HIGHER", "two-or-higher"}, {RATING_FILTER_THREE_OR_HIGHER, "RATING_FILTER_THREE_OR_HIGHER", "three-or-higher"}, {RATING_FILTER_FOUR_OR_HIGHER, "RATING_FILTER_FOUR_OR_HIGHER", "four-or-higher"}, {RATING_FILTER_FIVE_OR_HIGHER, "RATING_FILTER_FIVE_OR_HIGHER", "five-or-higher"}, {RATING_FILTER_REJECTED_ONLY, "RATING_FILTER_REJECTED_ONLY", "rejected-only"}, {RATING_FILTER_UNRATED_ONLY, "RATING_FILTER_UNRATED_ONLY", "unrated-only"}, {RATING_FILTER_ONE_ONLY, "RATING_FILTER_ONE_ONLY", "one-only"}, {RATING_FILTER_TWO_ONLY, "RATING_FILTER_TWO_ONLY", "two-only"}, {RATING_FILTER_THREE_ONLY, "RATING_FILTER_THREE_ONLY", "three-only"}, {RATING_FILTER_FOUR_ONLY, "RATING_FILTER_FOUR_ONLY", "four-only"}, {RATING_FILTER_FIVE_ONLY, "RATING_FILTER_FIVE_ONLY", "five-only"}, {0, NULL, NULL}};
	GType rating_filter_type_id;
	rating_filter_type_id = g_enum_register_static ("RatingFilter", values);
	return rating_filter_type_id;
}

GType
rating_filter_get_type (void)
{
	static volatile gsize rating_filter_type_id__once = 0;
	if (g_once_init_enter (&rating_filter_type_id__once)) {
		GType rating_filter_type_id;
		rating_filter_type_id = rating_filter_get_type_once ();
		g_once_init_leave (&rating_filter_type_id__once, rating_filter_type_id);
	}
	return rating_filter_type_id__once;
}

static inline gpointer
search_view_filter_get_instance_private (SearchViewFilter* self)
{
	return G_STRUCT_MEMBER_P (self, SearchViewFilter_private_offset);
}

static guint
search_view_filter_real_get_criteria (SearchViewFilter* self)
{
	guint _tmp0_ = 0U;
	g_critical ("Type `%s' does not implement abstract method `search_view_filter_get_criteria'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

guint
search_view_filter_get_criteria (SearchViewFilter* self)
{
	SearchViewFilterClass* _klass_;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), 0U);
	_klass_ = SEARCH_VIEW_FILTER_GET_CLASS (self);
	if (_klass_->get_criteria) {
		return _klass_->get_criteria (self);
	}
	return 0U;
}

void
search_view_filter_set_rating_filter (SearchViewFilter* self,
                                      RatingFilter rf)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	self->priv->rating_filter = rf;
	switch (self->priv->rating_filter) {
		case RATING_FILTER_REJECTED_ONLY:
		{
			self->priv->rating = RATING_REJECTED;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		case RATING_FILTER_REJECTED_OR_HIGHER:
		{
			self->priv->rating = RATING_REJECTED;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_ONE_OR_HIGHER:
		{
			self->priv->rating = RATING_ONE;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_ONE_ONLY:
		{
			self->priv->rating = RATING_ONE;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		case RATING_FILTER_TWO_OR_HIGHER:
		{
			self->priv->rating = RATING_TWO;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_TWO_ONLY:
		{
			self->priv->rating = RATING_TWO;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		case RATING_FILTER_THREE_OR_HIGHER:
		{
			self->priv->rating = RATING_THREE;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_THREE_ONLY:
		{
			self->priv->rating = RATING_THREE;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		case RATING_FILTER_FOUR_OR_HIGHER:
		{
			self->priv->rating = RATING_FOUR;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_FOUR_ONLY:
		{
			self->priv->rating = RATING_FOUR;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		case RATING_FILTER_FIVE_OR_HIGHER:
		{
			self->priv->rating = RATING_FIVE;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
		case RATING_FILTER_FIVE_ONLY:
		{
			self->priv->rating = RATING_FIVE;
			self->priv->rating_allow_higher = FALSE;
			break;
		}
		default:
		case RATING_FILTER_UNRATED_OR_HIGHER:
		{
			self->priv->rating = RATING_UNRATED;
			self->priv->rating_allow_higher = TRUE;
			break;
		}
	}
}

gboolean
search_view_filter_has_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	_tmp0_ = self->priv->search_filter;
	result = !is_string_empty (_tmp0_);
	return result;
}

const gchar*
search_view_filter_get_search_filter (SearchViewFilter* self)
{
	const gchar* _tmp0_;
	const gchar* result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
	_tmp0_ = self->priv->search_filter;
	result = _tmp0_;
	return result;
}

gchar**
search_view_filter_get_search_filter_words (SearchViewFilter* self,
                                            gint* result_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
	_tmp0_ = self->priv->search_filter_words;
	_tmp0__length1 = self->priv->search_filter_words_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup36 (gchar** self,
                   gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

void
search_view_filter_set_search_filter (SearchViewFilter* self,
                                      const gchar* text)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint __tmp5__size_ = 0;
	const gchar* _tmp6_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	if (!is_string_empty (text)) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = g_utf8_strdown (text, (gssize) -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = string_remove_diacritics (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
		_g_free0 (_tmp2_);
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	_tmp4_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->search_filter);
	self->priv->search_filter = _tmp4_;
	_tmp6_ = self->priv->search_filter;
	if (_tmp6_ != NULL) {
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		_tmp7_ = self->priv->search_filter;
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
		_tmp5_ = _tmp9_;
		_tmp5__length1 = _vala_array_length (_tmp8_);
		__tmp5__size_ = _tmp5__length1;
	} else {
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
		_tmp5_ = NULL;
		_tmp5__length1 = 0;
		__tmp5__size_ = _tmp5__length1;
	}
	_tmp10_ = (_tmp5_ != NULL) ? _vala_array_dup36 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp10__length1 = _tmp5__length1;
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
	self->priv->search_filter_words = _tmp10_;
	self->priv->search_filter_words_length1 = _tmp10__length1;
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp0_);
}

void
search_view_filter_clear_search_filter (SearchViewFilter* self)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	_g_free0 (self->priv->search_filter);
	self->priv->search_filter = NULL;
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
	self->priv->search_filter_words = NULL;
	self->priv->search_filter_words_length1 = 0;
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
}

gboolean
search_view_filter_has_saved_search (SearchViewFilter* self)
{
	SavedSearch* _tmp0_;
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	_tmp0_ = self->priv->_saved_search;
	result = _tmp0_ != NULL;
	return result;
}

gboolean
search_view_filter_get_rating_allow_higher (SearchViewFilter* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	result = self->priv->rating_allow_higher;
	return result;
}

Rating
search_view_filter_get_rating (SearchViewFilter* self)
{
	Rating result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), 0);
	result = self->priv->rating;
	return result;
}

gboolean
search_view_filter_filter_by_media_type (SearchViewFilter* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	_tmp3_ = self->priv->_show_media_video;
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp4_;
		_tmp4_ = self->priv->_show_media_photos;
		_tmp2_ = _tmp4_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_;
		_tmp5_ = self->priv->_show_media_raw;
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		_tmp8_ = self->priv->_show_media_video;
		if (_tmp8_) {
			gboolean _tmp9_;
			_tmp9_ = self->priv->_show_media_photos;
			_tmp7_ = _tmp9_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			gboolean _tmp10_;
			_tmp10_ = self->priv->_show_media_raw;
			_tmp6_ = _tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = !_tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

SearchViewFilter*
search_view_filter_construct (GType object_type)
{
	SearchViewFilter* self = NULL;
	self = (SearchViewFilter*) view_filter_construct (object_type);
	return self;
}

gboolean
search_view_filter_get_flagged (SearchViewFilter* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	result = self->priv->_flagged;
	return result;
}

void
search_view_filter_set_flagged (SearchViewFilter* self,
                                gboolean value)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	self->priv->_flagged = value;
}

gboolean
search_view_filter_get_show_media_video (SearchViewFilter* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	result = self->priv->_show_media_video;
	return result;
}

void
search_view_filter_set_show_media_video (SearchViewFilter* self,
                                         gboolean value)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	self->priv->_show_media_video = value;
}

gboolean
search_view_filter_get_show_media_photos (SearchViewFilter* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	result = self->priv->_show_media_photos;
	return result;
}

void
search_view_filter_set_show_media_photos (SearchViewFilter* self,
                                          gboolean value)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	self->priv->_show_media_photos = value;
}

gboolean
search_view_filter_get_show_media_raw (SearchViewFilter* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), FALSE);
	result = self->priv->_show_media_raw;
	return result;
}

void
search_view_filter_set_show_media_raw (SearchViewFilter* self,
                                       gboolean value)
{
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	self->priv->_show_media_raw = value;
}

SavedSearch*
search_view_filter_get_saved_search (SearchViewFilter* self)
{
	SavedSearch* result;
	SavedSearch* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_VIEW_FILTER (self), NULL);
	_tmp0_ = self->priv->_saved_search;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
search_view_filter_set_saved_search (SearchViewFilter* self,
                                     SavedSearch* value)
{
	SavedSearch* _tmp0_;
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (self));
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_saved_search);
	self->priv->_saved_search = _tmp0_;
}

static void
search_view_filter_class_init (SearchViewFilterClass * klass,
                               gpointer klass_data)
{
	search_view_filter_parent_class = g_type_class_peek_parent (klass);
	((ViewFilterClass *) klass)->finalize = search_view_filter_finalize;
	g_type_class_adjust_private_offset (klass, &SearchViewFilter_private_offset);
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) search_view_filter_real_get_criteria;
}

static void
search_view_filter_instance_init (SearchViewFilter * self,
                                  gpointer klass)
{
	self->priv = search_view_filter_get_instance_private (self);
	self->priv->rating_allow_higher = TRUE;
	self->priv->rating = RATING_UNRATED;
	self->priv->rating_filter = RATING_FILTER_UNRATED_OR_HIGHER;
	self->priv->_flagged = FALSE;
	self->priv->_show_media_video = TRUE;
	self->priv->_show_media_photos = TRUE;
	self->priv->_show_media_raw = TRUE;
	self->priv->search_filter = NULL;
	self->priv->search_filter_words = NULL;
	self->priv->search_filter_words_length1 = 0;
	self->priv->_search_filter_words_size_ = self->priv->search_filter_words_length1;
	self->priv->_saved_search = NULL;
}

static void
search_view_filter_finalize (ViewFilter * obj)
{
	SearchViewFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter);
	_g_free0 (self->priv->search_filter);
	self->priv->search_filter_words = (_vala_array_free (self->priv->search_filter_words, self->priv->search_filter_words_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->_saved_search);
	VIEW_FILTER_CLASS (search_view_filter_parent_class)->finalize (obj);
}

static GType
search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchViewFilter), 0, (GInstanceInitFunc) search_view_filter_instance_init, NULL };
	GType search_view_filter_type_id;
	search_view_filter_type_id = g_type_register_static (TYPE_VIEW_FILTER, "SearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SearchViewFilter_private_offset = g_type_add_instance_private (search_view_filter_type_id, sizeof (SearchViewFilterPrivate));
	return search_view_filter_type_id;
}

GType
search_view_filter_get_type (void)
{
	static volatile gsize search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&search_view_filter_type_id__once)) {
		GType search_view_filter_type_id;
		search_view_filter_type_id = search_view_filter_get_type_once ();
		g_once_init_leave (&search_view_filter_type_id__once, search_view_filter_type_id);
	}
	return search_view_filter_type_id__once;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
default_search_view_filter_real_predicate (ViewFilter* base,
                                           DataView* view)
{
	DefaultSearchViewFilter * self;
	MediaSource* source = NULL;
	MediaSource* _tmp0_;
	guint criteria = 0U;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp81_ = FALSE;
	gboolean result;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DEFAULT_SEARCH_VIEW_FILTER, DefaultSearchViewFilter);
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
	_tmp0_ = thumbnail_get_media_source (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_THUMBNAIL, Thumbnail));
	source = _tmp0_;
	criteria = search_view_filter_get_criteria (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
	if ((SEARCH_FILTER_CRITERIA_RATING & criteria) != 0) {
		gboolean _tmp1_ = FALSE;
		if (search_view_filter_get_rating_allow_higher (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))) {
			MediaSource* _tmp2_;
			_tmp2_ = source;
			_tmp1_ = media_source_get_rating (_tmp2_) < search_view_filter_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			result = FALSE;
			_g_object_unref0 (source);
			return result;
		} else {
			gboolean _tmp3_ = FALSE;
			if (!search_view_filter_get_rating_allow_higher (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter))) {
				MediaSource* _tmp4_;
				_tmp4_ = source;
				_tmp3_ = media_source_get_rating (_tmp4_) != search_view_filter_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				result = FALSE;
				_g_object_unref0 (source);
				return result;
			}
		}
	}
	if ((SEARCH_FILTER_CRITERIA_FLAG & criteria) != 0) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = search_view_filter_get_flagged (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			MediaSource* _tmp9_;
			_tmp9_ = source;
			_tmp6_ = IS_FLAGGABLE (_tmp9_);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			MediaSource* _tmp10_;
			_tmp10_ = source;
			_tmp5_ = !flaggable_is_flagged (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_FLAGGABLE, Flaggable));
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			result = FALSE;
			_g_object_unref0 (source);
			return result;
		}
	}
	if ((SEARCH_FILTER_CRITERIA_MEDIA & criteria) != 0) {
		_tmp11_ = search_view_filter_filter_by_media_type (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		MediaSource* _tmp12_;
		_tmp12_ = source;
		if (IS_VIDEO_SOURCE (_tmp12_)) {
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp13_ = search_view_filter_get_show_media_video (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
			_tmp14_ = _tmp13_;
			if (!_tmp14_) {
				result = FALSE;
				_g_object_unref0 (source);
				return result;
			}
		} else {
			MediaSource* _tmp15_;
			_tmp15_ = source;
			if (IS_PHOTO (_tmp15_)) {
				Photo* photo = NULL;
				MediaSource* _tmp16_;
				Photo* _tmp17_;
				Photo* _tmp18_;
				_tmp16_ = source;
				_tmp17_ = _g_object_ref0 (IS_PHOTO (_tmp16_) ? ((Photo*) _tmp16_) : NULL);
				photo = _tmp17_;
				_tmp18_ = photo;
				if (photo_get_master_file_format (_tmp18_) == PHOTO_FILE_FORMAT_RAW) {
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_;
					gboolean _tmp21_;
					_tmp20_ = search_view_filter_get_show_media_photos (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
					_tmp21_ = _tmp20_;
					if (!_tmp21_) {
						gboolean _tmp22_;
						gboolean _tmp23_;
						_tmp22_ = search_view_filter_get_show_media_raw (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
						_tmp23_ = _tmp22_;
						_tmp19_ = !_tmp23_;
					} else {
						_tmp19_ = FALSE;
					}
					if (_tmp19_) {
						result = FALSE;
						_g_object_unref0 (photo);
						_g_object_unref0 (source);
						return result;
					}
				} else {
					gboolean _tmp24_;
					gboolean _tmp25_;
					_tmp24_ = search_view_filter_get_show_media_photos (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
					_tmp25_ = _tmp24_;
					if (!_tmp25_) {
						result = FALSE;
						_g_object_unref0 (photo);
						_g_object_unref0 (source);
						return result;
					}
				}
				_g_object_unref0 (photo);
			}
		}
	}
	if ((SEARCH_FILTER_CRITERIA_TEXT & criteria) != 0) {
		_tmp26_ = search_view_filter_has_search_filter (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		const gchar* media_keywords = NULL;
		MediaSource* _tmp27_;
		const gchar* _tmp28_;
		const gchar* event_keywords = NULL;
		Event* event = NULL;
		MediaSource* _tmp29_;
		Event* _tmp30_;
		Event* _tmp31_;
		GeeList* tags = NULL;
		TagSourceCollection* _tmp34_;
		MediaSource* _tmp35_;
		GeeList* _tmp36_;
		gint _tmp37_ = 0;
		GeeList* _tmp38_;
		gint tags_size = 0;
		GeeList* faces = NULL;
		FaceSourceCollection* _tmp42_;
		MediaSource* _tmp43_;
		GeeList* _tmp44_;
		gint _tmp45_ = 0;
		gchar** _tmp46_;
		_tmp27_ = source;
		_tmp28_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_INDEXABLE, Indexable));
		media_keywords = _tmp28_;
		event_keywords = NULL;
		_tmp29_ = source;
		_tmp30_ = media_source_get_event (_tmp29_);
		event = _tmp30_;
		_tmp31_ = event;
		if (_tmp31_ != NULL) {
			Event* _tmp32_;
			const gchar* _tmp33_;
			_tmp32_ = event;
			_tmp33_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_INDEXABLE, Indexable));
			event_keywords = _tmp33_;
		}
		_tmp34_ = tag_global;
		_tmp35_ = source;
		_tmp36_ = tag_source_collection_fetch_for_source (_tmp34_, _tmp35_);
		tags = _tmp36_;
		_tmp38_ = tags;
		if (_tmp38_ != NULL) {
			GeeList* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			_tmp39_ = tags;
			_tmp40_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection));
			_tmp41_ = _tmp40_;
			_tmp37_ = _tmp41_;
		} else {
			_tmp37_ = 0;
		}
		tags_size = _tmp37_;
		_tmp42_ = face_global;
		_tmp43_ = source;
		_tmp44_ = face_source_collection_fetch_for_source (_tmp42_, _tmp43_);
		faces = _tmp44_;
		_tmp46_ = search_view_filter_get_search_filter_words (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter), &_tmp45_);
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
			word_collection = _tmp46_;
			word_collection_length1 = _tmp45_;
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
				const gchar* word = NULL;
				word = word_collection[word_it];
				{
					gboolean _tmp47_ = FALSE;
					const gchar* _tmp48_;
					gboolean _tmp51_ = FALSE;
					const gchar* _tmp52_;
					GeeList* _tmp66_;
					_tmp48_ = media_keywords;
					if (_tmp48_ != NULL) {
						const gchar* _tmp49_;
						const gchar* _tmp50_;
						_tmp49_ = media_keywords;
						_tmp50_ = word;
						_tmp47_ = string_contains (_tmp49_, _tmp50_);
					} else {
						_tmp47_ = FALSE;
					}
					if (_tmp47_) {
						continue;
					}
					_tmp52_ = event_keywords;
					if (_tmp52_ != NULL) {
						const gchar* _tmp53_;
						const gchar* _tmp54_;
						_tmp53_ = event_keywords;
						_tmp54_ = word;
						_tmp51_ = string_contains (_tmp53_, _tmp54_);
					} else {
						_tmp51_ = FALSE;
					}
					if (_tmp51_) {
						continue;
					}
					if (tags_size > 0) {
						gboolean found = FALSE;
						found = FALSE;
						{
							gint ctr = 0;
							ctr = 0;
							{
								gboolean _tmp55_ = FALSE;
								_tmp55_ = TRUE;
								while (TRUE) {
									const gchar* tag_keywords = NULL;
									GeeList* _tmp57_;
									gpointer _tmp58_;
									Tag* _tmp59_;
									const gchar* _tmp60_;
									const gchar* _tmp61_;
									gboolean _tmp62_ = FALSE;
									const gchar* _tmp63_;
									if (!_tmp55_) {
										gint _tmp56_;
										_tmp56_ = ctr;
										ctr = _tmp56_ + 1;
									}
									_tmp55_ = FALSE;
									if (!(ctr < tags_size)) {
										break;
									}
									_tmp57_ = tags;
									_tmp58_ = gee_list_get (_tmp57_, ctr);
									_tmp59_ = (Tag*) _tmp58_;
									_tmp60_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_INDEXABLE, Indexable));
									_tmp61_ = _tmp60_;
									_g_object_unref0 (_tmp59_);
									tag_keywords = _tmp61_;
									_tmp63_ = tag_keywords;
									if (_tmp63_ != NULL) {
										const gchar* _tmp64_;
										const gchar* _tmp65_;
										_tmp64_ = tag_keywords;
										_tmp65_ = word;
										_tmp62_ = string_contains (_tmp64_, _tmp65_);
									} else {
										_tmp62_ = FALSE;
									}
									if (_tmp62_) {
										found = TRUE;
										break;
									}
								}
							}
						}
						if (found) {
							continue;
						}
					}
					_tmp66_ = faces;
					if (_tmp66_ != NULL) {
						gboolean found = FALSE;
						found = FALSE;
						{
							GeeList* _f_list = NULL;
							GeeList* _tmp67_;
							gint _f_size = 0;
							GeeList* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							gint _f_index = 0;
							_tmp67_ = faces;
							_f_list = _tmp67_;
							_tmp68_ = _f_list;
							_tmp69_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, GEE_TYPE_COLLECTION, GeeCollection));
							_tmp70_ = _tmp69_;
							_f_size = _tmp70_;
							_f_index = -1;
							while (TRUE) {
								gint _tmp71_;
								gint _tmp72_;
								Face* f = NULL;
								GeeList* _tmp73_;
								gpointer _tmp74_;
								const gchar* face_keywords = NULL;
								Face* _tmp75_;
								const gchar* _tmp76_;
								gboolean _tmp77_ = FALSE;
								const gchar* _tmp78_;
								_f_index = _f_index + 1;
								_tmp71_ = _f_index;
								_tmp72_ = _f_size;
								if (!(_tmp71_ < _tmp72_)) {
									break;
								}
								_tmp73_ = _f_list;
								_tmp74_ = gee_list_get (_tmp73_, _f_index);
								f = (Face*) _tmp74_;
								_tmp75_ = f;
								_tmp76_ = indexable_get_indexable_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp75_, TYPE_INDEXABLE, Indexable));
								face_keywords = _tmp76_;
								_tmp78_ = face_keywords;
								if (_tmp78_ != NULL) {
									const gchar* _tmp79_;
									const gchar* _tmp80_;
									_tmp79_ = face_keywords;
									_tmp80_ = word;
									_tmp77_ = string_contains (_tmp79_, _tmp80_);
								} else {
									_tmp77_ = FALSE;
								}
								if (_tmp77_) {
									found = TRUE;
									_g_object_unref0 (f);
									break;
								}
								_g_object_unref0 (f);
							}
						}
						if (found) {
							continue;
						}
					}
					result = FALSE;
					_g_object_unref0 (faces);
					_g_object_unref0 (tags);
					_g_object_unref0 (event);
					_g_object_unref0 (source);
					return result;
				}
			}
		}
		_g_object_unref0 (faces);
		_g_object_unref0 (tags);
		_g_object_unref0 (event);
	}
	if ((SEARCH_FILTER_CRITERIA_SAVEDSEARCH & criteria) != 0) {
		_tmp81_ = search_view_filter_has_saved_search (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
	} else {
		_tmp81_ = FALSE;
	}
	if (_tmp81_) {
		SavedSearch* _tmp82_;
		SavedSearch* _tmp83_;
		MediaSource* _tmp84_;
		_tmp82_ = search_view_filter_get_saved_search (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
		_tmp83_ = _tmp82_;
		_tmp84_ = source;
		result = saved_search_predicate (_tmp83_, _tmp84_);
		_g_object_unref0 (source);
		return result;
	}
	result = TRUE;
	_g_object_unref0 (source);
	return result;
}

DefaultSearchViewFilter*
default_search_view_filter_construct (GType object_type)
{
	DefaultSearchViewFilter* self = NULL;
	self = (DefaultSearchViewFilter*) search_view_filter_construct (object_type);
	return self;
}

static void
default_search_view_filter_class_init (DefaultSearchViewFilterClass * klass,
                                       gpointer klass_data)
{
	default_search_view_filter_parent_class = g_type_class_peek_parent (klass);
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) default_search_view_filter_real_predicate;
}

static void
default_search_view_filter_instance_init (DefaultSearchViewFilter * self,
                                          gpointer klass)
{
}

static GType
default_search_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DefaultSearchViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) default_search_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DefaultSearchViewFilter), 0, (GInstanceInitFunc) default_search_view_filter_instance_init, NULL };
	GType default_search_view_filter_type_id;
	default_search_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DefaultSearchViewFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return default_search_view_filter_type_id;
}

GType
default_search_view_filter_get_type (void)
{
	static volatile gsize default_search_view_filter_type_id__once = 0;
	if (g_once_init_enter (&default_search_view_filter_type_id__once)) {
		GType default_search_view_filter_type_id;
		default_search_view_filter_type_id = default_search_view_filter_get_type_once ();
		g_once_init_leave (&default_search_view_filter_type_id__once, default_search_view_filter_type_id);
	}
	return default_search_view_filter_type_id__once;
}

static gboolean
disabled_view_filter_real_predicate (ViewFilter* base,
                                     DataView* view)
{
	DisabledViewFilter * self;
	gboolean result;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter);
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
	result = TRUE;
	return result;
}

static guint
disabled_view_filter_real_get_criteria (SearchViewFilter* base)
{
	DisabledViewFilter * self;
	guint result;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DISABLED_VIEW_FILTER, DisabledViewFilter);
	result = (guint) SEARCH_FILTER_CRITERIA_RATING;
	return result;
}

DisabledViewFilter*
disabled_view_filter_construct (GType object_type)
{
	DisabledViewFilter* self = NULL;
	self = (DisabledViewFilter*) search_view_filter_construct (object_type);
	return self;
}

DisabledViewFilter*
disabled_view_filter_new (void)
{
	return disabled_view_filter_construct (TYPE_DISABLED_VIEW_FILTER);
}

static void
disabled_view_filter_class_init (DisabledViewFilterClass * klass,
                                 gpointer klass_data)
{
	disabled_view_filter_parent_class = g_type_class_peek_parent (klass);
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) disabled_view_filter_real_predicate;
	((SearchViewFilterClass *) klass)->get_criteria = (guint (*) (SearchViewFilter*)) disabled_view_filter_real_get_criteria;
}

static void
disabled_view_filter_instance_init (DisabledViewFilter * self,
                                    gpointer klass)
{
}

static GType
disabled_view_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisabledViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) disabled_view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisabledViewFilter), 0, (GInstanceInitFunc) disabled_view_filter_instance_init, NULL };
	GType disabled_view_filter_type_id;
	disabled_view_filter_type_id = g_type_register_static (TYPE_SEARCH_VIEW_FILTER, "DisabledViewFilter", &g_define_type_info, 0);
	return disabled_view_filter_type_id;
}

GType
disabled_view_filter_get_type (void)
{
	static volatile gsize disabled_view_filter_type_id__once = 0;
	if (g_once_init_enter (&disabled_view_filter_type_id__once)) {
		GType disabled_view_filter_type_id;
		disabled_view_filter_type_id = disabled_view_filter_get_type_once ();
		g_once_init_leave (&disabled_view_filter_type_id__once, disabled_view_filter_type_id);
	}
	return disabled_view_filter_type_id__once;
}

static inline gpointer
text_action_get_instance_private (TextAction* self)
{
	return G_STRUCT_MEMBER_P (self, TextAction_private_offset);
}

TextAction*
text_action_construct (GType object_type,
                       const gchar* init)
{
	TextAction* self = NULL;
	gchar* _tmp0_;
	self = (TextAction*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (init);
	_g_free0 (self->priv->text);
	self->priv->text = _tmp0_;
	return self;
}

TextAction*
text_action_new (const gchar* init)
{
	return text_action_construct (TYPE_TEXT_ACTION, init);
}

void
text_action_set_text (TextAction* self,
                      const gchar* text)
{
	const gchar* _tmp0_;
	g_return_if_fail (IS_TEXT_ACTION (self));
	_tmp0_ = self->priv->text;
	if (g_strcmp0 (_tmp0_, text) != 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (text);
		_g_free0 (self->priv->text);
		self->priv->text = _tmp1_;
		g_signal_emit (self, text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL], 0, text);
	}
}

void
text_action_clear (TextAction* self)
{
	g_return_if_fail (IS_TEXT_ACTION (self));
	text_action_set_text (self, NULL);
}

gboolean
text_action_is_sensitive (TextAction* self)
{
	gboolean result;
	g_return_val_if_fail (IS_TEXT_ACTION (self), FALSE);
	result = self->priv->sensitive;
	return result;
}

void
text_action_set_sensitive (TextAction* self,
                           gboolean sensitive)
{
	g_return_if_fail (IS_TEXT_ACTION (self));
	if (self->priv->sensitive != sensitive) {
		self->priv->sensitive = sensitive;
		g_signal_emit (self, text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL], 0, sensitive);
	}
}

gboolean
text_action_is_visible (TextAction* self)
{
	gboolean result;
	g_return_val_if_fail (IS_TEXT_ACTION (self), FALSE);
	result = self->priv->visible;
	return result;
}

void
text_action_set_visible (TextAction* self,
                         gboolean visible)
{
	g_return_if_fail (IS_TEXT_ACTION (self));
	if (self->priv->visible != visible) {
		self->priv->visible = visible;
		g_signal_emit (self, text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL], 0, visible);
	}
}

const gchar*
text_action_get_value (TextAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (IS_TEXT_ACTION (self), NULL);
	_tmp0_ = self->priv->text;
	result = _tmp0_;
	return result;
}

static void
value_text_action_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_text_action_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		text_action_unref (value->data[0].v_pointer);
	}
}

static void
value_text_action_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = text_action_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_text_action_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_text_action_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		TextAction * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = text_action_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_text_action_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	TextAction ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = text_action_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_text_action (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTextAction* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEXT_ACTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_text_action (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION), NULL);
	return value->data[0].v_pointer;
}

void
value_set_text_action (GValue* value,
                       gpointer v_object)
{
	TextAction * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		text_action_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		text_action_unref (old);
	}
}

void
value_take_text_action (GValue* value,
                        gpointer v_object)
{
	TextAction * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEXT_ACTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEXT_ACTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		text_action_unref (old);
	}
}

static void
text_action_class_init (TextActionClass * klass,
                        gpointer klass_data)
{
	text_action_parent_class = g_type_class_peek_parent (klass);
	((TextActionClass *) klass)->finalize = text_action_finalize;
	g_type_class_adjust_private_offset (klass, &TextAction_private_offset);
	text_action_signals[TEXT_ACTION_TEXT_CHANGED_SIGNAL] = g_signal_new ("text-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	text_action_signals[TEXT_ACTION_SENSITIVITY_CHANGED_SIGNAL] = g_signal_new ("sensitivity-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	text_action_signals[TEXT_ACTION_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", TYPE_TEXT_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
text_action_instance_init (TextAction * self,
                           gpointer klass)
{
	self->priv = text_action_get_instance_private (self);
	self->priv->text = NULL;
	self->priv->sensitive = TRUE;
	self->priv->visible = TRUE;
	self->ref_count = 1;
}

static void
text_action_finalize (TextAction * obj)
{
	TextAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_ACTION, TextAction);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->text);
}

static GType
text_action_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_text_action_init, value_text_action_free_value, value_text_action_copy_value, value_text_action_peek_pointer, "p", value_text_action_collect_value, "p", value_text_action_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TextActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextAction), 0, (GInstanceInitFunc) text_action_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType text_action_type_id;
	text_action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TextAction", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TextAction_private_offset = g_type_add_instance_private (text_action_type_id, sizeof (TextActionPrivate));
	return text_action_type_id;
}

GType
text_action_get_type (void)
{
	static volatile gsize text_action_type_id__once = 0;
	if (g_once_init_enter (&text_action_type_id__once)) {
		GType text_action_type_id;
		text_action_type_id = text_action_get_type_once ();
		g_once_init_leave (&text_action_type_id__once, text_action_type_id);
	}
	return text_action_type_id__once;
}

gpointer
text_action_ref (gpointer instance)
{
	TextAction * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
text_action_unref (gpointer instance)
{
	TextAction * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TEXT_ACTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
search_filter_actions_get_instance_private (SearchFilterActions* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterActions_private_offset);
}

static void
_search_filter_actions_on_action_radio_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
	search_filter_actions_on_action_radio ((SearchFilterActions*) self, action, parameter);
}

static void
_search_filter_actions_on_rating_changed_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
	search_filter_actions_on_rating_changed ((SearchFilterActions*) self, action, value);
}

static void
_search_filter_actions_on_action_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
	search_filter_actions_on_action_toggle ((SearchFilterActions*) self, action, parameter);
}

static void
_search_filter_actions_on_flagged_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                GVariant* value,
                                                                                gpointer self)
{
	search_filter_actions_on_flagged_toggled ((SearchFilterActions*) self, action, value);
}

static void
_search_filter_actions_on_photos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
	search_filter_actions_on_photos_toggled ((SearchFilterActions*) self, action, value);
}

static void
_search_filter_actions_on_videos_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self)
{
	search_filter_actions_on_videos_toggled ((SearchFilterActions*) self, action, value);
}

static void
_search_filter_actions_on_raw_toggled_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                            GVariant* value,
                                                                            gpointer self)
{
	search_filter_actions_on_raw_toggled ((SearchFilterActions*) self, action, value);
}

static void
_search_filter_actions_on_text_changed_text_action_text_changed (TextAction* _sender,
                                                                 const gchar* text,
                                                                 gpointer self)
{
	search_filter_actions_on_text_changed ((SearchFilterActions*) self, _sender, text);
}

SearchFilterActions*
search_filter_actions_construct (GType object_type)
{
	SearchFilterActions* self = NULL;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
	self = (SearchFilterActions*) g_type_create_instance (object_type);
	search_filter_actions_register (self);
	_tmp0_ = search_filter_actions_get_text (self);
	_tmp1_ = _tmp0_;
	g_signal_connect (_tmp1_, "text-changed", (GCallback) _search_filter_actions_on_text_changed_text_action_text_changed, self);
	return self;
}

SearchFilterActions*
search_filter_actions_new (void)
{
	return search_filter_actions_construct (TYPE_SEARCH_FILTER_ACTIONS);
}

SearchFilterCriteria
search_filter_actions_get_criteria (SearchFilterActions* self)
{
	SearchFilterCriteria result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), 0U);
	result = self->priv->criteria;
	return result;
}

GActionEntry*
search_filter_actions_get_actions (SearchFilterActions* self,
                                   gint* result_length1)
{
	GActionEntry* _tmp0_;
	gint _tmp0__length1;
	GActionEntry* result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = SEARCH_FILTER_ACTIONS_entries;
	_tmp0__length1 = G_N_ELEMENTS (SEARCH_FILTER_ACTIONS_entries);
	if (result_length1) {
		*result_length1 = _tmp0__length1;
	}
	result = _tmp0_;
	return result;
}

GSimpleAction*
search_filter_actions_get_action (SearchFilterActions* self,
                                  const gchar* name)
{
	LibraryWindow* lw = NULL;
	AppWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	LibraryWindow* _tmp2_;
	GSimpleAction* result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = app_window_get_instance ();
	_tmp1_ = IS_LIBRARY_WINDOW (_tmp0_) ? ((LibraryWindow*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	lw = _tmp1_;
	_tmp2_ = lw;
	if (_tmp2_ != NULL) {
		LibraryWindow* _tmp3_;
		GAction* _tmp4_;
		_tmp3_ = lw;
		_tmp4_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_action_map_get_type (), GActionMap), name);
		result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp4_) : NULL;
		_g_object_unref0 (lw);
		return result;
	}
	result = NULL;
	_g_object_unref0 (lw);
	return result;
}

void
search_filter_actions_set_action_sensitive (SearchFilterActions* self,
                                            const gchar* name,
                                            gboolean sensitive)
{
	GSimpleAction* action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (name != NULL);
	_tmp0_ = search_filter_actions_get_action (self, name);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	action = _tmp1_;
	_tmp2_ = action;
	if (_tmp2_ != NULL) {
		GSimpleAction* _tmp3_;
		_tmp3_ = action;
		g_simple_action_set_enabled (_tmp3_, sensitive);
	}
	_g_object_unref0 (action);
}

static GVariant*
_variant_new29 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new30 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new31 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new32 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new33 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

void
search_filter_actions_reset (SearchFilterActions* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GVariant* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GVariant* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GVariant* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GVariant* _tmp11_;
	GVariant* v = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	TextAction* _tmp18_;
	TextAction* _tmp19_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	_tmp0_ = search_filter_actions_get_flagged (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _variant_new29 (FALSE);
	g_signal_emit_by_name (_tmp1_, "change-state", _tmp2_);
	_g_variant_unref0 (_tmp2_);
	_tmp3_ = search_filter_actions_get_photos (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _variant_new30 (FALSE);
	g_signal_emit_by_name (_tmp4_, "change-state", _tmp5_);
	_g_variant_unref0 (_tmp5_);
	_tmp6_ = search_filter_actions_get_raw (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = _variant_new31 (FALSE);
	g_signal_emit_by_name (_tmp7_, "change-state", _tmp8_);
	_g_variant_unref0 (_tmp8_);
	_tmp9_ = search_filter_actions_get_videos (self);
	_tmp10_ = _tmp9_;
	_tmp11_ = _variant_new32 (FALSE);
	g_signal_emit_by_name (_tmp10_, "change-state", _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = g_strdup_printf ("%d", (gint) RATING_FILTER_UNRATED_OR_HIGHER);
	_tmp13_ = _tmp12_;
	_tmp14_ = _variant_new33 (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	v = _tmp15_;
	_tmp16_ = search_filter_actions_get_rating (self);
	_tmp17_ = _tmp16_;
	g_signal_emit_by_name (_tmp17_, "change-state", v);
	_tmp18_ = search_filter_actions_get_text (self);
	_tmp19_ = _tmp18_;
	text_action_set_text (_tmp19_, NULL);
	_g_variant_unref0 (v);
}

void
search_filter_actions_set_sensitive_for_search_criteria (SearchFilterActions* self,
                                                         SearchFilterCriteria criteria)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	self->priv->criteria = criteria;
	search_filter_actions_update_sensitivities (self);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL], 0);
}

static void
_search_filter_actions_on_media_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                      gpointer self)
{
	search_filter_actions_on_media_tracker_updated ((SearchFilterActions*) self, _sender);
}

static void
_search_filter_actions_on_camera_tracker_updated_core_tracker_updated (CoreTracker* _sender,
                                                                       gpointer self)
{
	search_filter_actions_on_camera_tracker_updated ((SearchFilterActions*) self, _sender);
}

void
search_filter_actions_monitor_page_contents (SearchFilterActions* self,
                                             Page* old_page,
                                             Page* new_page)
{
	CheckerboardPage* old_tracked_page = NULL;
	CheckerboardPage* _tmp0_;
	CheckerboardPage* _tmp1_;
	CheckerboardPage* new_tracked_page = NULL;
	CheckerboardPage* _tmp10_;
	CheckerboardPage* _tmp11_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail ((old_page == NULL) || IS_PAGE (old_page));
	g_return_if_fail ((new_page == NULL) || IS_PAGE (new_page));
	_tmp0_ = _g_object_ref0 (IS_CHECKERBOARD_PAGE (old_page) ? ((CheckerboardPage*) old_page) : NULL);
	old_tracked_page = _tmp0_;
	_tmp1_ = old_tracked_page;
	if (_tmp1_ != NULL) {
		CoreViewTracker* tracker = NULL;
		CheckerboardPage* _tmp2_;
		CoreViewTracker* _tmp3_;
		CoreViewTracker* _tmp4_;
		_tmp2_ = old_tracked_page;
		_tmp3_ = checkerboard_page_get_view_tracker (_tmp2_);
		tracker = _tmp3_;
		_tmp4_ = tracker;
		if (IS_MEDIA_VIEW_TRACKER (_tmp4_)) {
			CoreViewTracker* _tmp5_;
			guint _tmp6_;
			_tmp5_ = tracker;
			g_signal_parse_name ("updated", CORE_TYPE_TRACKER, &_tmp6_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, CORE_TYPE_TRACKER, CoreTracker), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _search_filter_actions_on_media_tracker_updated_core_tracker_updated, self);
		} else {
			CoreViewTracker* _tmp7_;
			_tmp7_ = tracker;
			if (IS_CAMERA_VIEW_TRACKER (_tmp7_)) {
				CoreViewTracker* _tmp8_;
				guint _tmp9_;
				_tmp8_ = tracker;
				g_signal_parse_name ("updated", CORE_TYPE_TRACKER, &_tmp9_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, CORE_TYPE_TRACKER, CoreTracker), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_actions_on_camera_tracker_updated_core_tracker_updated, self);
			}
		}
		_core_tracker_unref0 (tracker);
	}
	_tmp10_ = _g_object_ref0 (IS_CHECKERBOARD_PAGE (new_page) ? ((CheckerboardPage*) new_page) : NULL);
	new_tracked_page = _tmp10_;
	_tmp11_ = new_tracked_page;
	if (_tmp11_ != NULL) {
		CoreViewTracker* tracker = NULL;
		CheckerboardPage* _tmp12_;
		CoreViewTracker* _tmp13_;
		CoreViewTracker* _tmp14_;
		self->priv->can_filter_by_stars = TRUE;
		_tmp12_ = new_tracked_page;
		_tmp13_ = checkerboard_page_get_view_tracker (_tmp12_);
		tracker = _tmp13_;
		_tmp14_ = tracker;
		if (IS_MEDIA_VIEW_TRACKER (_tmp14_)) {
			CoreViewTracker* _tmp15_;
			CoreViewTracker* _tmp16_;
			_tmp15_ = tracker;
			g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, CORE_TYPE_TRACKER, CoreTracker), "updated", (GCallback) _search_filter_actions_on_media_tracker_updated_core_tracker_updated, self);
			_tmp16_ = tracker;
			search_filter_actions_on_media_tracker_updated (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, CORE_TYPE_TRACKER, CoreTracker));
			_core_tracker_unref0 (tracker);
			_g_object_unref0 (new_tracked_page);
			_g_object_unref0 (old_tracked_page);
			return;
		} else {
			CoreViewTracker* _tmp17_;
			_tmp17_ = tracker;
			if (IS_CAMERA_VIEW_TRACKER (_tmp17_)) {
				CoreViewTracker* _tmp18_;
				CoreViewTracker* _tmp19_;
				_tmp18_ = tracker;
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CORE_TYPE_TRACKER, CoreTracker), "updated", (GCallback) _search_filter_actions_on_camera_tracker_updated_core_tracker_updated, self);
				_tmp19_ = tracker;
				search_filter_actions_on_camera_tracker_updated (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, CORE_TYPE_TRACKER, CoreTracker));
				_core_tracker_unref0 (tracker);
				_g_object_unref0 (new_tracked_page);
				_g_object_unref0 (old_tracked_page);
				return;
			}
		}
		_core_tracker_unref0 (tracker);
	}
	self->priv->has_flagged = FALSE;
	self->priv->has_photos = FALSE;
	self->priv->has_videos = FALSE;
	self->priv->has_raw = FALSE;
	self->priv->can_filter_by_stars = FALSE;
	search_filter_actions_update_sensitivities (self);
	_g_object_unref0 (new_tracked_page);
	_g_object_unref0 (old_tracked_page);
}

static gpointer
_core_tracker_ref0 (gpointer self)
{
	return self ? core_tracker_ref (self) : NULL;
}

static void
search_filter_actions_on_media_tracker_updated (SearchFilterActions* self,
                                                CoreTracker* t)
{
	MediaViewTracker* tracker = NULL;
	MediaViewTracker* _tmp0_;
	MediaAccumulator* _tmp1_;
	MediaAccumulator* _tmp2_;
	MediaAccumulator* _tmp3_;
	MediaAccumulator* _tmp4_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (CORE_IS_TRACKER (t));
	_tmp0_ = _core_tracker_ref0 (G_TYPE_CHECK_INSTANCE_CAST (t, TYPE_MEDIA_VIEW_TRACKER, MediaViewTracker));
	tracker = _tmp0_;
	_tmp1_ = tracker->all;
	self->priv->has_flagged = _tmp1_->flagged > 0;
	_tmp2_ = tracker->all;
	self->priv->has_photos = _tmp2_->photos > 0;
	_tmp3_ = tracker->all;
	self->priv->has_videos = _tmp3_->videos > 0;
	_tmp4_ = tracker->all;
	self->priv->has_raw = _tmp4_->raw > 0;
	search_filter_actions_update_sensitivities (self);
	_core_tracker_unref0 (tracker);
}

static void
search_filter_actions_on_camera_tracker_updated (SearchFilterActions* self,
                                                 CoreTracker* t)
{
	CameraViewTracker* tracker = NULL;
	CameraViewTracker* _tmp0_;
	CameraAccumulator* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	CameraAccumulator* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	CameraAccumulator* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (CORE_IS_TRACKER (t));
	_tmp0_ = _core_tracker_ref0 (G_TYPE_CHECK_INSTANCE_CAST (t, TYPE_CAMERA_VIEW_TRACKER, CameraViewTracker));
	tracker = _tmp0_;
	self->priv->has_flagged = FALSE;
	_tmp1_ = tracker->all;
	_tmp2_ = camera_accumulator_get_photos (_tmp1_);
	_tmp3_ = _tmp2_;
	self->priv->has_photos = _tmp3_ > 0;
	_tmp4_ = tracker->all;
	_tmp5_ = camera_accumulator_get_videos (_tmp4_);
	_tmp6_ = _tmp5_;
	self->priv->has_videos = _tmp6_ > 0;
	_tmp7_ = tracker->all;
	_tmp8_ = camera_accumulator_get_raw (_tmp7_);
	_tmp9_ = _tmp8_;
	self->priv->has_raw = _tmp9_ > 0;
	search_filter_actions_update_sensitivities (self);
	_core_tracker_unref0 (tracker);
}

static void
search_filter_actions_update_sensitivities (SearchFilterActions* self)
{
	gboolean allow_ratings = FALSE;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	allow_ratings = (SEARCH_FILTER_CRITERIA_RATING & self->priv->criteria) != 0;
	search_filter_actions_set_action_sensitive (self, "display.rating", allow_ratings & self->priv->can_filter_by_stars);
	_tmp0_ = search_filter_actions_get_text (self);
	_tmp1_ = _tmp0_;
	text_action_set_sensitive (_tmp1_, TRUE);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL], 0, self->priv->has_photos, self->priv->has_videos, self->priv->has_raw, self->priv->has_flagged);
}

static void
search_filter_actions_on_text_changed (SearchFilterActions* self,
                                       TextAction* action,
                                       const gchar* text)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (IS_TEXT_ACTION (action));
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL], 0, text);
}

static void
search_filter_actions_on_action_radio (SearchFilterActions* self,
                                       GSimpleAction* action,
                                       GVariant* parameter)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_signal_emit_by_name (action, "change-state", parameter);
}

static gboolean
_variant_get3 (GVariant* value)
{
	return g_variant_get_boolean (value);
}

static GVariant*
_variant_new34 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
search_filter_actions_on_action_toggle (SearchFilterActions* self,
                                        GSimpleAction* action,
                                        GVariant* parameter)
{
	gboolean state = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	_tmp0_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
	_tmp1_ = _tmp0_;
	_tmp2_ = _variant_get3 (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_unref0 (_tmp1_);
	state = _tmp3_;
	_tmp4_ = _variant_new34 (!state);
	g_signal_emit_by_name (action, "change-state", _tmp4_);
	_g_variant_unref0 (_tmp4_);
}

static void
search_filter_actions_register (SearchFilterActions* self)
{
	TextAction* _tmp0_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	_tmp0_ = text_action_new (NULL);
	_text_action_unref0 (self->priv->_text);
	self->priv->_text = _tmp0_;
}

static void
search_filter_actions_on_rating_changed (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	RatingFilter filter = 0;
	const gchar* _tmp5_;
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_return_if_fail (value != NULL);
	_tmp0_ = g_variant_get_string (value, NULL);
	_tmp1_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (action, g_action_get_type (), GAction));
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_string (_tmp2_, NULL);
	_tmp4_ = g_strcmp0 (_tmp0_, _tmp3_) == 0;
	_g_variant_unref0 (_tmp2_);
	if (_tmp4_) {
		return;
	}
	_tmp5_ = g_variant_get_string (value, NULL);
	filter = (RatingFilter) atoi (_tmp5_);
	g_simple_action_set_state (action, value);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL], 0, filter);
}

static void
search_filter_actions_on_flagged_toggled (SearchFilterActions* self,
                                          GSimpleAction* action,
                                          GVariant* value)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_return_if_fail (value != NULL);
	g_simple_action_set_state (action, value);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
}

static void
search_filter_actions_on_photos_toggled (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_return_if_fail (value != NULL);
	g_simple_action_set_state (action, value);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
}

static void
search_filter_actions_on_videos_toggled (SearchFilterActions* self,
                                         GSimpleAction* action,
                                         GVariant* value)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_return_if_fail (value != NULL);
	g_simple_action_set_state (action, value);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
}

static void
search_filter_actions_on_raw_toggled (SearchFilterActions* self,
                                      GSimpleAction* action,
                                      GVariant* value)
{
	g_return_if_fail (IS_SEARCH_FILTER_ACTIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
	g_return_if_fail (value != NULL);
	g_simple_action_set_state (action, value);
	g_signal_emit (self, search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL], 0, g_variant_get_boolean (value));
}

gboolean
search_filter_actions_get_has_photos (SearchFilterActions* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
	result = self->priv->has_photos;
	return result;
}

gboolean
search_filter_actions_get_has_videos (SearchFilterActions* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
	result = self->priv->has_videos;
	return result;
}

gboolean
search_filter_actions_get_has_raw (SearchFilterActions* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
	result = self->priv->has_raw;
	return result;
}

gboolean
search_filter_actions_get_has_flagged (SearchFilterActions* self)
{
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), FALSE);
	result = self->priv->has_flagged;
	return result;
}

GSimpleAction*
search_filter_actions_get_flagged (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = search_filter_actions_get_action (self, "display.flagged");
	result = _tmp0_;
	return result;
}

GSimpleAction*
search_filter_actions_get_photos (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = search_filter_actions_get_action (self, "display.photos");
	result = _tmp0_;
	return result;
}

GSimpleAction*
search_filter_actions_get_videos (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = search_filter_actions_get_action (self, "display.videos");
	result = _tmp0_;
	return result;
}

GSimpleAction*
search_filter_actions_get_raw (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = search_filter_actions_get_action (self, "display.raw");
	result = _tmp0_;
	return result;
}

GSimpleAction*
search_filter_actions_get_rating (SearchFilterActions* self)
{
	GSimpleAction* result;
	GSimpleAction* _tmp0_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = search_filter_actions_get_action (self, "display.rating");
	result = _tmp0_;
	return result;
}

TextAction*
search_filter_actions_get_text (SearchFilterActions* self)
{
	TextAction* result;
	TextAction* _tmp0_;
	TextAction* _tmp1_;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (self), NULL);
	_tmp0_ = self->priv->_text;
	_vala_assert (_tmp0_ != NULL, "_text != null");
	_tmp1_ = self->priv->_text;
	result = _tmp1_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN (GClosure * closure,
                                                               GValue * return_value,
                                                               guint n_param_values,
                                                               const GValue * param_values,
                                                               gpointer invocation_hint,
                                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gboolean arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_boolean (param_values + 4), data2);
}

static void
value_search_filter_actions_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_search_filter_actions_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		search_filter_actions_unref (value->data[0].v_pointer);
	}
}

static void
value_search_filter_actions_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = search_filter_actions_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_search_filter_actions_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_search_filter_actions_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		SearchFilterActions * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = search_filter_actions_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_search_filter_actions_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	SearchFilterActions ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = search_filter_actions_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_search_filter_actions (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	ParamSpecSearchFilterActions* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SEARCH_FILTER_ACTIONS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_search_filter_actions (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS), NULL);
	return value->data[0].v_pointer;
}

void
value_set_search_filter_actions (GValue* value,
                                 gpointer v_object)
{
	SearchFilterActions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_FILTER_ACTIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		search_filter_actions_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		search_filter_actions_unref (old);
	}
}

void
value_take_search_filter_actions (GValue* value,
                                  gpointer v_object)
{
	SearchFilterActions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEARCH_FILTER_ACTIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEARCH_FILTER_ACTIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		search_filter_actions_unref (old);
	}
}

static void
search_filter_actions_class_init (SearchFilterActionsClass * klass,
                                  gpointer klass_data)
{
	search_filter_actions_parent_class = g_type_class_peek_parent (klass);
	((SearchFilterActionsClass *) klass)->finalize = search_filter_actions_finalize;
	g_type_class_adjust_private_offset (klass, &SearchFilterActions_private_offset);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_FLAGGED_TOGGLED_SIGNAL] = g_signal_new ("flagged-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_PHOTOS_TOGGLED_SIGNAL] = g_signal_new ("photos-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_VIDEOS_TOGGLED_SIGNAL] = g_signal_new ("videos-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RAW_TOGGLED_SIGNAL] = g_signal_new ("raw-toggled", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_RATING_CHANGED_SIGNAL] = g_signal_new ("rating-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TYPE_RATING_FILTER);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_TEXT_CHANGED_SIGNAL] = g_signal_new ("text-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	/**
	     * fired when the kinds of media present in the current view change (e.g., a video becomes
	     * available in the view through a new import operation or no raw photos are available in
	     * the view anymore because the last one was moved to the trash)
	     */
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_MEDIA_CONTEXT_CHANGED_SIGNAL] = g_signal_new ("media-context-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN_BOOLEAN_BOOLEAN, G_TYPE_NONE, 4, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
	search_filter_actions_signals[SEARCH_FILTER_ACTIONS_CRITERIA_CHANGED_SIGNAL] = g_signal_new ("criteria-changed", TYPE_SEARCH_FILTER_ACTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
search_filter_actions_instance_init (SearchFilterActions * self,
                                     gpointer klass)
{
	self->priv = search_filter_actions_get_instance_private (self);
	self->priv->criteria = SEARCH_FILTER_CRITERIA_ALL;
	self->priv->_text = NULL;
	self->priv->has_flagged = TRUE;
	self->priv->has_photos = TRUE;
	self->priv->has_videos = TRUE;
	self->priv->has_raw = TRUE;
	self->priv->can_filter_by_stars = TRUE;
	self->ref_count = 1;
}

static void
search_filter_actions_finalize (SearchFilterActions * obj)
{
	SearchFilterActions * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_FILTER_ACTIONS, SearchFilterActions);
	g_signal_handlers_destroy (self);
	_text_action_unref0 (self->priv->_text);
}

static GType
search_filter_actions_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_search_filter_actions_init, value_search_filter_actions_free_value, value_search_filter_actions_copy_value, value_search_filter_actions_peek_pointer, "p", value_search_filter_actions_collect_value, "p", value_search_filter_actions_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterActionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_actions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterActions), 0, (GInstanceInitFunc) search_filter_actions_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType search_filter_actions_type_id;
	search_filter_actions_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SearchFilterActions", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SearchFilterActions_private_offset = g_type_add_instance_private (search_filter_actions_type_id, sizeof (SearchFilterActionsPrivate));
	return search_filter_actions_type_id;
}

GType
search_filter_actions_get_type (void)
{
	static volatile gsize search_filter_actions_type_id__once = 0;
	if (g_once_init_enter (&search_filter_actions_type_id__once)) {
		GType search_filter_actions_type_id;
		search_filter_actions_type_id = search_filter_actions_get_type_once ();
		g_once_init_leave (&search_filter_actions_type_id__once, search_filter_actions_type_id);
	}
	return search_filter_actions_type_id__once;
}

gpointer
search_filter_actions_ref (gpointer instance)
{
	SearchFilterActions * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
search_filter_actions_unref (gpointer instance)
{
	SearchFilterActions * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SEARCH_FILTER_ACTIONS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
search_filter_toolbar_get_instance_private (SearchFilterToolbar* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbar_private_offset);
}

static void
_search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed (SearchFilterActions* _sender,
                                                                                             gboolean has_photos,
                                                                                             gboolean has_videos,
                                                                                             gboolean has_raw,
                                                                                             gboolean has_flagged,
                                                                                             gpointer self)
{
	search_filter_toolbar_on_media_context_changed ((SearchFilterToolbar*) self, has_photos, has_videos, has_raw, has_flagged);
}

static void
_search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled (SearchFilterActions* _sender,
                                                                                 gboolean on,
                                                                                 gpointer self)
{
	search_filter_toolbar_on_flagged_toggled ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled (SearchFilterActions* _sender,
                                                                               gboolean on,
                                                                               gpointer self)
{
	search_filter_toolbar_on_photos_toggled ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled (SearchFilterActions* _sender,
                                                                               gboolean on,
                                                                               gpointer self)
{
	search_filter_toolbar_on_videos_toggled ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled (SearchFilterActions* _sender,
                                                                         gboolean on,
                                                                         gpointer self)
{
	search_filter_toolbar_on_raw_toggled ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed (SearchFilterActions* _sender,
                                                                               RatingFilter filter,
                                                                               gpointer self)
{
	search_filter_toolbar_on_rating_changed ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed (SearchFilterActions* _sender,
                                                                                  const gchar* text,
                                                                                  gpointer self)
{
	search_filter_toolbar_on_search_text_changed ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed (SearchFilterActions* _sender,
                                                                                   gpointer self)
{
	search_filter_toolbar_on_criteria_changed ((SearchFilterToolbar*) self);
}

static gboolean
_search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu (GtkToolbar* _sender,
                                                                                 gint x,
                                                                                 gint y,
                                                                                 gint button_number,
                                                                                 gpointer self)
{
	gboolean result;
	result = search_filter_toolbar_on_context_menu_requested ((SearchFilterToolbar*) self, x, y, button_number);
	return result;
}

static gpointer
_search_filter_actions_ref0 (gpointer self)
{
	return self ? search_filter_actions_ref (self) : NULL;
}

static void
_search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                            gpointer self)
{
	search_filter_toolbar_on_context_menu_close_chosen ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked (SearchFilterToolbarSavedSearchFilterButton* _sender,
                                                                                                                gpointer self)
{
	search_filter_toolbar_on_saved_search_button_clicked ((SearchFilterToolbar*) self);
}

SearchFilterToolbar*
search_filter_toolbar_construct (GType object_type,
                                 SearchFilterActions* actions)
{
	SearchFilterToolbar * self = NULL;
	SearchFilterActions* _tmp0_;
	GtkToolbar* _tmp1_;
	TextAction* _tmp2_;
	TextAction* _tmp3_;
	SearchFilterToolbarSearchBox* _tmp4_;
	GtkToolbar* _tmp5_;
	GtkToolbar* _tmp6_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	SearchFilterToolbarLabelToolItem* _tmp19_;
	GtkToolbar* _tmp20_;
	SearchFilterToolbarLabelToolItem* _tmp21_;
	SearchFilterToolbarToggleActionToolButton* _tmp22_;
	SearchFilterToolbarToggleActionToolButton* _tmp23_;
	SearchFilterToolbarToggleActionToolButton* _tmp24_;
	SearchFilterToolbarToggleActionToolButton* _tmp25_;
	SearchFilterToolbarToggleActionToolButton* _tmp26_;
	SearchFilterToolbarToggleActionToolButton* _tmp27_;
	GtkToolbar* _tmp28_;
	SearchFilterToolbarToggleActionToolButton* _tmp29_;
	GtkToolbar* _tmp30_;
	SearchFilterToolbarToggleActionToolButton* _tmp31_;
	GtkToolbar* _tmp32_;
	SearchFilterToolbarToggleActionToolButton* _tmp33_;
	GtkSeparatorToolItem* _tmp34_;
	GtkToolbar* _tmp35_;
	GtkSeparatorToolItem* _tmp36_;
	SearchFilterToolbarToggleActionToolButton* _tmp37_;
	SearchFilterToolbarToggleActionToolButton* _tmp38_;
	SearchFilterToolbarToggleActionToolButton* _tmp39_;
	GtkToolbar* _tmp40_;
	SearchFilterToolbarToggleActionToolButton* _tmp41_;
	GtkSeparatorToolItem* _tmp42_;
	GtkToolbar* _tmp43_;
	GtkSeparatorToolItem* _tmp44_;
	GMenuModel* model = NULL;
	GtkBuilder* _tmp45_;
	GObject* _tmp46_;
	GMenuModel* _tmp47_;
	SearchFilterToolbarRatingFilterButton* _tmp48_;
	SearchFilterToolbarRatingFilterButton* _tmp49_;
	SearchFilterToolbarRatingFilterButton* _tmp50_;
	GtkToolbar* _tmp51_;
	SearchFilterToolbarRatingFilterButton* _tmp52_;
	GtkSeparatorToolItem* _tmp53_;
	GtkToolbar* _tmp54_;
	GtkSeparatorToolItem* _tmp55_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp56_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp57_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp58_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp59_;
	GtkToolbar* _tmp60_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp61_;
	GtkSeparatorToolItem* separator_align = NULL;
	GtkSeparatorToolItem* _tmp62_;
	GtkToolbar* _tmp63_;
	GtkToolbar* _tmp64_;
	SearchFilterToolbarSearchBox* _tmp65_;
	GtkToolbar* _tmp66_;
	GtkToolbar* _tmp67_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (IS_SEARCH_FILTER_ACTIONS (actions), NULL);
	self = (SearchFilterToolbar*) g_object_new (object_type, NULL);
	_tmp0_ = _search_filter_actions_ref0 (actions);
	_search_filter_actions_unref0 (self->priv->actions);
	self->priv->actions = _tmp0_;
	_tmp1_ = (GtkToolbar*) gtk_toolbar_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->toolbar);
	self->priv->toolbar = _tmp1_;
	g_signal_connect_object (actions, "media-context-changed", (GCallback) _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed, self, 0);
	_tmp2_ = search_filter_actions_get_text (actions);
	_tmp3_ = _tmp2_;
	_tmp4_ = search_filter_toolbar_search_box_new (_tmp3_);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->search_box);
	self->priv->search_box = _tmp4_;
	_tmp5_ = self->priv->toolbar;
	gtk_buildable_set_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_buildable_get_type (), GtkBuildable), "search-filter-toolbar");
	_tmp6_ = self->priv->toolbar;
	gtk_toolbar_set_icon_size (_tmp6_, GTK_ICON_SIZE_SMALL_TOOLBAR);
	{
		GtkBuilder* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = self->builder;
		_tmp8_ = resources_get_ui ("search_bar.ui");
		_tmp9_ = _tmp8_;
		gtk_builder_add_from_resource (_tmp7_, _tmp9_, &_inner_error0_);
		_g_free0 (_tmp9_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = err;
		_tmp11_ = _tmp10_->message;
		_tmp12_ = g_strdup_printf (_ ("Error loading search bar UI: %s"), _tmp11_);
		_tmp13_ = _tmp12_;
		app_window_panic (_tmp13_);
		_g_free0 (_tmp13_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp14_ = self->priv->close_item;
	gtk_menu_item_set_label (_tmp14_, _ ("Close"));
	_tmp15_ = self->priv->close_item;
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
	_tmp16_ = self->priv->close_item;
	g_signal_connect_object (_tmp16_, "activate", (GCallback) _search_filter_toolbar_on_context_menu_close_chosen_gtk_menu_item_activate, self, 0);
	_tmp17_ = self->priv->close_menu;
	_tmp18_ = self->priv->close_item;
	gtk_menu_shell_append (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_menu_shell_get_type (), GtkMenuShell), _tmp18_);
	_tmp19_ = search_filter_toolbar_label_tool_item_new (_ ("Type"), 10, 5);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->label_type);
	self->priv->label_type = _tmp19_;
	_tmp20_ = self->priv->toolbar;
	_tmp21_ = self->priv->label_type;
	gtk_toolbar_insert (_tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp22_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.photos");
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->toolbtn_photos);
	self->priv->toolbtn_photos = _tmp22_;
	_tmp23_ = self->priv->toolbtn_photos;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_tool_item_get_type (), GtkToolItem), _ ("Photos"));
	_tmp24_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.videos");
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->toolbtn_videos);
	self->priv->toolbtn_videos = _tmp24_;
	_tmp25_ = self->priv->toolbtn_videos;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_tool_item_get_type (), GtkToolItem), _ ("Videos"));
	_tmp26_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.raw");
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->toolbtn_raw);
	self->priv->toolbtn_raw = _tmp26_;
	_tmp27_ = self->priv->toolbtn_raw;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_tool_item_get_type (), GtkToolItem), _ ("RAW Photos"));
	_tmp28_ = self->priv->toolbar;
	_tmp29_ = self->priv->toolbtn_photos;
	gtk_toolbar_insert (_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp30_ = self->priv->toolbar;
	_tmp31_ = self->priv->toolbtn_videos;
	gtk_toolbar_insert (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp32_ = self->priv->toolbar;
	_tmp33_ = self->priv->toolbtn_raw;
	gtk_toolbar_insert (_tmp32_, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp34_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->sepr_mediatype_flagged);
	self->priv->sepr_mediatype_flagged = _tmp34_;
	_tmp35_ = self->priv->toolbar;
	_tmp36_ = self->priv->sepr_mediatype_flagged;
	gtk_toolbar_insert (_tmp35_, G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp37_ = search_filter_toolbar_toggle_action_tool_button_new ("win.display.flagged");
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->toolbtn_flag);
	self->priv->toolbtn_flag = _tmp37_;
	_tmp38_ = self->priv->toolbtn_flag;
	search_filter_toolbar_toggle_action_tool_button_set_label (_tmp38_, _ ("Flagged"));
	_tmp39_ = self->priv->toolbtn_flag;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_tool_item_get_type (), GtkToolItem), _ ("Flagged"));
	_tmp40_ = self->priv->toolbar;
	_tmp41_ = self->priv->toolbtn_flag;
	gtk_toolbar_insert (_tmp40_, G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp42_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->sepr_flagged_rating);
	self->priv->sepr_flagged_rating = _tmp42_;
	_tmp43_ = self->priv->toolbar;
	_tmp44_ = self->priv->sepr_flagged_rating;
	gtk_toolbar_insert (_tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp45_ = self->builder;
	_tmp46_ = gtk_builder_get_object (_tmp45_, "popup-menu");
	_tmp47_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, g_menu_model_get_type ()) ? ((GMenuModel*) _tmp46_) : NULL);
	model = _tmp47_;
	_tmp48_ = search_filter_toolbar_rating_filter_button_new (model);
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (self->priv->rating_button);
	self->priv->rating_button = _tmp48_;
	_tmp49_ = self->priv->rating_button;
	search_filter_toolbar_rating_filter_button_set_label (_tmp49_, _ ("Rating"));
	_tmp50_ = self->priv->rating_button;
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_tool_item_get_type (), GtkToolItem), FALSE);
	_tmp51_ = self->priv->toolbar;
	_tmp52_ = self->priv->rating_button;
	gtk_toolbar_insert (_tmp51_, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp53_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
	g_object_ref_sink (_tmp53_);
	_g_object_unref0 (self->priv->sepr_rating_saved);
	self->priv->sepr_rating_saved = _tmp53_;
	_tmp54_ = self->priv->toolbar;
	_tmp55_ = self->priv->sepr_rating_saved;
	gtk_toolbar_insert (_tmp54_, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp56_ = self->priv->saved_search_button;
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, gtk_tool_item_get_type (), GtkToolItem), FALSE);
	_tmp57_ = self->priv->saved_search_button;
	search_filter_toolbar_saved_search_filter_button_set_label (_tmp57_, _ ("Saved Search"));
	_tmp58_ = self->priv->saved_search_button;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_tool_item_get_type (), GtkToolItem), _ ("Use a saved search to filter items in the current view"));
	_tmp59_ = self->priv->saved_search_button;
	g_signal_connect_object (_tmp59_, "clicked", (GCallback) _search_filter_toolbar_on_saved_search_button_clicked_search_filter_toolbar_saved_search_filter_button_clicked, self, 0);
	_tmp60_ = self->priv->toolbar;
	_tmp61_ = self->priv->saved_search_button;
	gtk_toolbar_insert (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp62_ = (GtkSeparatorToolItem*) gtk_separator_tool_item_new ();
	g_object_ref_sink (_tmp62_);
	separator_align = _tmp62_;
	gtk_tool_item_set_expand (G_TYPE_CHECK_INSTANCE_CAST (separator_align, gtk_tool_item_get_type (), GtkToolItem), TRUE);
	gtk_separator_tool_item_set_draw (separator_align, FALSE);
	_tmp63_ = self->priv->toolbar;
	gtk_toolbar_insert (_tmp63_, G_TYPE_CHECK_INSTANCE_CAST (separator_align, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp64_ = self->priv->toolbar;
	_tmp65_ = self->priv->search_box;
	gtk_toolbar_insert (_tmp64_, G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_tool_item_get_type (), GtkToolItem), -1);
	_tmp66_ = self->priv->toolbar;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, gtk_widget_get_type (), GtkWidget));
	g_signal_connect_object (actions, "flagged-toggled", (GCallback) _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled, self, 0);
	g_signal_connect_object (actions, "photos-toggled", (GCallback) _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled, self, 0);
	g_signal_connect_object (actions, "videos-toggled", (GCallback) _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled, self, 0);
	g_signal_connect_object (actions, "raw-toggled", (GCallback) _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled, self, 0);
	g_signal_connect_object (actions, "rating-changed", (GCallback) _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed, self, 0);
	g_signal_connect_object (actions, "text-changed", (GCallback) _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed, self, 0);
	g_signal_connect_object (actions, "criteria-changed", (GCallback) _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed, self, 0);
	_tmp67_ = self->priv->toolbar;
	g_signal_connect_object (_tmp67_, "popup-context-menu", (GCallback) _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu, self, 0);
	search_filter_toolbar_on_media_context_changed (self, search_filter_actions_get_has_photos (actions), search_filter_actions_get_has_videos (actions), search_filter_actions_get_has_raw (actions), search_filter_actions_get_has_flagged (actions));
	_g_object_unref0 (separator_align);
	_g_object_unref0 (model);
	return self;
}

SearchFilterToolbar*
search_filter_toolbar_new (SearchFilterActions* actions)
{
	return search_filter_toolbar_construct (TYPE_SEARCH_FILTER_TOOLBAR, actions);
}

static void
search_filter_toolbar_on_media_context_changed (SearchFilterToolbar* self,
                                                gboolean has_photos,
                                                gboolean has_videos,
                                                gboolean has_raw,
                                                gboolean has_flagged)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	if (has_photos) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = has_raw;
	}
	if (_tmp0_) {
		SearchFilterToolbarToggleActionToolButton* _tmp1_;
		_tmp1_ = self->priv->toolbtn_photos;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp1_, "filter-photos-symbolic");
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp2_;
		_tmp2_ = self->priv->toolbtn_photos;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp2_, "filter-photos-disabled-symbolic");
	}
	if (has_videos) {
		SearchFilterToolbarToggleActionToolButton* _tmp3_;
		_tmp3_ = self->priv->toolbtn_videos;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp3_, "filter-videos-symbolic");
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp4_;
		_tmp4_ = self->priv->toolbtn_videos;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp4_, "filter-videos-disabled-symbolic");
	}
	if (has_raw) {
		SearchFilterToolbarToggleActionToolButton* _tmp5_;
		_tmp5_ = self->priv->toolbtn_raw;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp5_, "filter-raw-symbolic");
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp6_;
		_tmp6_ = self->priv->toolbtn_raw;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp6_, "filter-raw-disabled-symbolic");
	}
	if (has_flagged) {
		SearchFilterToolbarToggleActionToolButton* _tmp7_;
		_tmp7_ = self->priv->toolbtn_flag;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp7_, "filter-flagged-symbolic");
	} else {
		SearchFilterToolbarToggleActionToolButton* _tmp8_;
		_tmp8_ = self->priv->toolbtn_flag;
		search_filter_toolbar_toggle_action_tool_button_set_icon_name (_tmp8_, "filter-flagged-disabled-symbolic");
	}
}

static gboolean
search_filter_toolbar_on_context_menu_requested (SearchFilterToolbar* self,
                                                 gint x,
                                                 gint y,
                                                 gint button)
{
	GtkMenu* _tmp0_;
	gboolean result;
	g_return_val_if_fail (IS_SEARCH_FILTER_TOOLBAR (self), FALSE);
	_tmp0_ = self->priv->close_menu;
	gtk_menu_popup_at_pointer (_tmp0_, NULL);
	result = FALSE;
	return result;
}

static GVariant*
_variant_new35 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
search_filter_toolbar_on_context_menu_close_chosen (SearchFilterToolbar* self)
{
	AppWindow* aw = NULL;
	LibraryWindow* _tmp0_;
	GSimpleAction* action = NULL;
	AppWindow* _tmp1_;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = library_window_get_app ();
	aw = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_APP_WINDOW, AppWindow);
	_tmp1_ = aw;
	_tmp2_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_map_get_type (), GActionMap), "CommonDisplaySearchbar");
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL);
	action = _tmp3_;
	_tmp4_ = action;
	if (_tmp4_ != NULL) {
		GSimpleAction* _tmp5_;
		GVariant* _tmp6_;
		_tmp5_ = action;
		_tmp6_ = _variant_new35 (FALSE);
		g_signal_emit_by_name (_tmp5_, "change-state", _tmp6_);
		_g_variant_unref0 (_tmp6_);
	}
	_g_object_unref0 (action);
	_g_object_unref0 (aw);
}

static void
search_filter_toolbar_on_flagged_toggled (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_on_videos_toggled (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_on_photos_toggled (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_on_raw_toggled (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_on_search_text_changed (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static GVariant*
_variant_new36 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
search_filter_toolbar_on_rating_changed (SearchFilterToolbar* self)
{
	AppWindow* aw = NULL;
	LibraryWindow* _tmp0_;
	AppWindow* _tmp1_;
	GSimpleAction* action = NULL;
	AppWindow* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = library_window_get_app ();
	aw = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_APP_WINDOW, AppWindow);
	_tmp1_ = aw;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (aw);
		return;
	}
	_tmp2_ = aw;
	_tmp3_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_action_map_get_type (), GActionMap), "CommonDisplaySearchbar");
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp3_) : NULL);
	action = _tmp4_;
	_tmp5_ = action;
	if (_tmp5_ != NULL) {
		GSimpleAction* _tmp6_;
		GVariant* _tmp7_;
		_tmp6_ = action;
		_tmp7_ = _variant_new36 (TRUE);
		g_signal_emit_by_name (_tmp6_, "change-state", _tmp7_);
		_g_variant_unref0 (_tmp7_);
	}
	search_filter_toolbar_update (self);
	_g_object_unref0 (action);
	_g_object_unref0 (aw);
}

static void
search_filter_toolbar_on_criteria_changed (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	search_filter_toolbar_update (self);
}

static gpointer
_view_filter_ref0 (gpointer self)
{
	return self ? view_filter_ref (self) : NULL;
}

void
search_filter_toolbar_set_view_filter (SearchFilterToolbar* self,
                                       SearchViewFilter* search_filter)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp1_;
	SearchFilterActions* _tmp2_;
	SearchFilterToolbarRatingFilterButton* _tmp3_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	g_return_if_fail (IS_SEARCH_VIEW_FILTER (search_filter));
	_tmp0_ = self->priv->search_filter;
	if (search_filter == _tmp0_) {
		return;
	}
	_tmp1_ = _view_filter_ref0 (search_filter);
	_view_filter_unref0 (self->priv->search_filter);
	self->priv->search_filter = _tmp1_;
	_tmp2_ = self->priv->actions;
	search_filter_actions_set_sensitive_for_search_criteria (_tmp2_, (SearchFilterCriteria) search_view_filter_get_criteria (search_filter));
	_tmp3_ = self->priv->rating_button;
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), (SEARCH_FILTER_CRITERIA_RATING & search_view_filter_get_criteria (search_filter)) != 0);
	search_filter_toolbar_update (self);
}

void
search_filter_toolbar_unset_view_filter (SearchFilterToolbar* self)
{
	DisabledViewFilter* _tmp0_;
	DisabledViewFilter* _tmp1_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = disabled_view_filter_new ();
	_tmp1_ = _tmp0_;
	search_filter_toolbar_set_view_filter (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SEARCH_VIEW_FILTER, SearchViewFilter));
	_view_filter_unref0 (_tmp1_);
}

void
search_filter_toolbar_update (SearchFilterToolbar* self)
{
	SearchViewFilter* _tmp0_;
	SearchViewFilter* _tmp3_;
	SearchViewFilter* _tmp4_;
	SearchFilterActions* _tmp5_;
	TextAction* _tmp6_;
	TextAction* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	SearchViewFilter* _tmp10_;
	SearchFilterActions* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	SearchViewFilter* _tmp16_;
	SearchFilterActions* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	SearchViewFilter* _tmp22_;
	SearchFilterActions* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GVariant* _tmp26_;
	GVariant* _tmp27_;
	SearchViewFilter* _tmp28_;
	SearchFilterActions* _tmp29_;
	GSimpleAction* _tmp30_;
	GSimpleAction* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	RatingFilter filter = 0;
	SearchFilterActions* _tmp34_;
	GSimpleAction* _tmp35_;
	GSimpleAction* _tmp36_;
	GVariant* _tmp37_;
	GVariant* _tmp38_;
	const gchar* _tmp39_;
	RatingFilter _tmp40_;
	SearchViewFilter* _tmp41_;
	SearchFilterToolbarRatingFilterButton* _tmp42_;
	SearchViewFilter* _tmp43_;
	SavedSearch* _tmp44_;
	SearchFilterCriteria criteria = 0U;
	SearchFilterActions* _tmp45_;
	SearchFilterToolbarSearchBox* _tmp46_;
	SearchFilterToolbarRatingFilterButton* _tmp47_;
	SearchFilterToolbarToggleActionToolButton* _tmp48_;
	SearchFilterToolbarLabelToolItem* _tmp49_;
	SearchFilterToolbarToggleActionToolButton* _tmp50_;
	SearchFilterToolbarToggleActionToolButton* _tmp51_;
	SearchFilterToolbarToggleActionToolButton* _tmp52_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp53_;
	gboolean _tmp54_ = FALSE;
	SearchFilterToolbarLabelToolItem* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_;
	GtkSeparatorToolItem* _tmp61_;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp63_ = FALSE;
	SearchFilterToolbarLabelToolItem* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	GtkSeparatorToolItem* _tmp77_;
	SearchViewFilter* _tmp78_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = self->priv->search_filter;
	if (NULL == _tmp0_) {
		LibraryWindow* _tmp1_;
		LibraryWindow* _tmp2_;
		_tmp1_ = library_window_get_app ();
		_tmp2_ = _tmp1_;
		library_window_show_search_bar (_tmp2_, TRUE);
		_g_object_unref0 (_tmp2_);
	}
	_tmp3_ = self->priv->search_filter;
	_vala_assert (NULL != _tmp3_, "null != search_filter");
	_tmp4_ = self->priv->search_filter;
	_tmp5_ = self->priv->actions;
	_tmp6_ = search_filter_actions_get_text (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = text_action_get_value (_tmp7_);
	_tmp9_ = _tmp8_;
	search_view_filter_set_search_filter (_tmp4_, _tmp9_);
	_tmp10_ = self->priv->search_filter;
	_tmp11_ = self->priv->actions;
	_tmp12_ = search_filter_actions_get_flagged (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_action_get_type (), GAction));
	_tmp15_ = _tmp14_;
	search_view_filter_set_flagged (_tmp10_, g_variant_get_boolean (_tmp15_));
	_g_variant_unref0 (_tmp15_);
	_tmp16_ = self->priv->search_filter;
	_tmp17_ = self->priv->actions;
	_tmp18_ = search_filter_actions_get_videos (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, g_action_get_type (), GAction));
	_tmp21_ = _tmp20_;
	search_view_filter_set_show_media_video (_tmp16_, g_variant_get_boolean (_tmp21_));
	_g_variant_unref0 (_tmp21_);
	_tmp22_ = self->priv->search_filter;
	_tmp23_ = self->priv->actions;
	_tmp24_ = search_filter_actions_get_photos (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_action_get_type (), GAction));
	_tmp27_ = _tmp26_;
	search_view_filter_set_show_media_photos (_tmp22_, g_variant_get_boolean (_tmp27_));
	_g_variant_unref0 (_tmp27_);
	_tmp28_ = self->priv->search_filter;
	_tmp29_ = self->priv->actions;
	_tmp30_ = search_filter_actions_get_raw (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, g_action_get_type (), GAction));
	_tmp33_ = _tmp32_;
	search_view_filter_set_show_media_raw (_tmp28_, g_variant_get_boolean (_tmp33_));
	_g_variant_unref0 (_tmp33_);
	_tmp34_ = self->priv->actions;
	_tmp35_ = search_filter_actions_get_rating (_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = g_action_get_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, g_action_get_type (), GAction));
	_tmp38_ = _tmp37_;
	_tmp39_ = g_variant_get_string (_tmp38_, NULL);
	_tmp40_ = (RatingFilter) atoi (_tmp39_);
	_g_variant_unref0 (_tmp38_);
	filter = _tmp40_;
	_tmp41_ = self->priv->search_filter;
	search_view_filter_set_rating_filter (_tmp41_, filter);
	_tmp42_ = self->priv->rating_button;
	search_filter_toolbar_rating_filter_button_set_filter_icon (_tmp42_, filter);
	_tmp43_ = self->priv->search_filter;
	_tmp44_ = self->priv->saved_search;
	search_view_filter_set_saved_search (_tmp43_, _tmp44_);
	_tmp45_ = self->priv->actions;
	criteria = search_filter_actions_get_criteria (_tmp45_);
	_tmp46_ = self->priv->search_box;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_TEXT) != 0);
	_tmp47_ = self->priv->rating_button;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_RATING) != 0);
	_tmp48_ = self->priv->toolbtn_flag;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_FLAG) != 0);
	_tmp49_ = self->priv->label_type;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
	_tmp50_ = self->priv->toolbtn_photos;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
	_tmp51_ = self->priv->toolbtn_videos;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
	_tmp52_ = self->priv->toolbtn_raw;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_MEDIA) != 0);
	_tmp53_ = self->priv->saved_search_button;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, gtk_widget_get_type (), GtkWidget), (criteria & SEARCH_FILTER_CRITERIA_SAVEDSEARCH) != 0);
	_tmp55_ = self->priv->label_type;
	_tmp56_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_widget_get_type (), GtkWidget));
	_tmp57_ = _tmp56_;
	if (_tmp57_) {
		SearchFilterToolbarToggleActionToolButton* _tmp58_;
		gboolean _tmp59_;
		gboolean _tmp60_;
		_tmp58_ = self->priv->toolbtn_flag;
		_tmp59_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_widget_get_type (), GtkWidget));
		_tmp60_ = _tmp59_;
		_tmp54_ = _tmp60_;
	} else {
		_tmp54_ = FALSE;
	}
	_tmp61_ = self->priv->sepr_mediatype_flagged;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_widget_get_type (), GtkWidget), _tmp54_);
	_tmp64_ = self->priv->label_type;
	_tmp65_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_widget_get_type (), GtkWidget));
	_tmp66_ = _tmp65_;
	if (_tmp66_) {
		SearchFilterToolbarRatingFilterButton* _tmp67_;
		gboolean _tmp68_;
		gboolean _tmp69_;
		_tmp67_ = self->priv->rating_button;
		_tmp68_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_widget_get_type (), GtkWidget));
		_tmp69_ = _tmp68_;
		_tmp63_ = _tmp69_;
	} else {
		_tmp63_ = FALSE;
	}
	if (_tmp63_) {
		_tmp62_ = TRUE;
	} else {
		gboolean _tmp70_ = FALSE;
		SearchFilterToolbarToggleActionToolButton* _tmp71_;
		gboolean _tmp72_;
		gboolean _tmp73_;
		_tmp71_ = self->priv->toolbtn_flag;
		_tmp72_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_widget_get_type (), GtkWidget));
		_tmp73_ = _tmp72_;
		if (_tmp73_) {
			SearchFilterToolbarRatingFilterButton* _tmp74_;
			gboolean _tmp75_;
			gboolean _tmp76_;
			_tmp74_ = self->priv->rating_button;
			_tmp75_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, gtk_widget_get_type (), GtkWidget));
			_tmp76_ = _tmp75_;
			_tmp70_ = _tmp76_;
		} else {
			_tmp70_ = FALSE;
		}
		_tmp62_ = _tmp70_;
	}
	_tmp77_ = self->priv->sepr_flagged_rating;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, gtk_widget_get_type (), GtkWidget), _tmp62_);
	_tmp78_ = self->priv->search_filter;
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, TYPE_VIEW_FILTER, ViewFilter), "refresh");
}

static void
search_filter_toolbar_on_savedsearch_selected (SearchFilterToolbar* self,
                                               SavedSearch* saved_search)
{
	SavedSearch* _tmp0_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	g_return_if_fail (IS_SAVED_SEARCH (saved_search));
	_tmp0_ = _g_object_ref0 (saved_search);
	_g_object_unref0 (self->priv->saved_search);
	self->priv->saved_search = _tmp0_;
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_disable_savedsearch (SearchFilterToolbar* self)
{
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_g_object_unref0 (self->priv->saved_search);
	self->priv->saved_search = NULL;
	search_filter_toolbar_update (self);
}

static void
search_filter_toolbar_edit_dialog (SearchFilterToolbar* self,
                                   SavedSearch* search)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
	SavedSearchDialog* ssd = NULL;
	SavedSearchDialog* _tmp2_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	g_return_if_fail (IS_SAVED_SEARCH (search));
	_tmp0_ = self->priv->saved_search_button;
	_tmp1_ = _tmp0_->filter_popup;
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
	_tmp2_ = saved_search_dialog_new_edit_existing (search);
	g_object_ref_sink (_tmp2_);
	ssd = _tmp2_;
	saved_search_dialog_show (ssd);
	_g_object_unref0 (ssd);
}

static void
search_filter_toolbar_delete_dialog (SearchFilterToolbar* self,
                                     SavedSearch* search)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	g_return_if_fail (IS_SAVED_SEARCH (search));
	_tmp0_ = self->priv->saved_search_button;
	_tmp1_ = _tmp0_->filter_popup;
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
	if (dialogs_confirm_delete_saved_search (search)) {
		CommandManager* _tmp2_;
		CommandManager* _tmp3_;
		DeleteSavedSearchCommand* _tmp4_;
		DeleteSavedSearchCommand* _tmp5_;
		_tmp2_ = app_window_get_command_manager ();
		_tmp3_ = _tmp2_;
		_tmp4_ = delete_saved_search_command_new (search);
		_tmp5_ = _tmp4_;
		command_manager_execute (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_COMMAND, Command));
		_g_object_unref0 (_tmp5_);
		_command_manager_unref0 (_tmp3_);
	}
}

static void
search_filter_toolbar_add_dialog (SearchFilterToolbar* self)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopover* _tmp1_;
	SavedSearchDialog* _tmp2_;
	SavedSearchDialog* _tmp3_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = self->priv->saved_search_button;
	_tmp1_ = _tmp0_->filter_popup;
	search_filter_toolbar_saved_search_popover_hide (_tmp1_);
	_tmp2_ = saved_search_dialog_new ();
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	saved_search_dialog_show (_tmp3_);
	_g_object_unref0 (_tmp3_);
}

static void
search_filter_toolbar_on_popover_closed (SearchFilterToolbar* self)
{
	SearchFilterToolbarSavedSearchFilterButton* _tmp0_;
	SavedSearch* _tmp1_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp2_;
	SearchFilterToolbarSavedSearchPopover* _tmp3_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	self->priv->elide_showing_again = TRUE;
	_tmp0_ = self->priv->saved_search_button;
	_tmp1_ = self->priv->saved_search;
	search_filter_toolbar_saved_search_filter_button_set_active (_tmp0_, _tmp1_ != NULL);
	_tmp2_ = self->priv->saved_search_button;
	_tmp3_ = _tmp2_->filter_popup;
	search_filter_toolbar_saved_search_popover_hide (_tmp3_);
}

static void
_search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                            SavedSearch* search,
                                                                                            gpointer self)
{
	search_filter_toolbar_edit_dialog ((SearchFilterToolbar*) self, search);
}

static void
_search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                            SavedSearch* search,
                                                                                                            gpointer self)
{
	search_filter_toolbar_on_savedsearch_selected ((SearchFilterToolbar*) self, search);
}

static void
_search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                                SavedSearch* search,
                                                                                                gpointer self)
{
	search_filter_toolbar_delete_dialog ((SearchFilterToolbar*) self, search);
}

static void
_search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                          gpointer self)
{
	search_filter_toolbar_add_dialog ((SearchFilterToolbar*) self);
}

static void
_search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed (SearchFilterToolbarSavedSearchPopover* _sender,
                                                                                            gpointer self)
{
	search_filter_toolbar_on_popover_closed ((SearchFilterToolbar*) self);
}

static void
search_filter_toolbar_on_saved_search_button_clicked (SearchFilterToolbar* self)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	if (self->priv->elide_showing_again) {
		SavedSearch* _tmp1_;
		_tmp1_ = self->priv->saved_search;
		_tmp0_ = _tmp1_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
	} else {
		SavedSearch* _tmp2_;
		_tmp2_ = self->priv->saved_search;
		if (_tmp2_ != NULL) {
			SearchFilterToolbarSavedSearchFilterButton* _tmp3_;
			_g_object_unref0 (self->priv->saved_search);
			self->priv->saved_search = NULL;
			_tmp3_ = self->priv->saved_search_button;
			search_filter_toolbar_saved_search_filter_button_set_active (_tmp3_, FALSE);
			search_filter_toolbar_disable_savedsearch (self);
		} else {
			SearchFilterToolbarSavedSearchFilterButton* _tmp4_;
			SearchFilterToolbarSavedSearchPopover* _tmp5_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp21_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp22_;
			SearchFilterToolbarSavedSearchPopover* _tmp23_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp24_;
			SearchFilterToolbarSavedSearchPopover* _tmp25_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp26_;
			SearchFilterToolbarSavedSearchPopover* _tmp27_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp28_;
			SearchFilterToolbarSavedSearchPopover* _tmp29_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp30_;
			SearchFilterToolbarSavedSearchPopover* _tmp31_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp32_;
			SearchFilterToolbarSavedSearchPopover* _tmp33_;
			SearchFilterToolbarSavedSearchFilterButton* _tmp34_;
			SearchFilterToolbarSavedSearchPopover* _tmp35_;
			_tmp4_ = self->priv->saved_search_button;
			_tmp5_ = _tmp4_->filter_popup;
			if (_tmp5_ != NULL) {
				SearchFilterToolbarSavedSearchFilterButton* _tmp6_;
				SearchFilterToolbarSavedSearchPopover* _tmp7_;
				guint _tmp8_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp9_;
				SearchFilterToolbarSavedSearchPopover* _tmp10_;
				guint _tmp11_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp12_;
				SearchFilterToolbarSavedSearchPopover* _tmp13_;
				guint _tmp14_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp15_;
				SearchFilterToolbarSavedSearchPopover* _tmp16_;
				guint _tmp17_;
				SearchFilterToolbarSavedSearchFilterButton* _tmp18_;
				SearchFilterToolbarSavedSearchPopover* _tmp19_;
				guint _tmp20_;
				_tmp6_ = self->priv->saved_search_button;
				_tmp7_ = _tmp6_->filter_popup;
				g_signal_parse_name ("edit-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp8_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked, self);
				_tmp9_ = self->priv->saved_search_button;
				_tmp10_ = _tmp9_->filter_popup;
				g_signal_parse_name ("search-activated", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp11_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated, self);
				_tmp12_ = self->priv->saved_search_button;
				_tmp13_ = _tmp12_->filter_popup;
				g_signal_parse_name ("delete-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp14_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked, self);
				_tmp15_ = self->priv->saved_search_button;
				_tmp16_ = _tmp15_->filter_popup;
				g_signal_parse_name ("add-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp17_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked, self);
				_tmp18_ = self->priv->saved_search_button;
				_tmp19_ = _tmp18_->filter_popup;
				g_signal_parse_name ("closed", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, &_tmp20_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed, self);
			}
			_tmp21_ = self->priv->saved_search_button;
			_tmp22_ = self->priv->saved_search_button;
			_tmp23_ = search_filter_toolbar_saved_search_popover_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget));
			_search_filter_toolbar_saved_search_popover_unref0 (_tmp21_->filter_popup);
			_tmp21_->filter_popup = _tmp23_;
			_tmp24_ = self->priv->saved_search_button;
			_tmp25_ = _tmp24_->filter_popup;
			g_signal_connect_object (_tmp25_, "edit-clicked", (GCallback) _search_filter_toolbar_edit_dialog_search_filter_toolbar_saved_search_popover_edit_clicked, self, 0);
			_tmp26_ = self->priv->saved_search_button;
			_tmp27_ = _tmp26_->filter_popup;
			g_signal_connect_object (_tmp27_, "search-activated", (GCallback) _search_filter_toolbar_on_savedsearch_selected_search_filter_toolbar_saved_search_popover_search_activated, self, 0);
			_tmp28_ = self->priv->saved_search_button;
			_tmp29_ = _tmp28_->filter_popup;
			g_signal_connect_object (_tmp29_, "delete-clicked", (GCallback) _search_filter_toolbar_delete_dialog_search_filter_toolbar_saved_search_popover_delete_clicked, self, 0);
			_tmp30_ = self->priv->saved_search_button;
			_tmp31_ = _tmp30_->filter_popup;
			g_signal_connect_object (_tmp31_, "add-clicked", (GCallback) _search_filter_toolbar_add_dialog_search_filter_toolbar_saved_search_popover_add_clicked, self, 0);
			_tmp32_ = self->priv->saved_search_button;
			_tmp33_ = _tmp32_->filter_popup;
			g_signal_connect_object (_tmp33_, "closed", (GCallback) _search_filter_toolbar_on_popover_closed_search_filter_toolbar_saved_search_popover_closed, self, 0);
			_tmp34_ = self->priv->saved_search_button;
			_tmp35_ = _tmp34_->filter_popup;
			search_filter_toolbar_saved_search_popover_show_all (_tmp35_);
		}
	}
	self->priv->elide_showing_again = FALSE;
}

void
search_filter_toolbar_take_focus (SearchFilterToolbar* self)
{
	SearchFilterToolbarSearchBox* _tmp0_;
	g_return_if_fail (IS_SEARCH_FILTER_TOOLBAR (self));
	_tmp0_ = self->priv->search_box;
	search_filter_toolbar_search_box_get_focus (_tmp0_);
}

static inline gpointer
search_filter_toolbar_label_tool_item_get_instance_private (SearchFilterToolbarLabelToolItem* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarLabelToolItem_private_offset);
}

static SearchFilterToolbarLabelToolItem*
search_filter_toolbar_label_tool_item_construct (GType object_type,
                                                 const gchar* s,
                                                 gint left_padding,
                                                 gint right_padding)
{
	SearchFilterToolbarLabelToolItem * self = NULL;
	GtkLabel* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkLabel* _tmp6_;
	g_return_val_if_fail (s != NULL, NULL);
	self = (SearchFilterToolbarLabelToolItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkLabel*) gtk_label_new (s);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->label);
	self->priv->label = _tmp0_;
	if (left_padding != 0) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = right_padding != 0;
	}
	if (_tmp1_) {
		GtkLabel* _tmp2_;
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		_tmp2_ = self->priv->label;
		gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
		_tmp3_ = self->priv->label;
		gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
		_tmp4_ = self->priv->label;
		gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), left_padding);
		_tmp5_ = self->priv->label;
		gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), right_padding);
	}
	_tmp6_ = self->priv->label;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
	return self;
}

static SearchFilterToolbarLabelToolItem*
search_filter_toolbar_label_tool_item_new (const gchar* s,
                                           gint left_padding,
                                           gint right_padding)
{
	return search_filter_toolbar_label_tool_item_construct (SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, s, left_padding, right_padding);
}

static void
search_filter_toolbar_label_tool_item_class_init (SearchFilterToolbarLabelToolItemClass * klass,
                                                  gpointer klass_data)
{
	search_filter_toolbar_label_tool_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarLabelToolItem_private_offset);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_label_tool_item_finalize;
}

static void
search_filter_toolbar_label_tool_item_instance_init (SearchFilterToolbarLabelToolItem * self,
                                                     gpointer klass)
{
	self->priv = search_filter_toolbar_label_tool_item_get_instance_private (self);
}

static void
search_filter_toolbar_label_tool_item_finalize (GObject * obj)
{
	SearchFilterToolbarLabelToolItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_LABEL_TOOL_ITEM, SearchFilterToolbarLabelToolItem);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (search_filter_toolbar_label_tool_item_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_label_tool_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarLabelToolItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_label_tool_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarLabelToolItem), 0, (GInstanceInitFunc) search_filter_toolbar_label_tool_item_instance_init, NULL };
	GType search_filter_toolbar_label_tool_item_type_id;
	search_filter_toolbar_label_tool_item_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarLabelToolItem", &g_define_type_info, 0);
	SearchFilterToolbarLabelToolItem_private_offset = g_type_add_instance_private (search_filter_toolbar_label_tool_item_type_id, sizeof (SearchFilterToolbarLabelToolItemPrivate));
	return search_filter_toolbar_label_tool_item_type_id;
}

static GType
search_filter_toolbar_label_tool_item_get_type (void)
{
	static volatile gsize search_filter_toolbar_label_tool_item_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_label_tool_item_type_id__once)) {
		GType search_filter_toolbar_label_tool_item_type_id;
		search_filter_toolbar_label_tool_item_type_id = search_filter_toolbar_label_tool_item_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_label_tool_item_type_id__once, search_filter_toolbar_label_tool_item_type_id);
	}
	return search_filter_toolbar_label_tool_item_type_id__once;
}

static inline gpointer
search_filter_toolbar_toggle_action_tool_button_get_instance_private (SearchFilterToolbarToggleActionToolButton* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarToggleActionToolButton_private_offset);
}

static SearchFilterToolbarToggleActionToolButton*
search_filter_toolbar_toggle_action_tool_button_construct (GType object_type,
                                                           const gchar* action)
{
	SearchFilterToolbarToggleActionToolButton * self = NULL;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	g_return_val_if_fail (action != NULL, NULL);
	self = (SearchFilterToolbarToggleActionToolButton*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp0_;
	_tmp1_ = self->priv->button;
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
	_tmp2_ = self->priv->button;
	gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_actionable_get_type (), GtkActionable), action);
	_tmp3_ = self->priv->button;
	gtk_widget_set_has_tooltip (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp4_ = self->priv->button;
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
	_tmp5_ = self->priv->button;
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), 2);
	_tmp6_ = self->priv->button;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
	return self;
}

static SearchFilterToolbarToggleActionToolButton*
search_filter_toolbar_toggle_action_tool_button_new (const gchar* action)
{
	return search_filter_toolbar_toggle_action_tool_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, action);
}

static void
search_filter_toolbar_toggle_action_tool_button_set_icon_name (SearchFilterToolbarToggleActionToolButton* self,
                                                               const gchar* icon_name)
{
	GtkImage* image = NULL;
	GtkToggleButton* _tmp0_;
	GtkImage* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkImage* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkToggleButton* _tmp5_;
	const gchar* _tmp6_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON (self));
	g_return_if_fail (icon_name != NULL);
	image = NULL;
	_tmp0_ = self->priv->button;
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), TRUE);
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (image);
	image = _tmp1_;
	_tmp2_ = self->priv->button;
	_tmp3_ = image;
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_button_get_type (), GtkButton), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
	_tmp5_ = self->priv->button;
	_tmp6_ = gtk_button_get_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton));
	if (g_strcmp0 (_tmp6_, "") != 0) {
		GtkToggleButton* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = self->priv->button;
		_tmp8_ = gtk_button_get_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_button_get_type (), GtkButton));
		_tmp4_ = _tmp8_ != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GtkImage* _tmp9_;
		_tmp9_ = image;
		gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget), 6);
	}
	_g_object_unref0 (image);
}

static void
search_filter_toolbar_toggle_action_tool_button_set_label (SearchFilterToolbarToggleActionToolButton* self,
                                                           const gchar* label)
{
	GtkToggleButton* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_TOGGLE_ACTION_TOOL_BUTTON (self));
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->button;
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
}

static void
search_filter_toolbar_toggle_action_tool_button_class_init (SearchFilterToolbarToggleActionToolButtonClass * klass,
                                                            gpointer klass_data)
{
	search_filter_toolbar_toggle_action_tool_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarToggleActionToolButton_private_offset);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_toggle_action_tool_button_finalize;
}

static void
search_filter_toolbar_toggle_action_tool_button_instance_init (SearchFilterToolbarToggleActionToolButton * self,
                                                               gpointer klass)
{
	self->priv = search_filter_toolbar_toggle_action_tool_button_get_instance_private (self);
}

static void
search_filter_toolbar_toggle_action_tool_button_finalize (GObject * obj)
{
	SearchFilterToolbarToggleActionToolButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_TOGGLE_ACTION_TOOL_BUTTON, SearchFilterToolbarToggleActionToolButton);
	_g_object_unref0 (self->priv->button);
	G_OBJECT_CLASS (search_filter_toolbar_toggle_action_tool_button_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_toggle_action_tool_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarToggleActionToolButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_toggle_action_tool_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarToggleActionToolButton), 0, (GInstanceInitFunc) search_filter_toolbar_toggle_action_tool_button_instance_init, NULL };
	GType search_filter_toolbar_toggle_action_tool_button_type_id;
	search_filter_toolbar_toggle_action_tool_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarToggleActionToolButton", &g_define_type_info, 0);
	SearchFilterToolbarToggleActionToolButton_private_offset = g_type_add_instance_private (search_filter_toolbar_toggle_action_tool_button_type_id, sizeof (SearchFilterToolbarToggleActionToolButtonPrivate));
	return search_filter_toolbar_toggle_action_tool_button_type_id;
}

static GType
search_filter_toolbar_toggle_action_tool_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_toggle_action_tool_button_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_toggle_action_tool_button_type_id__once)) {
		GType search_filter_toolbar_toggle_action_tool_button_type_id;
		search_filter_toolbar_toggle_action_tool_button_type_id = search_filter_toolbar_toggle_action_tool_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_toggle_action_tool_button_type_id__once, search_filter_toolbar_toggle_action_tool_button_type_id);
	}
	return search_filter_toolbar_toggle_action_tool_button_type_id__once;
}

static inline gpointer
search_filter_toolbar_search_box_get_instance_private (SearchFilterToolbarSearchBox* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSearchBox_private_offset);
}

static void
_search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed (TextAction* _sender,
                                                                                   const gchar* text,
                                                                                   gpointer self)
{
	search_filter_toolbar_search_box_on_action_text_changed ((SearchFilterToolbarSearchBox*) self, text);
}

static void
_search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed (TextAction* _sender,
                                                                                          gboolean sensitive,
                                                                                          gpointer self)
{
	search_filter_toolbar_search_box_on_sensitivity_changed ((SearchFilterToolbarSearchBox*) self, sensitive);
}

static void
_search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed (TextAction* _sender,
                                                                                        gboolean visible,
                                                                                        gpointer self)
{
	search_filter_toolbar_search_box_on_visibility_changed ((SearchFilterToolbarSearchBox*) self, visible);
}

static void
_search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text (GtkEntryBuffer* _sender,
                                                                                  guint position,
                                                                                  guint n_chars,
                                                                                  gpointer self)
{
	search_filter_toolbar_search_box_on_entry_changed ((SearchFilterToolbarSearchBox*) self);
}

static void
_search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text (GtkEntryBuffer* _sender,
                                                                                   guint position,
                                                                                   const gchar* chars,
                                                                                   guint n_chars,
                                                                                   gpointer self)
{
	search_filter_toolbar_search_box_on_entry_changed ((SearchFilterToolbarSearchBox*) self);
}

static gpointer
_text_action_ref0 (gpointer self)
{
	return self ? text_action_ref (self) : NULL;
}

static gboolean
_search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                            GdkEventKey* event,
                                                                            gpointer self)
{
	gboolean result;
	result = search_filter_toolbar_search_box_on_escape_key ((SearchFilterToolbarSearchBox*) self, event);
	return result;
}

SearchFilterToolbarSearchBox*
search_filter_toolbar_search_box_construct (GType object_type,
                                            TextAction* action)
{
	SearchFilterToolbarSearchBox * self = NULL;
	TextAction* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkSearchEntry* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkSearchEntry* _tmp7_;
	GtkEntryBuffer* _tmp8_;
	GtkEntryBuffer* _tmp9_;
	GtkSearchEntry* _tmp10_;
	GtkEntryBuffer* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	g_return_val_if_fail (IS_TEXT_ACTION (action), NULL);
	self = (SearchFilterToolbarSearchBox*) g_object_new (object_type, NULL);
	_tmp0_ = _text_action_ref0 (action);
	_text_action_unref0 (self->priv->action);
	self->priv->action = _tmp0_;
	_tmp1_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->search_entry);
	self->priv->search_entry = _tmp1_;
	_tmp2_ = self->priv->search_entry;
	gtk_entry_set_width_chars (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry), 23);
	_tmp3_ = self->priv->search_entry;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _search_filter_toolbar_search_box_on_escape_key_gtk_widget_key_press_event, self, 0);
	_tmp4_ = self->priv->search_entry;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
	_tmp5_ = text_action_get_value (action);
	_tmp6_ = _tmp5_;
	search_filter_toolbar_search_box_set_nullable_text (self, _tmp6_);
	g_signal_connect_object (action, "text-changed", (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self, 0);
	g_signal_connect_object (action, "sensitivity-changed", (GCallback) _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed, self, 0);
	g_signal_connect_object (action, "visibility-changed", (GCallback) _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed, self, 0);
	_tmp7_ = self->priv->search_entry;
	_tmp8_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_entry_get_type (), GtkEntry));
	_tmp9_ = _tmp8_;
	g_signal_connect_object (_tmp9_, "deleted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self, 0);
	_tmp10_ = self->priv->search_entry;
	_tmp11_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry));
	_tmp12_ = _tmp11_;
	g_signal_connect_object (_tmp12_, "inserted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self, 0);
	return self;
}

SearchFilterToolbarSearchBox*
search_filter_toolbar_search_box_new (TextAction* action)
{
	return search_filter_toolbar_search_box_construct (SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, action);
}

void
search_filter_toolbar_search_box_get_focus (SearchFilterToolbarSearchBox* self)
{
	GtkSearchEntry* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	_tmp0_ = self->priv->search_entry;
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), "has-focus", TRUE, NULL);
}

static gboolean
search_filter_toolbar_search_box_on_escape_key (SearchFilterToolbarSearchBox* self,
                                                GdkEventKey* e)
{
	const gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self), FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = gdk_keyval_name (e->keyval);
	if (g_strcmp0 (_tmp0_, "Escape") == 0) {
		TextAction* _tmp1_;
		_tmp1_ = self->priv->action;
		text_action_clear (_tmp1_);
	}
	result = FALSE;
	return result;
}

static void
search_filter_toolbar_search_box_on_action_text_changed (SearchFilterToolbarSearchBox* self,
                                                         const gchar* text)
{
	GtkSearchEntry* _tmp0_;
	GtkEntryBuffer* _tmp1_;
	GtkEntryBuffer* _tmp2_;
	guint _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkEntryBuffer* _tmp5_;
	GtkEntryBuffer* _tmp6_;
	guint _tmp7_;
	GtkSearchEntry* _tmp8_;
	GtkEntryBuffer* _tmp9_;
	GtkEntryBuffer* _tmp10_;
	GtkSearchEntry* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	GtkEntryBuffer* _tmp13_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	_tmp0_ = self->priv->search_entry;
	_tmp1_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
	_tmp2_ = _tmp1_;
	g_signal_parse_name ("deleted-text", gtk_entry_buffer_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self);
	_tmp4_ = self->priv->search_entry;
	_tmp5_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_entry_get_type (), GtkEntry));
	_tmp6_ = _tmp5_;
	g_signal_parse_name ("inserted-text", gtk_entry_buffer_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self);
	search_filter_toolbar_search_box_set_nullable_text (self, text);
	_tmp8_ = self->priv->search_entry;
	_tmp9_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_entry_get_type (), GtkEntry));
	_tmp10_ = _tmp9_;
	g_signal_connect_object (_tmp10_, "deleted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self, 0);
	_tmp11_ = self->priv->search_entry;
	_tmp12_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_entry_get_type (), GtkEntry));
	_tmp13_ = _tmp12_;
	g_signal_connect_object (_tmp13_, "inserted-text", (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self, 0);
}

static void
search_filter_toolbar_search_box_on_entry_changed (SearchFilterToolbarSearchBox* self)
{
	TextAction* _tmp0_;
	guint _tmp1_;
	TextAction* _tmp2_;
	GtkSearchEntry* _tmp3_;
	const gchar* _tmp4_;
	TextAction* _tmp5_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	_tmp0_ = self->priv->action;
	g_signal_parse_name ("text-changed", TYPE_TEXT_ACTION, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self);
	_tmp2_ = self->priv->action;
	_tmp3_ = self->priv->search_entry;
	_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry));
	text_action_set_text (_tmp2_, _tmp4_);
	_tmp5_ = self->priv->action;
	g_signal_connect_object (_tmp5_, "text-changed", (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self, 0);
}

static void
search_filter_toolbar_search_box_on_sensitivity_changed (SearchFilterToolbarSearchBox* self,
                                                         gboolean sensitive)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), sensitive);
}

static void
search_filter_toolbar_search_box_on_visibility_changed (SearchFilterToolbarSearchBox* self,
                                                        gboolean visible)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), visible);
}

static void
search_filter_toolbar_search_box_set_nullable_text (SearchFilterToolbarSearchBox* self,
                                                    const gchar* text)
{
	const gchar* _tmp0_ = NULL;
	GtkSearchEntry* _tmp1_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SEARCH_BOX (self));
	if (text != NULL) {
		_tmp0_ = text;
	} else {
		_tmp0_ = "";
	}
	_tmp1_ = self->priv->search_entry;
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry), _tmp0_);
}

static void
search_filter_toolbar_search_box_class_init (SearchFilterToolbarSearchBoxClass * klass,
                                             gpointer klass_data)
{
	search_filter_toolbar_search_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSearchBox_private_offset);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_search_box_finalize;
}

static void
search_filter_toolbar_search_box_instance_init (SearchFilterToolbarSearchBox * self,
                                                gpointer klass)
{
	self->priv = search_filter_toolbar_search_box_get_instance_private (self);
}

static void
search_filter_toolbar_search_box_finalize (GObject * obj)
{
	SearchFilterToolbarSearchBox * self;
	TextAction* _tmp0_;
	guint _tmp1_;
	TextAction* _tmp2_;
	guint _tmp3_;
	TextAction* _tmp4_;
	guint _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkEntryBuffer* _tmp7_;
	GtkEntryBuffer* _tmp8_;
	guint _tmp9_;
	GtkSearchEntry* _tmp10_;
	GtkEntryBuffer* _tmp11_;
	GtkEntryBuffer* _tmp12_;
	guint _tmp13_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SEARCH_BOX, SearchFilterToolbarSearchBox);
	_tmp0_ = self->priv->action;
	g_signal_parse_name ("text-changed", TYPE_TEXT_ACTION, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_action_text_changed_text_action_text_changed, self);
	_tmp2_ = self->priv->action;
	g_signal_parse_name ("sensitivity-changed", TYPE_TEXT_ACTION, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_sensitivity_changed_text_action_sensitivity_changed, self);
	_tmp4_ = self->priv->action;
	g_signal_parse_name ("visibility-changed", TYPE_TEXT_ACTION, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_visibility_changed_text_action_visibility_changed, self);
	_tmp6_ = self->priv->search_entry;
	_tmp7_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_entry_get_type (), GtkEntry));
	_tmp8_ = _tmp7_;
	g_signal_parse_name ("deleted-text", gtk_entry_buffer_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_deleted_text, self);
	_tmp10_ = self->priv->search_entry;
	_tmp11_ = gtk_entry_get_buffer (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry));
	_tmp12_ = _tmp11_;
	g_signal_parse_name ("inserted-text", gtk_entry_buffer_get_type (), &_tmp13_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_search_box_on_entry_changed_gtk_entry_buffer_inserted_text, self);
	_g_object_unref0 (self->priv->search_entry);
	_text_action_unref0 (self->priv->action);
	G_OBJECT_CLASS (search_filter_toolbar_search_box_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_search_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSearchBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_search_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSearchBox), 0, (GInstanceInitFunc) search_filter_toolbar_search_box_instance_init, NULL };
	GType search_filter_toolbar_search_box_type_id;
	search_filter_toolbar_search_box_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarSearchBox", &g_define_type_info, 0);
	SearchFilterToolbarSearchBox_private_offset = g_type_add_instance_private (search_filter_toolbar_search_box_type_id, sizeof (SearchFilterToolbarSearchBoxPrivate));
	return search_filter_toolbar_search_box_type_id;
}

GType
search_filter_toolbar_search_box_get_type (void)
{
	static volatile gsize search_filter_toolbar_search_box_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_search_box_type_id__once)) {
		GType search_filter_toolbar_search_box_type_id;
		search_filter_toolbar_search_box_type_id = search_filter_toolbar_search_box_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_search_box_type_id__once, search_filter_toolbar_search_box_type_id);
	}
	return search_filter_toolbar_search_box_type_id__once;
}

SearchFilterToolbarRatingFilterButton*
search_filter_toolbar_rating_filter_button_construct (GType object_type,
                                                      GMenuModel* model)
{
	SearchFilterToolbarRatingFilterButton * self = NULL;
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkMenuButton* _tmp4_;
	GtkMenuButton* _tmp5_;
	GtkMenuButton* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkMenuButton* _tmp8_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, g_menu_model_get_type ()), NULL);
	self = (SearchFilterToolbarRatingFilterButton*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->button);
	self->button = _tmp0_;
	_tmp1_ = self->button;
	_tmp2_ = search_filter_toolbar_rating_filter_button_get_filter_icon (self, RATING_FILTER_UNRATED_OR_HIGHER);
	_tmp3_ = _tmp2_;
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->button;
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), FALSE);
	_tmp5_ = self->button;
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
	_tmp6_ = self->button;
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), 2);
	_tmp7_ = self->button;
	gtk_menu_button_set_menu_model (_tmp7_, model);
	gtk_tool_item_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), FALSE);
	_tmp8_ = self->button;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
	return self;
}

SearchFilterToolbarRatingFilterButton*
search_filter_toolbar_rating_filter_button_new (GMenuModel* model)
{
	return search_filter_toolbar_rating_filter_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, model);
}

static GtkWidget*
search_filter_toolbar_rating_filter_button_get_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                            RatingFilter filter)
{
	GtkWidget* icon = NULL;
	GtkWidget* _tmp13_;
	GtkWidget* result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), NULL);
	icon = NULL;
	switch (filter) {
		case RATING_FILTER_REJECTED_OR_HIGHER:
		{
			GtkBox* box = NULL;
			GtkBox* _tmp0_;
			GtkImage* image = NULL;
			GtkImage* _tmp1_;
			GtkImage* _tmp2_;
			GtkBox* _tmp3_;
			GtkImage* _tmp4_;
			GtkImage* _tmp5_;
			GtkBox* _tmp6_;
			GtkImage* _tmp7_;
			GtkBox* _tmp8_;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp10_;
			_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
			g_object_ref_sink (_tmp0_);
			box = _tmp0_;
			_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-photos-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
			g_object_ref_sink (_tmp1_);
			image = _tmp1_;
			_tmp2_ = image;
			gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), 2);
			_tmp3_ = box;
			_tmp4_ = image;
			gtk_box_pack_start (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
			_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
			g_object_ref_sink (_tmp5_);
			_g_object_unref0 (image);
			image = _tmp5_;
			_tmp6_ = box;
			_tmp7_ = image;
			gtk_box_pack_start (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
			_tmp8_ = box;
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
			_g_object_unref0 (icon);
			icon = _tmp9_;
			_tmp10_ = icon;
			gtk_widget_show_all (_tmp10_);
			_g_object_unref0 (image);
			_g_object_unref0 (box);
			break;
		}
		case RATING_FILTER_REJECTED_ONLY:
		{
			GtkImage* _tmp11_;
			_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
			g_object_ref_sink (_tmp11_);
			_g_object_unref0 (icon);
			icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget);
			break;
		}
		default:
		case RATING_FILTER_UNRATED_OR_HIGHER:
		{
			GtkImage* _tmp12_;
			_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-photos-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
			g_object_ref_sink (_tmp12_);
			_g_object_unref0 (icon);
			icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget);
			break;
		}
	}
	_tmp13_ = icon;
	gtk_widget_set_margin_end (_tmp13_, 6);
	result = icon;
	return result;
}

static gint
search_filter_toolbar_rating_filter_button_get_filter_icon_size (SearchFilterToolbarRatingFilterButton* self,
                                                                 RatingFilter filter)
{
	gint icon_base = 0;
	gint icon_star_base = 0;
	gint icon_plus = 0;
	gint result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), 0);
	icon_base = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_SCALE);
	icon_star_base = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_BASE_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE);
	icon_plus = (gint) (SEARCH_FILTER_TOOLBAR_FILTER_ICON_PLUS_WIDTH * SEARCH_FILTER_TOOLBAR_FILTER_ICON_STAR_SCALE);
	switch (filter) {
		case RATING_FILTER_ONE_OR_HIGHER:
		{
			result = icon_star_base + icon_plus;
			return result;
		}
		case RATING_FILTER_TWO_OR_HIGHER:
		{
			result = (icon_star_base * 2) + icon_plus;
			return result;
		}
		case RATING_FILTER_THREE_OR_HIGHER:
		{
			result = (icon_star_base * 3) + icon_plus;
			return result;
		}
		case RATING_FILTER_FOUR_OR_HIGHER:
		{
			result = (icon_star_base * 4) + icon_plus;
			return result;
		}
		case RATING_FILTER_FIVE_OR_HIGHER:
		case RATING_FILTER_FIVE_ONLY:
		{
			result = icon_star_base * 5;
			return result;
		}
		case RATING_FILTER_REJECTED_OR_HIGHER:
		{
			result = RESOURCES_ICON_FILTER_REJECTED_OR_BETTER_FIXED_SIZE;
			return result;
		}
		case RATING_FILTER_UNRATED_OR_HIGHER:
		{
			result = RESOURCES_ICON_FILTER_UNRATED_OR_BETTER_FIXED_SIZE;
			return result;
		}
		case RATING_FILTER_REJECTED_ONLY:
		{
			result = icon_plus;
			return result;
		}
		default:
		{
			result = icon_base;
			return result;
		}
	}
}

void
search_filter_toolbar_rating_filter_button_set_filter_icon (SearchFilterToolbarRatingFilterButton* self,
                                                            RatingFilter filter)
{
	GtkMenuButton* _tmp0_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self));
	_tmp0_ = self->button;
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), TRUE);
	switch (filter) {
		case RATING_FILTER_ONE_OR_HIGHER:
		{
			GtkMenuButton* _tmp1_;
			_tmp1_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), _ ("★+ Rating"));
			break;
		}
		case RATING_FILTER_TWO_OR_HIGHER:
		{
			GtkMenuButton* _tmp2_;
			_tmp2_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_button_get_type (), GtkButton), _ ("★★+ Rating"));
			break;
		}
		case RATING_FILTER_THREE_OR_HIGHER:
		{
			GtkMenuButton* _tmp3_;
			_tmp3_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_button_get_type (), GtkButton), _ ("★★★+ Rating"));
			break;
		}
		case RATING_FILTER_FOUR_OR_HIGHER:
		{
			GtkMenuButton* _tmp4_;
			_tmp4_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton), _ ("★★★★+ Rating"));
			break;
		}
		case RATING_FILTER_FIVE_ONLY:
		case RATING_FILTER_FIVE_OR_HIGHER:
		{
			GtkMenuButton* _tmp5_;
			_tmp5_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), _ ("★★★★★+ Rating"));
			break;
		}
		default:
		{
			GtkMenuButton* _tmp6_;
			GtkMenuButton* _tmp7_;
			GtkWidget* _tmp8_;
			GtkWidget* _tmp9_;
			_tmp6_ = self->button;
			gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_button_get_type (), GtkButton), _ ("Rating"));
			_tmp7_ = self->button;
			_tmp8_ = search_filter_toolbar_rating_filter_button_get_filter_icon (self, filter);
			_tmp9_ = _tmp8_;
			gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_button_get_type (), GtkButton), _tmp9_);
			_g_object_unref0 (_tmp9_);
			break;
		}
	}
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), search_filter_toolbar_rating_filter_button_get_filter_button_size (self, filter), -1);
	_tmp10_ = resources_get_rating_filter_tooltip (filter);
	_tmp11_ = _tmp10_;
	gtk_tool_item_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), _tmp11_);
	_g_free0 (_tmp11_);
	gtk_widget_set_has_tooltip (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
}

static gint
search_filter_toolbar_rating_filter_button_get_filter_button_size (SearchFilterToolbarRatingFilterButton* self,
                                                                   RatingFilter filter)
{
	gint result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self), 0);
	result = search_filter_toolbar_rating_filter_button_get_filter_icon_size (self, filter) + (2 * SEARCH_FILTER_TOOLBAR_FILTER_BUTTON_MARGIN);
	return result;
}

void
search_filter_toolbar_rating_filter_button_set_label (SearchFilterToolbarRatingFilterButton* self,
                                                      const gchar* label)
{
	GtkMenuButton* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_RATING_FILTER_BUTTON (self));
	g_return_if_fail (label != NULL);
	_tmp0_ = self->button;
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
}

static void
search_filter_toolbar_rating_filter_button_class_init (SearchFilterToolbarRatingFilterButtonClass * klass,
                                                       gpointer klass_data)
{
	search_filter_toolbar_rating_filter_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_rating_filter_button_finalize;
}

static void
search_filter_toolbar_rating_filter_button_instance_init (SearchFilterToolbarRatingFilterButton * self,
                                                          gpointer klass)
{
}

static void
search_filter_toolbar_rating_filter_button_finalize (GObject * obj)
{
	SearchFilterToolbarRatingFilterButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_RATING_FILTER_BUTTON, SearchFilterToolbarRatingFilterButton);
	_g_object_unref0 (self->button);
	G_OBJECT_CLASS (search_filter_toolbar_rating_filter_button_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_rating_filter_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarRatingFilterButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_rating_filter_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarRatingFilterButton), 0, (GInstanceInitFunc) search_filter_toolbar_rating_filter_button_instance_init, NULL };
	GType search_filter_toolbar_rating_filter_button_type_id;
	search_filter_toolbar_rating_filter_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarRatingFilterButton", &g_define_type_info, 0);
	return search_filter_toolbar_rating_filter_button_type_id;
}

GType
search_filter_toolbar_rating_filter_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_rating_filter_button_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_rating_filter_button_type_id__once)) {
		GType search_filter_toolbar_rating_filter_button_type_id;
		search_filter_toolbar_rating_filter_button_type_id = search_filter_toolbar_rating_filter_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_rating_filter_button_type_id__once, search_filter_toolbar_rating_filter_button_type_id);
	}
	return search_filter_toolbar_rating_filter_button_type_id__once;
}

static void
_search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                 gpointer self)
{
	search_filter_toolbar_saved_search_filter_button_on_clicked ((SearchFilterToolbarSavedSearchFilterButton*) self);
}

SearchFilterToolbarSavedSearchFilterButton*
search_filter_toolbar_saved_search_filter_button_construct (GType object_type)
{
	SearchFilterToolbarSavedSearchFilterButton * self = NULL;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	self = (SearchFilterToolbarSavedSearchFilterButton*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->button);
	self->button = _tmp0_;
	_tmp1_ = self->button;
	gtk_button_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), TRUE);
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-find-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp2_);
	image = _tmp2_;
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (image, gtk_widget_get_type (), GtkWidget), 6);
	_tmp3_ = self->button;
	gtk_button_set_image (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_button_get_type (), GtkButton), G_TYPE_CHECK_INSTANCE_CAST (image, gtk_widget_get_type (), GtkWidget));
	_tmp4_ = self->button;
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), FALSE);
	_tmp5_ = self->button;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton), "clicked", (GCallback) _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked, self, 0);
	search_filter_toolbar_saved_search_filter_button_restyle (self);
	gtk_tool_item_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tool_item_get_type (), GtkToolItem), FALSE);
	_tmp6_ = self->button;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (image);
	return self;
}

SearchFilterToolbarSavedSearchFilterButton*
search_filter_toolbar_saved_search_filter_button_new (void)
{
	return search_filter_toolbar_saved_search_filter_button_construct (SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON);
}

static void
search_filter_toolbar_saved_search_filter_button_on_clicked (SearchFilterToolbarSavedSearchFilterButton* self)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
	g_signal_emit (self, search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL], 0);
}

void
search_filter_toolbar_saved_search_filter_button_set_active (SearchFilterToolbarSavedSearchFilterButton* self,
                                                             gboolean active)
{
	GtkToggleButton* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
	_tmp0_ = self->button;
	gtk_toggle_button_set_active (_tmp0_, active);
}

void
search_filter_toolbar_saved_search_filter_button_set_label (SearchFilterToolbarSavedSearchFilterButton* self,
                                                            const gchar* label)
{
	GtkToggleButton* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
	g_return_if_fail (label != NULL);
	_tmp0_ = self->button;
	gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), label);
}

void
search_filter_toolbar_saved_search_filter_button_restyle (SearchFilterToolbarSavedSearchFilterButton* self)
{
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_FILTER_BUTTON (self));
	_tmp0_ = self->button;
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), 24, 24);
	_tmp1_ = self->button;
	gtk_button_set_relief (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_get_type (), GtkButton), GTK_RELIEF_NONE);
}

static void
search_filter_toolbar_saved_search_filter_button_class_init (SearchFilterToolbarSavedSearchFilterButtonClass * klass,
                                                             gpointer klass_data)
{
	search_filter_toolbar_saved_search_filter_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_saved_search_filter_button_finalize;
	search_filter_toolbar_saved_search_filter_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_FILTER_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
search_filter_toolbar_saved_search_filter_button_instance_init (SearchFilterToolbarSavedSearchFilterButton * self,
                                                                gpointer klass)
{
	self->filter_popup = NULL;
}

static void
search_filter_toolbar_saved_search_filter_button_finalize (GObject * obj)
{
	SearchFilterToolbarSavedSearchFilterButton * self;
	GtkToggleButton* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_FILTER_BUTTON, SearchFilterToolbarSavedSearchFilterButton);
	_tmp0_ = self->button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_filter_button_on_clicked_gtk_button_clicked, self);
	_search_filter_toolbar_saved_search_popover_unref0 (self->filter_popup);
	_g_object_unref0 (self->button);
	G_OBJECT_CLASS (search_filter_toolbar_saved_search_filter_button_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_saved_search_filter_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchFilterButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_filter_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchFilterButton), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_filter_button_instance_init, NULL };
	GType search_filter_toolbar_saved_search_filter_button_type_id;
	search_filter_toolbar_saved_search_filter_button_type_id = g_type_register_static (gtk_tool_item_get_type (), "SearchFilterToolbarSavedSearchFilterButton", &g_define_type_info, 0);
	return search_filter_toolbar_saved_search_filter_button_type_id;
}

GType
search_filter_toolbar_saved_search_filter_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_filter_button_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_filter_button_type_id__once)) {
		GType search_filter_toolbar_saved_search_filter_button_type_id;
		search_filter_toolbar_saved_search_filter_button_type_id = search_filter_toolbar_saved_search_filter_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_filter_button_type_id__once, search_filter_toolbar_saved_search_filter_button_type_id);
	}
	return search_filter_toolbar_saved_search_filter_button_type_id__once;
}

static inline gpointer
search_filter_toolbar_saved_search_popover_get_instance_private (SearchFilterToolbarSavedSearchPopover* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSavedSearchPopover_private_offset);
}

static void
_search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                          SavedSearch* search,
                                                                                                                          gpointer self)
{
	search_filter_toolbar_saved_search_popover_on_edit_click ((SearchFilterToolbarSavedSearchPopover*) self, search);
}

static void
_search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked (SearchFilterToolbarSavedSearchPopoverDataButton* _sender,
                                                                                                                            SavedSearch* search,
                                                                                                                            gpointer self)
{
	search_filter_toolbar_saved_search_popover_on_delete_click ((SearchFilterToolbarSavedSearchPopover*) self, search);
}

static void
_search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
	search_filter_toolbar_saved_search_popover_on_add_click ((SearchFilterToolbarSavedSearchPopover*) self);
}

static void
_search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                        GtkListBoxRow* row,
                                                                                        gpointer self)
{
	search_filter_toolbar_saved_search_popover_on_activate_row ((SearchFilterToolbarSavedSearchPopover*) self, row);
}

static void
_search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed (GtkPopover* _sender,
                                                                                  gpointer self)
{
	search_filter_toolbar_saved_search_popover_on_popover_closed ((SearchFilterToolbarSavedSearchPopover*) self);
}

static void
_vala_array_add129 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                    gint* length,
                    gint* size,
                    SearchFilterToolbarSavedSearchPopoverDataButton* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (SearchFilterToolbarSavedSearchPopoverDataButton*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add130 (SearchFilterToolbarSavedSearchPopoverDataButton** * array,
                    gint* length,
                    gint* size,
                    SearchFilterToolbarSavedSearchPopoverDataButton* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (SearchFilterToolbarSavedSearchPopoverDataButton*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

SearchFilterToolbarSavedSearchPopover*
search_filter_toolbar_saved_search_popover_construct (GType object_type,
                                                      GtkWidget* relative_to)
{
	SearchFilterToolbarSavedSearchPopover* self = NULL;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	GtkListBox* _tmp2_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp3_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	GtkListBox* _tmp42_;
	GtkButton* _tmp43_;
	GtkListBox* _tmp44_;
	GtkListBox* _tmp45_;
	GtkPopover* _tmp46_;
	GtkListBox* _tmp47_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (relative_to, gtk_widget_get_type ()), NULL);
	self = (SearchFilterToolbarSavedSearchPopover*) g_type_create_instance (object_type);
	_tmp0_ = (GtkPopover*) gtk_popover_new (relative_to);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp0_;
	_tmp1_ = self->priv->popover;
	g_signal_connect (_tmp1_, "closed", (GCallback) _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed, self);
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->list_box);
	self->priv->list_box = _tmp2_;
	_tmp3_ = g_new0 (SearchFilterToolbarSavedSearchPopoverDataButton*, 0 + 1);
	self->priv->edit_buttons = (_vala_array_free (self->priv->edit_buttons, self->priv->edit_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->edit_buttons = _tmp3_;
	self->priv->edit_buttons_length1 = 0;
	self->priv->_edit_buttons_size_ = self->priv->edit_buttons_length1;
	_tmp4_ = g_new0 (SearchFilterToolbarSavedSearchPopoverDataButton*, 0 + 1);
	self->priv->delete_buttons = (_vala_array_free (self->priv->delete_buttons, self->priv->delete_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->delete_buttons = _tmp4_;
	self->priv->delete_buttons_length1 = 0;
	self->priv->_delete_buttons_size_ = self->priv->delete_buttons_length1;
	{
		GeeIterator* _search_it = NULL;
		SavedSearchTable* _tmp5_;
		SavedSearchTable* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
		_tmp5_ = saved_search_table_get_instance ();
		_tmp6_ = _tmp5_;
		_tmp7_ = saved_search_table_get_all (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp8_);
		_saved_search_table_unref0 (_tmp6_);
		_search_it = _tmp10_;
		while (TRUE) {
			GeeIterator* _tmp11_;
			SavedSearch* search = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			GtkBox* row = NULL;
			GtkBox* _tmp14_;
			GtkBox* _tmp15_;
			GtkLabel* label = NULL;
			SavedSearch* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GtkLabel* _tmp19_;
			GtkLabel* _tmp20_;
			GtkLabel* _tmp21_;
			GtkBox* _tmp22_;
			GtkLabel* _tmp23_;
			SearchFilterToolbarSavedSearchPopoverDataButton* delete_button = NULL;
			SavedSearch* _tmp24_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp25_;
			GtkBox* _tmp26_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp27_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp28_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp29_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp30_;
			SearchFilterToolbarSavedSearchPopoverDataButton* edit_button = NULL;
			SavedSearch* _tmp31_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp32_;
			GtkBox* _tmp33_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp34_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp35_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp36_;
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp37_;
			GtkListBox* _tmp38_;
			GtkBox* _tmp39_;
			_tmp11_ = _search_it;
			if (!gee_iterator_next (_tmp11_)) {
				break;
			}
			_tmp12_ = _search_it;
			_tmp13_ = gee_iterator_get (_tmp12_);
			search = (SavedSearch*) _tmp13_;
			_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 1);
			g_object_ref_sink (_tmp14_);
			row = _tmp14_;
			_tmp15_ = row;
			gtk_box_set_homogeneous (_tmp15_, FALSE);
			_tmp16_ = search;
			_tmp17_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
			_tmp18_ = _tmp17_;
			_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
			g_object_ref_sink (_tmp19_);
			_tmp20_ = _tmp19_;
			_g_free0 (_tmp18_);
			label = _tmp20_;
			_tmp21_ = label;
			gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
			_tmp22_ = row;
			_tmp23_ = label;
			gtk_box_pack_start (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 3);
			_tmp24_ = search;
			_tmp25_ = search_filter_toolbar_saved_search_popover_data_button_new (_tmp24_, "edit-delete-symbolic");
			g_object_ref_sink (_tmp25_);
			delete_button = _tmp25_;
			_tmp26_ = row;
			_tmp27_ = delete_button;
			gtk_box_pack_end (_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
			_tmp28_ = delete_button;
			g_signal_connect (_tmp28_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
			_tmp29_ = delete_button;
			_tmp30_ = _g_object_ref0 (_tmp29_);
			_vala_array_add129 (&self->priv->delete_buttons, &self->priv->delete_buttons_length1, &self->priv->_delete_buttons_size_, _tmp30_);
			_tmp31_ = search;
			_tmp32_ = search_filter_toolbar_saved_search_popover_data_button_new (_tmp31_, "text-editor-symbolic");
			g_object_ref_sink (_tmp32_);
			edit_button = _tmp32_;
			_tmp33_ = row;
			_tmp34_ = edit_button;
			gtk_box_pack_end (_tmp33_, G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
			_tmp35_ = edit_button;
			g_signal_connect (_tmp35_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
			_tmp36_ = edit_button;
			_tmp37_ = _g_object_ref0 (_tmp36_);
			_vala_array_add130 (&self->priv->edit_buttons, &self->priv->edit_buttons_length1, &self->priv->_edit_buttons_size_, _tmp37_);
			_tmp38_ = self->priv->list_box;
			_tmp39_ = row;
			gtk_list_box_insert (_tmp38_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget), -1);
			_g_object_unref0 (edit_button);
			_g_object_unref0 (delete_button);
			_g_object_unref0 (label);
			_g_object_unref0 (row);
			_g_object_unref0 (search);
		}
		_g_object_unref0 (_search_it);
	}
	_tmp40_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->priv->add);
	self->priv->add = _tmp40_;
	_tmp41_ = self->priv->add;
	g_signal_connect (_tmp41_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked, self);
	_tmp42_ = self->priv->list_box;
	_tmp43_ = self->priv->add;
	gtk_list_box_insert (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget), -1);
	_tmp44_ = self->priv->list_box;
	g_signal_connect (_tmp44_, "row-activated", (GCallback) _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated, self);
	_tmp45_ = self->priv->list_box;
	gtk_list_box_set_selection_mode (_tmp45_, GTK_SELECTION_NONE);
	_tmp46_ = self->priv->popover;
	_tmp47_ = self->priv->list_box;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget));
	search_filter_toolbar_saved_search_popover_restyle (self);
	return self;
}

SearchFilterToolbarSavedSearchPopover*
search_filter_toolbar_saved_search_popover_new (GtkWidget* relative_to)
{
	return search_filter_toolbar_saved_search_popover_construct (SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, relative_to);
}

void
search_filter_toolbar_saved_search_popover_restyle (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkButton* _tmp0_;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp1_;
	gint _tmp1__length1;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	gint _tmp4__length1;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	_tmp0_ = self->priv->add;
	gtk_button_set_relief (_tmp0_, GTK_RELIEF_NONE);
	_tmp1_ = self->priv->edit_buttons;
	_tmp1__length1 = self->priv->edit_buttons_length1;
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
		button_collection = _tmp1_;
		button_collection_length1 = _tmp1__length1;
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp2_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
			_tmp2_ = _g_object_ref0 (button_collection[button_it]);
			button = _tmp2_;
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp3_;
				_tmp3_ = button;
				search_filter_toolbar_saved_search_popover_data_button_restyle (_tmp3_);
				_g_object_unref0 (button);
			}
		}
	}
	_tmp4_ = self->priv->delete_buttons;
	_tmp4__length1 = self->priv->delete_buttons_length1;
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
		button_collection = _tmp4_;
		button_collection_length1 = _tmp4__length1;
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp5_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
			_tmp5_ = _g_object_ref0 (button_collection[button_it]);
			button = _tmp5_;
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp6_;
				_tmp6_ = button;
				search_filter_toolbar_saved_search_popover_data_button_restyle (_tmp6_);
				_g_object_unref0 (button);
			}
		}
	}
}

static gboolean
search_filter_toolbar_saved_search_popover_is_search_row (SearchFilterToolbarSavedSearchPopover* self,
                                                          GtkListBoxRow* row)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self), FALSE);
	g_return_val_if_fail ((row == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()), FALSE);
	if (row == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_container_get_type (), GtkContainer));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_list_last (_tmp1_);
	_tmp3_ = _tmp2_->data;
	_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE ((GtkWidget*) _tmp3_, gtk_button_get_type ());
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
	if (_tmp4_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

static SavedSearch*
search_filter_toolbar_saved_search_popover_get_search (SearchFilterToolbarSavedSearchPopover* self,
                                                       GtkListBoxRow* row)
{
	GtkBox* box = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
	GList* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	gconstpointer _tmp9_;
	GtkWidget* _tmp10_;
	SearchFilterToolbarSavedSearchPopoverDataButton* _tmp11_;
	SearchFilterToolbarSavedSearchPopoverDataButton* _tmp12_;
	SavedSearch* _tmp13_;
	SavedSearch* _tmp14_;
	SavedSearch* _tmp15_;
	SavedSearch* result;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self), NULL);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()), NULL);
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_container_get_type (), GtkContainer));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_list_first (_tmp1_);
	_tmp3_ = _tmp2_->data;
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp3_, gtk_box_get_type (), GtkBox));
	_tmp5_ = _tmp4_;
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
	box = _tmp5_;
	_tmp6_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (box, gtk_container_get_type (), GtkContainer));
	_tmp7_ = _tmp6_;
	_tmp8_ = g_list_last (_tmp7_);
	_tmp9_ = _tmp8_->data;
	_tmp10_ = (GtkWidget*) _tmp9_;
	_tmp11_ = _g_object_ref0 (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (_tmp10_) ? ((SearchFilterToolbarSavedSearchPopoverDataButton*) _tmp10_) : NULL);
	_tmp12_ = _tmp11_;
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
	button = _tmp12_;
	_tmp13_ = search_filter_toolbar_saved_search_popover_data_button_get_search (button);
	_tmp14_ = _tmp13_;
	_tmp15_ = _g_object_ref0 (_tmp14_);
	result = _tmp15_;
	_g_object_unref0 (button);
	_g_object_unref0 (box);
	return result;
}

static void
search_filter_toolbar_saved_search_popover_on_activate_row (SearchFilterToolbarSavedSearchPopover* self,
                                                            GtkListBoxRow* row)
{
	GtkPopover* _tmp2_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	g_return_if_fail ((row == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ()));
	if (search_filter_toolbar_saved_search_popover_is_search_row (self, row)) {
		SavedSearch* _tmp0_;
		SavedSearch* _tmp1_;
		_tmp0_ = search_filter_toolbar_saved_search_popover_get_search (self, row);
		_tmp1_ = _tmp0_;
		g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL], 0, _tmp1_);
		_g_object_unref0 (_tmp1_);
	}
	_tmp2_ = self->priv->popover;
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
}

static void
search_filter_toolbar_saved_search_popover_on_edit_click (SearchFilterToolbarSavedSearchPopover* self,
                                                          SavedSearch* search)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	g_return_if_fail (IS_SAVED_SEARCH (search));
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL], 0, search);
}

static void
search_filter_toolbar_saved_search_popover_on_delete_click (SearchFilterToolbarSavedSearchPopover* self,
                                                            SavedSearch* search)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	g_return_if_fail (IS_SAVED_SEARCH (search));
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL], 0, search);
}

static void
search_filter_toolbar_saved_search_popover_on_add_click (SearchFilterToolbarSavedSearchPopover* self)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL], 0);
}

static void
search_filter_toolbar_saved_search_popover_on_popover_closed (SearchFilterToolbarSavedSearchPopover* self)
{
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL], 0);
}

void
search_filter_toolbar_saved_search_popover_show_all (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkPopover* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	_tmp0_ = self->priv->popover;
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
}

void
search_filter_toolbar_saved_search_popover_hide (SearchFilterToolbarSavedSearchPopover* self)
{
	GtkPopover* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_IS_SAVED_SEARCH_POPOVER (self));
	_tmp0_ = self->priv->popover;
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
}

static inline gpointer
search_filter_toolbar_saved_search_popover_data_button_get_instance_private (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	return G_STRUCT_MEMBER_P (self, SearchFilterToolbarSavedSearchPopoverDataButton_private_offset);
}

static void
_search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked (GtkButton* _sender,
                                                                                     gpointer self)
{
	search_filter_toolbar_saved_search_popover_data_button_on_click ((SearchFilterToolbarSavedSearchPopoverDataButton*) self);
}

static SearchFilterToolbarSavedSearchPopoverDataButton*
search_filter_toolbar_saved_search_popover_data_button_construct (GType object_type,
                                                                  SavedSearch* search,
                                                                  const gchar* name)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	g_return_val_if_fail (IS_SAVED_SEARCH (search), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (SearchFilterToolbarSavedSearchPopoverDataButton*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name (name, (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp0_;
	search_filter_toolbar_saved_search_popover_data_button_set_search (self, search);
	_tmp1_ = self->priv->button;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
	search_filter_toolbar_saved_search_popover_data_button_restyle (self);
	_tmp2_ = self->priv->button;
	g_signal_connect_object (_tmp2_, "clicked", (GCallback) _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked, self, 0);
	return self;
}

static SearchFilterToolbarSavedSearchPopoverDataButton*
search_filter_toolbar_saved_search_popover_data_button_new (SavedSearch* search,
                                                            const gchar* name)
{
	return search_filter_toolbar_saved_search_popover_data_button_construct (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, search, name);
}

static void
search_filter_toolbar_saved_search_popover_data_button_restyle (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
	_tmp0_ = self->priv->button;
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), 24, 24);
	_tmp1_ = self->priv->button;
	gtk_button_set_relief (_tmp1_, GTK_RELIEF_NONE);
}

static void
search_filter_toolbar_saved_search_popover_data_button_on_click (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	SavedSearch* _tmp0_;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
	_tmp0_ = self->priv->_search;
	g_signal_emit (self, search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL], 0, _tmp0_);
}

static SavedSearch*
search_filter_toolbar_saved_search_popover_data_button_get_search (SearchFilterToolbarSavedSearchPopoverDataButton* self)
{
	SavedSearch* result;
	SavedSearch* _tmp0_;
	g_return_val_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self), NULL);
	_tmp0_ = self->priv->_search;
	result = _tmp0_;
	return result;
}

static void
search_filter_toolbar_saved_search_popover_data_button_set_search (SearchFilterToolbarSavedSearchPopoverDataButton* self,
                                                                   SavedSearch* value)
{
	SavedSearch* old_value;
	g_return_if_fail (SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_IS_DATA_BUTTON (self));
	old_value = search_filter_toolbar_saved_search_popover_data_button_get_search (self);
	if (old_value != value) {
		SavedSearch* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_search);
		self->priv->_search = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY]);
	}
}

static void
search_filter_toolbar_saved_search_popover_data_button_class_init (SearchFilterToolbarSavedSearchPopoverDataButtonClass * klass,
                                                                   gpointer klass_data)
{
	search_filter_toolbar_saved_search_popover_data_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSavedSearchPopoverDataButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_search_filter_toolbar_saved_search_popover_data_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_search_filter_toolbar_saved_search_popover_data_button_set_property;
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_saved_search_popover_data_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY, search_filter_toolbar_saved_search_popover_data_button_properties[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY] = g_param_spec_object ("search", "search", "search", TYPE_SAVED_SEARCH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	search_filter_toolbar_saved_search_popover_data_button_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
}

static void
search_filter_toolbar_saved_search_popover_data_button_instance_init (SearchFilterToolbarSavedSearchPopoverDataButton * self,
                                                                      gpointer klass)
{
	self->priv = search_filter_toolbar_saved_search_popover_data_button_get_instance_private (self);
	self->priv->button = NULL;
}

static void
search_filter_toolbar_saved_search_popover_data_button_finalize (GObject * obj)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	GtkButton* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
	_tmp0_ = self->priv->button;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_data_button_on_click_gtk_button_clicked, self);
	_g_object_unref0 (self->priv->button);
	_g_object_unref0 (self->priv->_search);
	G_OBJECT_CLASS (search_filter_toolbar_saved_search_popover_data_button_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_saved_search_popover_data_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchPopoverDataButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_popover_data_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchPopoverDataButton), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_popover_data_button_instance_init, NULL };
	GType search_filter_toolbar_saved_search_popover_data_button_type_id;
	search_filter_toolbar_saved_search_popover_data_button_type_id = g_type_register_static (gtk_bin_get_type (), "SearchFilterToolbarSavedSearchPopoverDataButton", &g_define_type_info, 0);
	SearchFilterToolbarSavedSearchPopoverDataButton_private_offset = g_type_add_instance_private (search_filter_toolbar_saved_search_popover_data_button_type_id, sizeof (SearchFilterToolbarSavedSearchPopoverDataButtonPrivate));
	return search_filter_toolbar_saved_search_popover_data_button_type_id;
}

static GType
search_filter_toolbar_saved_search_popover_data_button_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_popover_data_button_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_popover_data_button_type_id__once)) {
		GType search_filter_toolbar_saved_search_popover_data_button_type_id;
		search_filter_toolbar_saved_search_popover_data_button_type_id = search_filter_toolbar_saved_search_popover_data_button_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_popover_data_button_type_id__once, search_filter_toolbar_saved_search_popover_data_button_type_id);
	}
	return search_filter_toolbar_saved_search_popover_data_button_type_id__once;
}

static void
_vala_search_filter_toolbar_saved_search_popover_data_button_get_property (GObject * object,
                                                                           guint property_id,
                                                                           GValue * value,
                                                                           GParamSpec * pspec)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
	switch (property_id) {
		case SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY:
		g_value_set_object (value, search_filter_toolbar_saved_search_popover_data_button_get_search (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_search_filter_toolbar_saved_search_popover_data_button_set_property (GObject * object,
                                                                           guint property_id,
                                                                           const GValue * value,
                                                                           GParamSpec * pspec)
{
	SearchFilterToolbarSavedSearchPopoverDataButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, SearchFilterToolbarSavedSearchPopoverDataButton);
	switch (property_id) {
		case SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DATA_BUTTON_SEARCH_PROPERTY:
		search_filter_toolbar_saved_search_popover_data_button_set_search (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
search_filter_toolbar_value_saved_search_popover_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
search_filter_toolbar_value_saved_search_popover_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		search_filter_toolbar_saved_search_popover_unref (value->data[0].v_pointer);
	}
}

static void
search_filter_toolbar_value_saved_search_popover_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = search_filter_toolbar_saved_search_popover_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
search_filter_toolbar_value_saved_search_popover_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
search_filter_toolbar_value_saved_search_popover_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		SearchFilterToolbarSavedSearchPopover * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = search_filter_toolbar_saved_search_popover_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
search_filter_toolbar_value_saved_search_popover_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	SearchFilterToolbarSavedSearchPopover ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = search_filter_toolbar_saved_search_popover_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
search_filter_toolbar_param_spec_saved_search_popover (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	SearchFilterToolbarParamSpecSavedSearchPopover* spec;
	g_return_val_if_fail (g_type_is_a (object_type, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
search_filter_toolbar_value_get_saved_search_popover (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER), NULL);
	return value->data[0].v_pointer;
}

void
search_filter_toolbar_value_set_saved_search_popover (GValue* value,
                                                      gpointer v_object)
{
	SearchFilterToolbarSavedSearchPopover * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		search_filter_toolbar_saved_search_popover_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		search_filter_toolbar_saved_search_popover_unref (old);
	}
}

void
search_filter_toolbar_value_take_saved_search_popover (GValue* value,
                                                       gpointer v_object)
{
	SearchFilterToolbarSavedSearchPopover * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		search_filter_toolbar_saved_search_popover_unref (old);
	}
}

static void
search_filter_toolbar_saved_search_popover_class_init (SearchFilterToolbarSavedSearchPopoverClass * klass,
                                                       gpointer klass_data)
{
	search_filter_toolbar_saved_search_popover_parent_class = g_type_class_peek_parent (klass);
	((SearchFilterToolbarSavedSearchPopoverClass *) klass)->finalize = search_filter_toolbar_saved_search_popover_finalize;
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbarSavedSearchPopover_private_offset);
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_SEARCH_ACTIVATED_SIGNAL] = g_signal_new ("search-activated", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_EDIT_CLICKED_SIGNAL] = g_signal_new ("edit-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_DELETE_CLICKED_SIGNAL] = g_signal_new ("delete-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_SAVED_SEARCH);
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_ADD_CLICKED_SIGNAL] = g_signal_new ("add-clicked", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	search_filter_toolbar_saved_search_popover_signals[SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_CLOSED_SIGNAL] = g_signal_new ("closed", SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
search_filter_toolbar_saved_search_popover_instance_init (SearchFilterToolbarSavedSearchPopover * self,
                                                          gpointer klass)
{
	self->priv = search_filter_toolbar_saved_search_popover_get_instance_private (self);
	self->priv->popover = NULL;
	self->priv->list_box = NULL;
	self->priv->edit_buttons = NULL;
	self->priv->edit_buttons_length1 = 0;
	self->priv->_edit_buttons_size_ = self->priv->edit_buttons_length1;
	self->priv->delete_buttons = NULL;
	self->priv->delete_buttons_length1 = 0;
	self->priv->_delete_buttons_size_ = self->priv->delete_buttons_length1;
	self->priv->add = NULL;
	self->ref_count = 1;
}

static void
search_filter_toolbar_saved_search_popover_finalize (SearchFilterToolbarSavedSearchPopover * obj)
{
	SearchFilterToolbarSavedSearchPopover * self;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp0_;
	gint _tmp0__length1;
	SearchFilterToolbarSavedSearchPopoverDataButton** _tmp4_;
	gint _tmp4__length1;
	GtkButton* _tmp8_;
	guint _tmp9_;
	GtkListBox* _tmp10_;
	guint _tmp11_;
	GtkPopover* _tmp12_;
	guint _tmp13_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEARCH_FILTER_TOOLBAR_TYPE_SAVED_SEARCH_POPOVER, SearchFilterToolbarSavedSearchPopover);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->edit_buttons;
	_tmp0__length1 = self->priv->edit_buttons_length1;
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
		button_collection = _tmp0_;
		button_collection_length1 = _tmp0__length1;
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp1_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
			_tmp1_ = _g_object_ref0 (button_collection[button_it]);
			button = _tmp1_;
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp2_;
				guint _tmp3_;
				_tmp2_ = button;
				g_signal_parse_name ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, &_tmp3_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_edit_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
				_g_object_unref0 (button);
			}
		}
	}
	_tmp4_ = self->priv->delete_buttons;
	_tmp4__length1 = self->priv->delete_buttons_length1;
	{
		SearchFilterToolbarSavedSearchPopoverDataButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
		button_collection = _tmp4_;
		button_collection_length1 = _tmp4__length1;
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
			SearchFilterToolbarSavedSearchPopoverDataButton* _tmp5_;
			SearchFilterToolbarSavedSearchPopoverDataButton* button = NULL;
			_tmp5_ = _g_object_ref0 (button_collection[button_it]);
			button = _tmp5_;
			{
				SearchFilterToolbarSavedSearchPopoverDataButton* _tmp6_;
				guint _tmp7_;
				_tmp6_ = button;
				g_signal_parse_name ("clicked", SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_TYPE_DATA_BUTTON, &_tmp7_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_delete_click_search_filter_toolbar_saved_search_popover_data_button_clicked, self);
				_g_object_unref0 (button);
			}
		}
	}
	_tmp8_ = self->priv->add;
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_add_click_gtk_button_clicked, self);
	_tmp10_ = self->priv->list_box;
	g_signal_parse_name ("row-activated", gtk_list_box_get_type (), &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_activate_row_gtk_list_box_row_activated, self);
	_tmp12_ = self->priv->popover;
	g_signal_parse_name ("closed", gtk_popover_get_type (), &_tmp13_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_saved_search_popover_on_popover_closed_gtk_popover_closed, self);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->list_box);
	self->priv->edit_buttons = (_vala_array_free (self->priv->edit_buttons, self->priv->edit_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->delete_buttons = (_vala_array_free (self->priv->delete_buttons, self->priv->delete_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->add);
}

static GType
search_filter_toolbar_saved_search_popover_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { search_filter_toolbar_value_saved_search_popover_init, search_filter_toolbar_value_saved_search_popover_free_value, search_filter_toolbar_value_saved_search_popover_copy_value, search_filter_toolbar_value_saved_search_popover_peek_pointer, "p", search_filter_toolbar_value_saved_search_popover_collect_value, "p", search_filter_toolbar_value_saved_search_popover_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarSavedSearchPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_saved_search_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbarSavedSearchPopover), 0, (GInstanceInitFunc) search_filter_toolbar_saved_search_popover_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType search_filter_toolbar_saved_search_popover_type_id;
	search_filter_toolbar_saved_search_popover_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SearchFilterToolbarSavedSearchPopover", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SearchFilterToolbarSavedSearchPopover_private_offset = g_type_add_instance_private (search_filter_toolbar_saved_search_popover_type_id, sizeof (SearchFilterToolbarSavedSearchPopoverPrivate));
	return search_filter_toolbar_saved_search_popover_type_id;
}

GType
search_filter_toolbar_saved_search_popover_get_type (void)
{
	static volatile gsize search_filter_toolbar_saved_search_popover_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_saved_search_popover_type_id__once)) {
		GType search_filter_toolbar_saved_search_popover_type_id;
		search_filter_toolbar_saved_search_popover_type_id = search_filter_toolbar_saved_search_popover_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_saved_search_popover_type_id__once, search_filter_toolbar_saved_search_popover_type_id);
	}
	return search_filter_toolbar_saved_search_popover_type_id__once;
}

gpointer
search_filter_toolbar_saved_search_popover_ref (gpointer instance)
{
	SearchFilterToolbarSavedSearchPopover * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
search_filter_toolbar_saved_search_popover_unref (gpointer instance)
{
	SearchFilterToolbarSavedSearchPopover * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SEARCH_FILTER_TOOLBAR_SAVED_SEARCH_POPOVER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
search_filter_toolbar_class_init (SearchFilterToolbarClass * klass,
                                  gpointer klass_data)
{
	search_filter_toolbar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SearchFilterToolbar_private_offset);
	G_OBJECT_CLASS (klass)->finalize = search_filter_toolbar_finalize;
}

static void
search_filter_toolbar_instance_init (SearchFilterToolbar * self,
                                     gpointer klass)
{
	GtkMenu* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkBuilder* _tmp2_;
	SearchFilterToolbarSavedSearchFilterButton* _tmp3_;
	self->priv = search_filter_toolbar_get_instance_private (self);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->close_menu = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->close_item = _tmp1_;
	_tmp2_ = gtk_builder_new ();
	self->builder = _tmp2_;
	self->priv->saved_search = NULL;
	_tmp3_ = search_filter_toolbar_saved_search_filter_button_new ();
	g_object_ref_sink (_tmp3_);
	self->priv->saved_search_button = _tmp3_;
	self->priv->elide_showing_again = FALSE;
	self->priv->search_filter = NULL;
}

static void
search_filter_toolbar_finalize (GObject * obj)
{
	SearchFilterToolbar * self;
	SearchFilterActions* _tmp0_;
	guint _tmp1_;
	SearchFilterActions* _tmp2_;
	guint _tmp3_;
	SearchFilterActions* _tmp4_;
	guint _tmp5_;
	SearchFilterActions* _tmp6_;
	guint _tmp7_;
	SearchFilterActions* _tmp8_;
	guint _tmp9_;
	SearchFilterActions* _tmp10_;
	guint _tmp11_;
	SearchFilterActions* _tmp12_;
	guint _tmp13_;
	SearchFilterActions* _tmp14_;
	guint _tmp15_;
	GtkToolbar* _tmp16_;
	guint _tmp17_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_FILTER_TOOLBAR, SearchFilterToolbar);
	_tmp0_ = self->priv->actions;
	g_signal_parse_name ("media-context-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _search_filter_toolbar_on_media_context_changed_search_filter_actions_media_context_changed, self);
	_tmp2_ = self->priv->actions;
	g_signal_parse_name ("flagged-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _search_filter_toolbar_on_flagged_toggled_search_filter_actions_flagged_toggled, self);
	_tmp4_ = self->priv->actions;
	g_signal_parse_name ("photos-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _search_filter_toolbar_on_photos_toggled_search_filter_actions_photos_toggled, self);
	_tmp6_ = self->priv->actions;
	g_signal_parse_name ("videos-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _search_filter_toolbar_on_videos_toggled_search_filter_actions_videos_toggled, self);
	_tmp8_ = self->priv->actions;
	g_signal_parse_name ("raw-toggled", TYPE_SEARCH_FILTER_ACTIONS, &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_filter_toolbar_on_raw_toggled_search_filter_actions_raw_toggled, self);
	_tmp10_ = self->priv->actions;
	g_signal_parse_name ("rating-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _search_filter_toolbar_on_rating_changed_search_filter_actions_rating_changed, self);
	_tmp12_ = self->priv->actions;
	g_signal_parse_name ("text-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp13_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _search_filter_toolbar_on_search_text_changed_search_filter_actions_text_changed, self);
	_tmp14_ = self->priv->actions;
	g_signal_parse_name ("criteria-changed", TYPE_SEARCH_FILTER_ACTIONS, &_tmp15_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _search_filter_toolbar_on_criteria_changed_search_filter_actions_criteria_changed, self);
	_tmp16_ = self->priv->toolbar;
	g_signal_parse_name ("popup-context-menu", gtk_toolbar_get_type (), &_tmp17_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _search_filter_toolbar_on_context_menu_requested_gtk_toolbar_popup_context_menu, self);
	_g_object_unref0 (self->priv->toolbar);
	_g_object_unref0 (self->priv->close_menu);
	_g_object_unref0 (self->priv->close_item);
	_g_object_unref0 (self->builder);
	_search_filter_actions_unref0 (self->priv->actions);
	_g_object_unref0 (self->priv->saved_search);
	_g_object_unref0 (self->priv->search_box);
	_g_object_unref0 (self->priv->rating_button);
	_g_object_unref0 (self->priv->saved_search_button);
	_view_filter_unref0 (self->priv->search_filter);
	_g_object_unref0 (self->priv->label_type);
	_g_object_unref0 (self->priv->toolbtn_photos);
	_g_object_unref0 (self->priv->toolbtn_videos);
	_g_object_unref0 (self->priv->toolbtn_raw);
	_g_object_unref0 (self->priv->toolbtn_flag);
	_g_object_unref0 (self->priv->sepr_mediatype_flagged);
	_g_object_unref0 (self->priv->sepr_flagged_rating);
	_g_object_unref0 (self->priv->sepr_rating_saved);
	G_OBJECT_CLASS (search_filter_toolbar_parent_class)->finalize (obj);
}

static GType
search_filter_toolbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SearchFilterToolbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_filter_toolbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchFilterToolbar), 0, (GInstanceInitFunc) search_filter_toolbar_instance_init, NULL };
	GType search_filter_toolbar_type_id;
	search_filter_toolbar_type_id = g_type_register_static (gtk_revealer_get_type (), "SearchFilterToolbar", &g_define_type_info, 0);
	SearchFilterToolbar_private_offset = g_type_add_instance_private (search_filter_toolbar_type_id, sizeof (SearchFilterToolbarPrivate));
	return search_filter_toolbar_type_id;
}

GType
search_filter_toolbar_get_type (void)
{
	static volatile gsize search_filter_toolbar_type_id__once = 0;
	if (g_once_init_enter (&search_filter_toolbar_type_id__once)) {
		GType search_filter_toolbar_type_id;
		search_filter_toolbar_type_id = search_filter_toolbar_get_type_once ();
		g_once_init_leave (&search_filter_toolbar_type_id__once, search_filter_toolbar_type_id);
	}
	return search_filter_toolbar_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

